GYRE
====

This is the GYRE oscillation code suite. GYRE is free software: you
can redistribute it and/or modify it under the terms of the GNU
General Public License as published by the Free Software Foundation,
version 3. See the file COPYING for further details.

Details on installing and using GYRE are available on the website:

http://www.astro.wisc.edu/~townsend/gyre/

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: gyre_constants gyre_model core_kinds ISO_FORTRAN_ENV core_order core_parallel gyre_cocache
!   provides: gyre_scons_model
!end dependencies
!
!end fpx3_header
! Module   : gyre_cons_model
! Purpose  : self-consistent model
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_scons_model

  ! Uses

  use core_kinds
  use core_parallel
  use core_order

  use gyre_constants
  use gyre_model
  use gyre_cocache

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type, extends(model_t) :: scons_model_t
     private
     real(WP), allocatable :: dt_x(:)
     real(WP), allocatable :: dt_V(:)
     real(WP), allocatable :: dt_U(:)
     real(WP), allocatable :: dt_c_1(:)
     real(WP), allocatable :: dt_Gamma_1(:)
     real(WP)              :: dt_Omega_rot
     real(WP), public      :: M_star
     real(WP), public      :: R_star
     real(WP), public      :: L_star
     real(WP)              :: p_c
     real(WP)              :: rho_c
   contains
     private

    procedure :: V_1_
    procedure :: V_v_

    procedure :: As_1_
    procedure :: As_v_

    procedure :: U_1_
    procedure :: U_v_

    procedure :: c_1_1_
    procedure :: c_1_v_

    procedure :: Gamma_1_1_
    procedure :: Gamma_1_v_

    procedure :: nabla_ad_1_
    procedure :: nabla_ad_v_

    procedure :: delta_1_
    procedure :: delta_v_

    procedure :: c_rad_1_
    procedure :: c_rad_v_

    procedure :: dc_rad_1_
    procedure :: dc_rad_v_

    procedure :: c_thm_1_
    procedure :: c_thm_v_

    procedure :: c_dif_1_
    procedure :: c_dif_v_

    procedure :: c_eps_ad_1_
    procedure :: c_eps_ad_v_

    procedure :: c_eps_S_1_
    procedure :: c_eps_S_v_

    procedure :: nabla_1_
    procedure :: nabla_v_

    procedure :: kappa_ad_1_
    procedure :: kappa_ad_v_

    procedure :: kappa_S_1_
    procedure :: kappa_S_v_

    procedure :: tau_thm_1_
    procedure :: tau_thm_v_

    procedure :: Omega_rot_1_
    procedure :: Omega_rot_v_

     procedure, public :: pi_c => pi_c_
     procedure, public :: is_zero => is_zero_
     procedure, public :: attach_cache => attach_cache_
     procedure, public :: detach_cache => detach_cache_
     procedure, public :: fill_cache => fill_cache_
  end type scons_model_t

  ! Interfaces

  interface scons_model_t
     module procedure scons_model_t_mech_coeffs_
     module procedure scons_model_t_mech_
  end interface scons_model_t

  ! Access specifiers

  private

  public :: scons_model_t

  ! Procedures

contains

  function scons_model_t_mech_coeffs_ (x, V, U, c_1, Gamma_1, Omega_rot) result (ml)

    real(WP), intent(in) :: x(:)
    real(WP), intent(in) :: V(:)
    real(WP), intent(in) :: U(:)
    real(WP), intent(in) :: c_1(:)
    real(WP), intent(in) :: Gamma_1(:)
    real(WP), intent(in) :: Omega_rot
    type(scons_model_t)    :: ml

    integer  :: n
    real(WP) :: B
    integer  :: i

  if(SIZE(V)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(V) :', SIZE(V)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(V)==SIZE(x) failed at line 126 <gyre_scons_model:scons_model_t_mech_coeffs_>'
    stop
  endif

  if(SIZE(U)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(U) :', SIZE(U)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(U)==SIZE(x) failed at line 127 <gyre_scons_model:scons_model_t_mech_coeffs_>'
    stop
  endif

  if(SIZE(Gamma_1)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Gamma_1) :', SIZE(Gamma_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Gamma_1)==SIZE(x) failed at line 128 <gyre_scons_model:scons_model_t_mech_' &
 & // 'coeffs_>'
    stop
  endif

    ! Construct the scons_model_t

    n = SIZE(x)

    ! Set up U

    allocate(ml%dt_U(n))

    ml%dt_U(1:2) = 3._WP
    ml%dt_U(3:) = U(3:)

    ! Set up c_1 (integration from outside in)

    allocate(ml%dt_c_1(n))

    ml%dt_c_1(n) = c_1(n)

    do i = n-1, 2, -1
       B = LOG(U(i)/U(i+1))/LOG(x(i)/x(i+1))
       ml%dt_c_1(i) = ml%dt_c_1(i+1)*EXP(-(U(i)-U(i+1))/B)*(x(i)/x(i+1))**3
    end do

    ml%dt_c_1(1) = ml%dt_c_1(2)

    ! Set up V and Gamma for linear interpolation

    ml%dt_V = V
    ml%dt_Gamma_1 = Gamma_1

    ! Store the abscissa

    ml%dt_x = x

    ! Finish

    return

  end function scons_model_t_mech_coeffs_

!****

  recursive function scons_model_t_mech_ (M_star, R_star, L_star, r, m, p, rho, T, N2, &
                                          Gamma_1, nabla_ad, delta, Omega_rot, &
                                          add_center) result (ml)

    real(WP), intent(in)          :: M_star
    real(WP), intent(in)          :: R_star
    real(WP), intent(in)          :: L_star
    real(WP), intent(in)          :: r(:)
    real(WP), intent(in)          :: m(:)
    real(WP), intent(in)          :: p(:)
    real(WP), intent(in)          :: rho(:)
    real(WP), intent(in)          :: T(:)
    real(WP), intent(in)          :: N2(:)
    real(WP), intent(in)          :: Gamma_1(:)
    real(WP), intent(in)          :: nabla_ad(:)
    real(WP), intent(in)          :: delta(:)
    real(WP), intent(in)          :: Omega_rot(:)
    logical, optional, intent(in) :: add_center
    type(scons_model_t)           :: ml

    logical  :: add_center_
    integer  :: n
    real(WP) :: V(SIZE(r))
    real(WP) :: U(SIZE(r))
    real(WP) :: c_1(SIZE(r))
    real(WP) :: x(SIZE(r))
    real(WP) :: Omega_rot_

  if(SIZE(m)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(m) :', SIZE(m)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(m)==SIZE(r) failed at line 199 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(p)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(p) :', SIZE(p)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(p)==SIZE(r) failed at line 200 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(rho)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(rho) :', SIZE(rho)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(rho)==SIZE(r) failed at line 201 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(T)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(T) :', SIZE(T)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(T)==SIZE(r) failed at line 202 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(N2)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(N2) :', SIZE(N2)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(N2)==SIZE(r) failed at line 203 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(Gamma_1)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Gamma_1) :', SIZE(Gamma_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Gamma_1)==SIZE(r) failed at line 204 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(nabla_ad)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(nabla_ad) :', SIZE(nabla_ad)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(nabla_ad)==SIZE(r) failed at line 205 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(delta)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(delta) :', SIZE(delta)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(delta)==SIZE(r) failed at line 206 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

  if(SIZE(Omega_rot)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Omega_rot) :', SIZE(Omega_rot)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Omega_rot)==SIZE(r) failed at line 207 <gyre_scons_model:scons_model_t_mech_>'
    stop
  endif

    if(PRESENT(add_center)) then
       add_center_ = add_center
    else
       add_center_ = .FALSE.
    endif

    ! Construct the evol_model_t using the mechanical structure data

    ! See if we need a central point

    if (add_center_) then

       ! Add a central point and initialize using recursion

       ml = scons_model_t(M_star, R_star, L_star, [0._WP,r], [0._WP,m], &
                          prep_center_(r, p), prep_center_(r, rho), prep_center_(r, T), &
                          [0._WP,N2], prep_center_(r, Gamma_1), prep_center_(r, nabla_ad), prep_center_(r, delta), &
                          prep_center_(r, Omega_rot), .FALSE.)

    else

       ! Perform basic validations

       n = SIZE(r)

    if(.NOT. (r(1) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''r(1) == 0._WP'' failed at line 234 <gyre_scons_model:scons_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'First grid point not at center'
      stop
    endif

    if(.NOT. (m(1) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''m(1) == 0._WP'' failed at line 235 <gyre_scons_model:scons_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'First grid point not at center'
      stop
    endif

    if(.NOT. (ALL(r(2:) > r(:n-1)))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(r(2:) > r(:n-1))'' failed at line 237 <gyre_scons_model:scons_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-monotonic radius data'
      stop
    endif

    if(.NOT. (ALL(m(2:) >= m(:n-1)))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(m(2:) >= m(:n-1))'' failed at line 238 <gyre_scons_model:scons_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-monotonic mass data'
      stop
    endif

       ! Calculate coefficients

       where(r /= 0._WP)
          V = G_GRAVITY*m*rho/(p*r)
          U = 4._WP*PI*rho*r**3/m
          c_1 = (r/R_star)**3/(m/M_star)
       elsewhere
          V = 0._WP
          U = 3._WP
          c_1 = 3._WP*(M_star/R_star**3)/(4._WP*PI*rho)
       end where

       x = r/R_star

       Omega_rot_ = SQRT(R_star**3/(G_GRAVITY*M_star))*Omega_rot(n)

       ! Initialize the model

       ml = scons_model_t(x, V, U, c_1, Gamma_1, Omega_rot_)

       ml%M_star = M_star
       ml%R_star = R_star
       ml%L_star = L_star

       ml%p_c = p(1)
       ml%rho_c = rho(1)

    endif

    ! Finish

    return

  end function scons_model_t_mech_

!****

  function prep_center_ (x, y) result (y_prep)

    real(WP), intent(in) :: x(:)
    real(WP), intent(in) :: y(:)
    real(WP)             :: y_prep(SIZE(y)+1)

    real(WP) :: y_0

  if(SIZE(x)/= SIZE(y)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(x)==SIZE(y) failed at line 285 <gyre_scons_model:prep_center_>'
    stop
  endif

    if(.NOT. (SIZE(y) >= 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(y) >= 2'' failed at line 287 <gyre_scons_model:prep_center_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Insufficient grid points'
      stop
    endif

    ! Use parabola fitting to interpolate y at the center

    y_0 = (x(2)**2*y(1) - x(1)**2*y(2))/(x(2)**2 - x(1)**2)

    ! Preprend this to the array

    y_prep = [y_0,y]

    ! Finish

    return

  end function prep_center_

!****

  function V_1_ (this, x) result (V)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: V

    integer  :: i
    real(WP) :: w

    ! Calculate V

    call locate(this%dt_x, x, i)

    if(.NOT. (i > 0 .AND. i < SIZE(this%dt_x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < SIZE(this%dt_x)'' failed at line 318 <gyre_scons_model:V_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

    w = (x - this%dt_x(i))/(this%dt_x(i+1) - this%dt_x(i))

    V = (1._WP-w)*this%dt_V(i) + w*this%dt_V(i+1)

    ! Finish

    return

  end function V_1_

!****

  function V_v_ (this, x) result (V)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: V(SIZE(x))

    integer :: i

    ! Calculate V

    x_loop : do i = 1,SIZE(x)
       V(i) = this%V(x(i))
    end do x_loop

    ! Finish

    return

  end function V_v_

!****

  function As_1_ (this, x) result (As)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: As

    integer  :: i
    real(WP) :: B

    ! Calculate As

    call locate(this%dt_x, x, i)

    if(.NOT. (i > 0 .AND. i < SIZE(this%dt_x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < SIZE(this%dt_x)'' failed at line 367 <gyre_scons_model:As_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

    if (i > 1) then
       B = LOG(this%dt_U(i)/this%dt_U(i+1))/LOG(this%dt_x(i)/this%dt_x(i+1))
    else
       B = 0._WP
    endif

    As = -this%V(x)/this%Gamma_1(x) - this%U(x) - B + 3._WP

    ! Finish

    return

  end function As_1_

!****

  function As_v_ (this, x) result (As)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: As(SIZE(x))

    integer :: i

    ! Calculate As

    x_loop : do i = 1,SIZE(x)
       As(i) = this%As(x(i))
    end do x_loop

    ! Finish

    return

  end function As_v_

!****

  function U_1_ (this, x) result (U)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: U

    integer  :: i
    real(WP) :: B

    ! Calculate U

    call locate(this%dt_x, x, i)

    if(.NOT. (i > 0 .AND. i < SIZE(this%dt_x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < SIZE(this%dt_x)'' failed at line 420 <gyre_scons_model:U_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

    if (i > 1) then
       B = LOG(this%dt_U(i)/this%dt_U(i+1))/LOG(this%dt_x(i)/this%dt_x(i+1))
       U = this%dt_U(i)*(x/this%dt_x(i))**B
    else
       U = 3._WP
    endif

    ! Finish

    return

  end function U_1_

!****

  function U_v_ (this, x) result (U)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: U(SIZE(x))

    integer :: i

    ! Calculate U

    x_loop : do i = 1,SIZE(x)
       U(i) = this%U(x(i))
    end do x_loop

    ! Finish

    return

  end function U_v_

!****

  function c_1_1_ (this, x) result (c_1)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: c_1

    integer  :: i
    real(WP) :: B

    ! Calculate c_1

    call locate(this%dt_x, x, i)

    if(.NOT. (i > 0 .AND. i < SIZE(this%dt_x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < SIZE(this%dt_x)'' failed at line 472 <gyre_scons_model:c_1_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

    if (i > 1) then
       B = LOG(this%dt_U(i)/this%dt_U(i+1))/LOG(this%dt_x(i)/this%dt_x(i+1))
       c_1 = this%dt_c_1(i)*EXP(-(this%U(x)-this%dt_U(i))/B)*(x/this%dt_x(i))**3
    else
       c_1 = this%dt_c_1(1)
    endif

    ! Finish

    return

  end function c_1_1_

!****

  function c_1_v_ (this, x) result (c_1)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: c_1(SIZE(x))

    integer :: i

    ! Calculate c_1

    x_loop : do i = 1,SIZE(x)
       c_1(i) = this%c_1(x(i))
    end do x_loop

    ! Finish

    return

  end function c_1_v_

!****

  function Gamma_1_1_ (this, x) result (Gamma_1)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: Gamma_1

    integer  :: i
    real(WP) :: w

    ! Calculate Gamma_1

    call locate(this%dt_x, x, i)

    if(.NOT. (i > 0 .AND. i < SIZE(this%dt_x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < SIZE(this%dt_x)'' failed at line 524 <gyre_scons_model:Gamma_1_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

    w = (x - this%dt_x(i))/(this%dt_x(i+1) - this%dt_x(i))

    Gamma_1 = (1._WP-w)*this%dt_Gamma_1(i) + w*this%dt_Gamma_1(i+1)

    ! Finish

    return

  end function Gamma_1_1_

!****

  function Gamma_1_v_ (this, x) result (Gamma_1)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: Gamma_1(SIZE(x))

    integer :: i

    ! Calculate Gamma_1

    x_loop : do i = 1,SIZE(x)
       Gamma_1(i) = this%Gamma_1(x(i))
    end do x_loop

    ! Finish

    return

  end function Gamma_1_v_

!****

  function nabla_ad_1_ (this, x) result (nabla_ad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: nabla_ad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 600 <gyre_scons_model:nabla_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function nabla_ad_1_

!****

  function nabla_ad_v_ (this, x) result (nabla_ad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: nabla_ad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 600 <gyre_scons_model:nabla_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function nabla_ad_v_

  function delta_1_ (this, x) result (delta)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: delta

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 601 <gyre_scons_model:delta_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'delta is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function delta_1_

!****

  function delta_v_ (this, x) result (delta)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: delta(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 601 <gyre_scons_model:delta_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'delta is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function delta_v_

  function c_rad_1_ (this, x) result (c_rad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: c_rad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 602 <gyre_scons_model:c_rad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_rad_1_

!****

  function c_rad_v_ (this, x) result (c_rad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: c_rad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 602 <gyre_scons_model:c_rad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_rad_v_

  function dc_rad_1_ (this, x) result (dc_rad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: dc_rad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 603 <gyre_scons_model:dc_rad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'dc_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function dc_rad_1_

!****

  function dc_rad_v_ (this, x) result (dc_rad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: dc_rad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 603 <gyre_scons_model:dc_rad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'dc_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function dc_rad_v_

  function c_thm_1_ (this, x) result (c_thm)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: c_thm

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 604 <gyre_scons_model:c_thm_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_thm_1_

!****

  function c_thm_v_ (this, x) result (c_thm)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: c_thm(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 604 <gyre_scons_model:c_thm_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_thm_v_

  function c_dif_1_ (this, x) result (c_dif)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: c_dif

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 605 <gyre_scons_model:c_dif_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_dif is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_dif_1_

!****

  function c_dif_v_ (this, x) result (c_dif)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: c_dif(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 605 <gyre_scons_model:c_dif_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_dif is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_dif_v_

  function c_eps_ad_1_ (this, x) result (c_eps_ad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: c_eps_ad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 606 <gyre_scons_model:c_eps_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_ad_1_

!****

  function c_eps_ad_v_ (this, x) result (c_eps_ad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: c_eps_ad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 606 <gyre_scons_model:c_eps_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_ad_v_

  function c_eps_S_1_ (this, x) result (c_eps_S)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: c_eps_S

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 607 <gyre_scons_model:c_eps_S_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_S_1_

!****

  function c_eps_S_v_ (this, x) result (c_eps_S)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: c_eps_S(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 607 <gyre_scons_model:c_eps_S_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_S_v_

  function nabla_1_ (this, x) result (nabla)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: nabla

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 608 <gyre_scons_model:nabla_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function nabla_1_

!****

  function nabla_v_ (this, x) result (nabla)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: nabla(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 608 <gyre_scons_model:nabla_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function nabla_v_

  function kappa_S_1_ (this, x) result (kappa_S)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: kappa_S

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 609 <gyre_scons_model:kappa_S_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_S_1_

!****

  function kappa_S_v_ (this, x) result (kappa_S)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: kappa_S(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 609 <gyre_scons_model:kappa_S_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_S_v_

  function kappa_ad_1_ (this, x) result (kappa_ad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: kappa_ad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 610 <gyre_scons_model:kappa_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_ad_1_

!****

  function kappa_ad_v_ (this, x) result (kappa_ad)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: kappa_ad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 610 <gyre_scons_model:kappa_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_ad_v_

  function tau_thm_1_ (this, x) result (tau_thm)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: tau_thm

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 611 <gyre_scons_model:tau_thm_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'tau_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function tau_thm_1_

!****

  function tau_thm_v_ (this, x) result (tau_thm)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: tau_thm(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 611 <gyre_scons_model:tau_thm_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'tau_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function tau_thm_v_

!****

  function Omega_rot_1_ (this, x) result (Omega_rot)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    real(WP)                       :: Omega_rot

    ! Calculate Omega_rot

    Omega_rot = this%dt_Omega_rot

    ! Finish

    return

  end function Omega_rot_1_

!****

  function Omega_rot_v_ (this, x) result (Omega_rot)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x(:)
    real(WP)                       :: Omega_rot(SIZE(x))

    integer :: i

    ! Calculate Omega_rot

    x_loop : do i = 1,SIZE(x)
       Omega_rot(i) = this%Omega_rot(x(i))
    end do x_loop

    ! Finish

    return

  end function Omega_rot_v_

!****

  function pi_c_ (this) result (pi_c)

    class(scons_model_t), intent(in) :: this
    real(WP)                       :: pi_c

    ! Calculate pi_c = V/x^2 as x -> 0

    pi_c = 2._WP

    ! Finish

    return

  end function pi_c_

!****

  function is_zero_ (this, x) result (is_zero)

    class(scons_model_t), intent(in) :: this
    real(WP), intent(in)           :: x
    logical                        :: is_zero

    ! Determine whether the point at x has a vanishing pressure and/or density

    is_zero = x >= 1._WP

    ! Finish

    return

  end function is_zero_

!****

  subroutine attach_cache_ (this, cc)

    class(scons_model_t), intent(inout)     :: this
    class(cocache_t), pointer, intent(in) :: cc

    ! Attach a coefficient cache (no-op, since we don't cache)

    ! Finish

    return

  end subroutine attach_cache_

!****

  subroutine detach_cache_ (this)

    class(scons_model_t), intent(inout) :: this

    ! Detach the coefficient cache (no-op, since we don't cache)

    ! Finish

    return

  end subroutine detach_cache_

!****

  subroutine fill_cache_ (this, x)

    class(scons_model_t), intent(inout) :: this
    real(WP), intent(in)              :: x(:)

    ! Fill the coefficient cache (no-op, since we don't cache)

    ! Finish

    return

  end subroutine fill_cache_

!****

end module gyre_scons_model

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_kinds
!   provides: core_linalg
!end dependencies
!
!end fpx3_header
! Module   : core_linalg
! Purpose  : interfaces to LAPACK and BLAS routines

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_linalg

  ! Uses

  use core_kinds

  ! No implicit typing

  implicit none

  ! Interfaces

  ! LAPACK

  interface XGTSV
     subroutine SGTSV (N, NRHS, DL, D, DU, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: NRHS, N, LDB
       integer, intent(out) :: INFO
       real(SP), intent(inout) :: DL(*), D(*), DU(*), B(LDB,*)
     end subroutine SGTSV
     subroutine DGTSV (N, NRHS, DL, D, DU, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: NRHS, N, LDB
       integer, intent(out) :: INFO
       real(DP), intent(inout) :: DL(*), D(*), DU(*), B(LDB,*)
     end subroutine DGTSV
     subroutine CGTSV (N, NRHS, DL, D, DU, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: NRHS, N, LDB
       integer, intent(out) :: INFO
       complex(SP), intent(inout) :: DL(*), D(*), DU(*), B(LDB,*)
     end subroutine CGTSV
     subroutine ZGTSV (N, NRHS, DL, D, DU, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: NRHS, N, LDB
       integer, intent(out) :: INFO
       complex(DP), intent(inout) :: DL(*), D(*), DU(*), B(LDB,*)
     end subroutine ZGTSV
  end interface XGTSV

  interface XGETRF
     subroutine SGETRF (M, N, A, LDA, PIV, INFO)
       use core_kinds
       integer, intent(in) :: LDA, M, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV( * )
       real(SP), intent(inout) :: A( LDA, * )
     end subroutine SGETRF
     subroutine DGETRF (M, N, A, LDA, PIV, INFO)
       use core_kinds
       integer, intent(in) :: LDA, M, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV( * )
       real(DP), intent(inout) :: A( LDA, * )
     end subroutine DGETRF
     subroutine CGETRF (M, N, A, LDA, PIV, INFO)
       use core_kinds
       integer, intent(in) :: LDA, M, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV( * )
       complex(SP), intent(inout) :: A( LDA, * )
     end subroutine CGETRF
     subroutine ZGETRF (M, N, A, LDA, PIV, INFO)
       use core_kinds
       integer, intent(in) :: LDA, M, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV( * )
       complex(DP), intent(inout) :: A( LDA, * )
     end subroutine ZGETRF
  end interface XGETRF

  interface XGESV
     subroutine SGESV (N, NRHS, A, LDA, PIV, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: LDA, LDB, NRHS, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV(*)
       real(SP), intent(inout) :: A(LDA,*), B(LDB,*)
     end subroutine SGESV
     subroutine DGESV (N, NRHS, A, LDA, PIV, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: LDA, LDB, NRHS, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV(*)
       real(DP), intent(inout) :: A(LDA,*), B(LDB,*)
     end subroutine DGESV
     subroutine CGESV (N, NRHS, A, LDA, PIV, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: LDA, LDB, NRHS, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV(*)
       complex(SP), intent(inout) :: A(LDA,*), B(LDB,*)
     end subroutine CGESV
     subroutine ZGESV (N, NRHS, A, LDA, PIV, B, LDB, INFO)
       use core_kinds
       integer, intent(in) :: LDA, LDB, NRHS, N
       integer, intent(out) :: INFO
       integer, intent(out) :: PIV(*)
       complex(DP), intent(inout) :: A(LDA,*), B(LDB,*)
     end subroutine ZGESV
  end interface XGESV

  interface XGEEV
     subroutine SGEEV (JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR, LDVR, WORK, LWORK, INFO)
       use core_kinds
       character(1), intent(in) :: JOBVL, JOBVR
       integer, intent(in) :: N, LDA, LDVL, LDVR, LWORK
       integer, intent(out) :: INFO
       real(SP), intent(inout) :: A(LDA,*)
       real(SP), intent(out) :: VL(LDVL,*), VR(LDVR,*), WR(*), WI(*), WORK(*)
     end subroutine SGEEV
     subroutine DGEEV (JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR, LDVR, WORK, LWORK, INFO)
       use core_kinds
       character(1), intent(in) :: JOBVL, JOBVR
       integer, intent(in) :: N, LDA, LDVL, LDVR, LWORK
       integer, intent(out) :: INFO
       real(DP), intent(inout) :: A(LDA,*)
       real(DP), intent(out) :: VL(LDVL,*), VR(LDVR,*), WR(*), WI(*), WORK(*)
     end subroutine DGEEV
     subroutine CGEEV (JOBVL, JOBVR, N, A, LDA, W, VL, LDVL, VR, LDVR, WORK, LWORK, RWORK, INFO )
       use core_kinds
       character(1), intent(in) :: JOBVL, JOBVR
       integer, intent(in) :: N, LDA, LDVL, LDVR, LWORK
       integer, intent(out) :: INFO
       real(SP), intent(out) :: RWORK(*)
       complex(SP), intent(inout) :: A(LDA,*)
       complex(SP), intent(out) :: VL(LDVL,*), VR(LDVR,*), W(*), WORK(*)
     end subroutine CGEEV
     subroutine ZGEEV (JOBVL, JOBVR, N, A, LDA, W, VL, LDVL, VR, LDVR, WORK, LWORK, RWORK, INFO)
       use core_kinds
       character(1), intent(in) :: JOBVL, JOBVR
       integer, intent(in) :: N, LDA, LDVL, LDVR, LWORK
       integer, intent(out) :: INFO
       real(DP), intent(out) :: RWORK(*)
       complex(DP), intent(inout) :: A(LDA,*)
       complex(DP), intent(out) :: VL(LDVL,*), VR(LDVR,*), W(*), WORK(*)
     end subroutine ZGEEV
  end interface XGEEV

  interface XSTEVR
     subroutine SSTEVR (JOBZ, RANGE, N, D, E, VL, VU, IL, IU, ABSTOL, &
                        M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK,     &
                        LIWORK, INFO)
       use core_kinds
       CHARACTER(1), INTENT(IN) :: JOBZ, RANGE
       integer, intent(in) :: N, IL, IU, LDZ,  LWORK, LIWORK
       integer, intent(out) :: M
       integer, intent(out), target :: ISUPPZ(*)
       real(SP), intent(in) :: ABSTOL, VL, VU
       integer, intent(out) ::  IWORK(*)
       integer, intent(out) :: INFO
       real(SP), intent(inout) :: D(*), E(*)
       real(SP), intent(out) :: WORK(*), W(*)
       real(SP), intent(out), target :: Z(LDZ,*)
     end subroutine SSTEVR
     subroutine DSTEVR (JOBZ, RANGE, N, D, E, VL, VU, IL, IU, ABSTOL, &
                        M, W, Z, LDZ, ISUPPZ, WORK, LWORK, IWORK,     &
                        LIWORK, INFO)
       use core_kinds
       character(1), INTENT(IN) :: JOBZ, RANGE
       integer, intent(in) :: N, IL, IU, LDZ,  LWORK, LIWORK
       integer, intent(out) :: M
       integer, intent(out), target :: ISUPPZ(*)
       real(DP), intent(in) :: ABSTOL, VL, VU
       integer, intent(out) ::  IWORK(*)
       integer, intent(out) :: INFO
       real(DP), intent(inout) :: D(*), E(*)
       real(DP), intent(out) :: WORK(*), W(*)
       real(DP), intent(out), target :: Z(LDZ,*)
     end subroutine DSTEVR
  end interface XSTEVR

  interface XLAMCH
     module procedure xlamch_r_sp_
     module procedure xlamch_r_dp_
  end interface XLAMCH

  ! Access specifiers

  private

  public :: XGTSV
  public :: XGETRF
  public :: XGESV
  public :: XGEEV
  public :: XSTEVR
  public :: XLAMCH

contains

  function xlamch_r_sp_ (x, cmach)

    real(SP), intent(in)        :: x
    character(*), intent(in) :: cmach
    real(SP)                    :: xlamch_r_sp_

    real(SP), external :: SLAMCH

    xlamch_r_sp_ = SLAMCH(cmach)

  end function xlamch_r_sp_

  function xlamch_r_dp_ (x, cmach)

    real(DP), intent(in)        :: x
    character(*), intent(in) :: cmach
    real(DP)                    :: xlamch_r_dp_

    real(DP), external :: DLAMCH

    xlamch_r_dp_ = DLAMCH(cmach)

  end function xlamch_r_dp_

end module core_linalg

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: gyre_constants gyre_grid ISO_FORTRAN_ENV core_hgroup core_kinds
!   provides: 
!end dependencies
!
!end fpx3_header
! Program  : build_poly_hom
! Purpose  : build homogeneous polytrope
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

program build_poly_hom

  ! Uses

  use core_kinds
  use gyre_constants
  use core_hgroup

  use gyre_grid

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Variables

  real(WP)                    :: Gamma_1
  real(WP)                    :: Omega_rot
  character(LEN=256)          :: grid_type
  real(WP)                    :: s
  integer                     :: n
  character(LEN=FILENAME_LEN) :: file
  real(WP), allocatable       :: x(:)
  real(WP), allocatable       :: xi(:)
  real(WP), allocatable       :: Theta(:)
  real(WP), allocatable       :: dTheta(:)
  type(hgroup_t)              :: hg

  namelist /poly/ Gamma_1, Omega_rot
  namelist /grid/ grid_type, s, n
  namelist /output/ file

  ! Read parameters

  Gamma_1 = 5._WP/3._WP
  Omega_rot = 0._WP

  read(INPUT_UNIT, NML=poly)

  grid_type = 'GEOM'

  s = 100._WP
  n = 100

  read(INPUT_UNIT, NML=grid)

  read(INPUT_UNIT, NML=output)

  ! Set up the grid

  select case (grid_type)
  case ('UNIFORM')
     call create_uniform(n, x)
  case ('GEOM')
     call create_geom(s, n, x)
  case ('LOG')
     call create_log(s, n, x)
  case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 80 <build_poly_hom>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid grid_type'

  stop 'Program aborted'

  end select

  ! Calculate structure variables

  allocate(xi(n))

  allocate(Theta(n))
  allocate(dTheta(n))

  xi = SQRT(6._WP)*x

  Theta = 1._WP - xi**2/6._WP
  dTheta = -xi/3._WP

  ! Write the model

  hg = hgroup_t(file, CREATE_FILE)

  call write_attr(hg, 'n', n)

  call write_attr(hg, 'n_poly', 0._WP)
  call write_attr(hg, 'Gamma_1', Gamma_1)

  call write_dset(hg, 'xi', xi)
  call write_dset(hg, 'Theta', Theta)
  call write_dset(hg, 'dTheta', dTheta)
  call write_dset(hg, 'Omega_rot', SPREAD(Omega_rot, DIM=1, NCOPIES=n))

  call hg%final()

  ! Finish

end program build_poly_hom

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_hgroup gyre_trad_func core_kinds ISO_FORTRAN_ENV
!   provides: gyre_trad_table
!end dependencies
!
!end fpx3_header
! Program  : gyre_trad_table
! Purpose  : tables of trad_func_t types
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_trad_table

  ! Uses

  use core_kinds

  use core_hgroup

  use gyre_trad_func

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: trad_table_t
     type(trad_func_t), allocatable :: tf(:,:)
     integer                        :: l_max
  end type trad_table_t

  ! Interfaces

  interface trad_table_t
     module procedure trad_table_t_
  end interface trad_table_t

  interface read
     module procedure read_
  end interface read
  interface write
     module procedure write_
  end interface write

  ! Access specifiers

  private

  public :: trad_table_t

  public :: read
  public :: write

  ! Procedures

contains

  function trad_table_t_ (l_max) result (tt)

    integer, intent(in) :: l_max 
    type(trad_table_t)  :: tt

    ! Construct the trad_table_t

    allocate(tt%tf(0:l_max,-l_max:l_max))

    tt%l_max = l_max

    ! Finish

    return

  end function trad_table_t_

!****

  subroutine read_ (hg, tt)

    type(hgroup_t), intent(inout)   :: hg
    type(trad_table_t), intent(out) :: tt

    integer        :: l_max
    integer        :: l
    integer        :: m
    type(hgroup_t) :: hg_comp

    ! Read the trad_table_t

    call read_attr(hg, 'l_max', l_max)

    tt = trad_table_t(l_max)

    do l = 0, l_max
       do m = -l, l
          hg_comp = hgroup_t(hg, elem_group_name('tf', [l,m]))
          call read(hg_comp, tt%tf(l,m))
          call hg_comp%final()
       end do
    end do

    ! Finish

    return

  end subroutine read_

!****

  subroutine write_ (hg, tt)

    type(hgroup_t), intent(inout)  :: hg
    type(trad_table_t), intent(in) :: tt

    integer        :: l
    integer        :: m
    type(hgroup_t) :: hg_comp

    ! Write the trad_table_t

    call write_attr(hg, 'l_max', tt%l_max)

    do l = 0, tt%l_max
       do m = -l, l
          hg_comp = hgroup_t(hg, elem_group_name('tf', [l,m]))
          call write(hg_comp, tt%tf(l,m))
          call hg_comp%final()
       end do
    end do

    ! Finish

    return

  end subroutine write_

!****

end module gyre_trad_table

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: gyre_rot gyre_oscpar gyre_null_rot gyre_trad_rot gyre_modepar ISO_FORTRAN_ENV gyre_dopp_rot core_kinds gyre_model
!   provides: gyre_rot_factory
!end dependencies
!
!end fpx3_header
! Incfile  : gyre_rot_factory
! Purpose  : factory procedures for r_rot_t and c_rot_t types
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_rot_factory

  ! Uses

  use core_kinds

  use gyre_model
  use gyre_modepar
  use gyre_oscpar
  use gyre_rot

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Interfaces

  interface r_rot_t
     module procedure r_rot_t_
  end interface r_rot_t

  interface c_rot_t
     module procedure c_rot_t_
  end interface c_rot_t

  ! Access specifiers

  private

  public :: r_rot_t
  public :: c_rot_t

  ! Procedures

contains

  function r_rot_t_ (ml, mp, op) result (rt)

    use gyre_dopp_rot
    use gyre_null_rot
    use gyre_trad_rot

    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    class(r_rot_t), allocatable      :: rt

    ! Create a ${T}_rot_t

    select case (op%rotation_method)
    case ('DOPPLER')
       allocate(rt, SOURCE=r_dopp_rot_t(ml, mp))
    case ('NULL')
       allocate(rt, SOURCE=r_null_rot_t(mp))
    case ('TRAD')
       allocate(rt, SOURCE=r_trad_rot_t(ml, mp))
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 94 <gyre_rot_factory:r_rot_t_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid rotation_method'

  stop 'Program aborted'

    end select

    ! Finish

    return

  end function r_rot_t_

  function c_rot_t_ (ml, mp, op) result (rt)

    use gyre_dopp_rot
    use gyre_null_rot
    use gyre_trad_rot

    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    class(c_rot_t), allocatable      :: rt

    ! Create a ${T}_rot_t

    select case (op%rotation_method)
    case ('DOPPLER')
       allocate(rt, SOURCE=c_dopp_rot_t(ml, mp))
    case ('NULL')
       allocate(rt, SOURCE=c_null_rot_t(mp))
    case ('TRAD')
       allocate(rt, SOURCE=c_trad_rot_t(ml, mp))
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 95 <gyre_rot_factory:c_rot_t_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid rotation_method'

  stop 'Program aborted'

    end select

    ! Finish

    return

  end function c_rot_t_

end module gyre_rot_factory

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc ../rot/gyre_trad_rot.inc
!   uses: gyre_rot gyre_trad gyre_model core_kinds ISO_FORTRAN_ENV gyre_modepar
!   provides: gyre_r_trad_rot
!end dependencies
!
!end fpx3_header
! Module   : gyre_r_trad_rot
! Purpose  : rotational effects (traditional approximation, real)
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : gyre_trad_rot
! Purpose  : rotational effects (traditional approximation, template)
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_r_trad_rot

  ! Uses

  use core_kinds

  use gyre_model
  use gyre_modepar
  use gyre_trad
  use gyre_rot

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type, extends (r_rot_t) :: r_trad_rot_t
     private
     class(model_t), pointer :: ml => null()
   contains
     private
     procedure, public :: omega => omega_
     procedure         :: omega_c_1_
     procedure         :: omega_c_v_
     procedure         :: lambda_1_
     procedure         :: lambda_v_
  end type r_trad_rot_t

  ! Interfaces

  interface r_trad_rot_t
     module procedure r_trad_rot_t_
  end interface r_trad_rot_t

  ! Access specifiers

  private

  public :: r_trad_rot_t

  ! Procedures

contains

  function r_trad_rot_t_ (ml, mp) result (rt)

    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(r_trad_rot_t)               :: rt

    ! Construct the trad_rot_t

    rt%ml => ml
    rt%mp = mp

    ! Finish

    return

  end function r_trad_rot_t_

!****

  function omega_ (this, x, omega_c) result (omega)

    class(r_trad_rot_t), intent(in) :: this
    real(WP), intent(in)               :: x
    real(WP), intent(in)              :: omega_c
    real(WP)                          :: omega

    ! Evaluate the inertial-frame frequency from the corotating-frame
    ! frequency

    omega = omega_c + this%mp%m*this%ml%Omega_rot(x)

    ! Finish

    return

  end function omega_

!****

  function omega_c_1_ (this, x, omega) result (omega_c)

    class(r_trad_rot_t), intent(in) :: this
    real(WP), intent(in)               :: x
    real(WP), intent(in)              :: omega
    real(WP)                          :: omega_c

    ! Evaluate the corotating-frame frequency from the inertial-frame
    ! frequency (scalar)

    omega_c = omega - this%mp%m*this%ml%Omega_rot(x)

    ! Finish

    return

  end function omega_c_1_

!****

  function omega_c_v_ (this, x, omega) result (omega_c)

    class(r_trad_rot_t), intent(in) :: this
    real(WP), intent(in)               :: x(:)
    real(WP), intent(in)              :: omega
    real(WP)                          :: omega_c(SIZE(x))

    ! Evaluate the corotating-frame frequency from the inertial-frame
    ! frequency (vector)

    omega_c = omega - this%mp%m*this%ml%Omega_rot(x)

    ! Finish

    return

  end function omega_c_v_

!****

  function lambda_1_ (this, x, omega) result (lambda)

    class(r_trad_rot_t), intent(in) :: this
    real(WP), intent(in)               :: x
    real(WP), intent(in)              :: omega
    real(WP)                          :: lambda

    real(WP) :: nu

    ! Evaluate the angular eigenvalue (scalar)

    nu = 2._WP*this%ml%Omega_rot(x)/this%omega_c(x, omega)

    lambda = trad_lambda(nu, this%mp%l, this%mp%m)

    ! Finish

    return

  end function lambda_1_

!****

  function lambda_v_ (this, x, omega) result (lambda)

    class(r_trad_rot_t), intent(in) :: this
    real(WP), intent(in)               :: x(:)
    real(WP), intent(in)              :: omega
    real(WP)                          :: lambda(SIZE(x))

    integer :: i

    ! Evaluate the angular eigenvalue (vector)

    do i = 1, SIZE(x)
       lambda(i) = this%lambda(x(i), omega)
    end do

    ! Finish

    return

  end function lambda_v_

end module gyre_r_trad_rot

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: 
!   uses: 
!   provides: core_kinds
!end dependencies
!
!end fpx3_header
! Module   : core_kinds
! Purpose  : kind types

module core_kinds

  ! No implicit typing

  implicit none

  ! Parameter definitions

  integer, parameter :: I4 = SELECTED_INT_KIND(9)
  integer, parameter :: I8 = SELECTED_INT_KIND(14)

  integer, parameter :: SP = KIND(0.)
  integer, parameter :: DP = KIND(0.D0)

  integer, parameter :: WP = DP

  ! Acess specifiers

  private

  public :: I4
  public :: I8
  public :: SP
  public :: DP
  public :: WP

end module core_kinds

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_memory core_hgroup core_kinds core_constants
!   provides: gyre_cheby
!end dependencies
!
!end fpx3_header
! Incfile  : gyre_cheby
! Purpose  : Chebyshev fitting functions
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_cheby

  ! Uses

  use core_kinds
  use core_constants

  use core_hgroup

  use core_memory

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: cheby_t
     private
     real(WP), allocatable :: c(:)
     real(WP)              :: x_a
     real(WP)              :: x_b
     integer               :: n
   contains 
     private
     procedure, public :: truncate => truncate_
     procedure         :: eval_r_
     procedure         :: eval_c_
     generic, public   :: eval => eval_r_, eval_c_
  end type cheby_t

  ! Interfaces

  interface cheby_t
     module procedure cheby_t_coeff_
     module procedure cheby_t_func_
  end interface cheby_t

  interface read
     module procedure read_
  end interface read
  interface write
     module procedure write_
  end interface write

  ! Access specifiers

  private

  public :: cheby_t

  public :: read
  public :: write

  ! Procedures

contains

  function cheby_t_coeff_ (x_a, x_b, c) result (cb)

    real(WP), intent(in) :: x_a
    real(WP), intent(in) :: x_b
    real(WP), intent(in) :: c(:)
    type(cheby_t)        :: cb

    ! Construct the cheby_t using the coefficients

    cb%c = c

    cb%x_a = x_a
    cb%x_b = x_b

    cb%n = SIZE(c)

    ! Finish

    return

  end function cheby_t_coeff_

!****

  function cheby_t_func_ (x_a, x_b, n, func) result (cb)

    real(WP), intent(in) :: x_a
    real(WP), intent(in) :: x_b
    integer, intent(in)  :: n
    interface
       function func (x)
         use core_kinds
         real(WP), intent(in) :: x
         real(WP)             :: func
       end function func
    end interface
    type(cheby_t)        :: cb

    real(WP) :: b_m
    real(WP) :: b_p
    integer  :: j
    integer  :: k
    real(WP) :: y
    real(WP) :: f(n)
    real(WP) :: fac
    real(DP) :: sum

    ! Construct the cheby_t, with n terms, from the function func
    ! defined on the domain [x_a,x_b]

    ! Set up the coefficients

    allocate(cb%c(n))

    b_m = 0.5_WP*(x_b - x_a)
    b_p = 0.5_WP*(x_b + x_a)

    do k = 1, n
       y = COS(PI*(k-0.5_DP)/n)
       f(k) = func(y*b_m + b_p)
    end do

    fac = 2._WP/n

    do j = 1, n
       sum = 0._DP
       do k = 1, n
          sum = sum + f(k)*COS((PI*(j-1))*((k-0.5_DP)/n))
       end do
       cb%c(j) = fac*sum
    end do

    cb%x_a = x_a
    cb%x_b = x_b

    cb%n = n

    ! Finish

    return

  end function cheby_t_func_

!****

  subroutine read_ (hg, cb)

    type(hgroup_t), intent(inout) :: hg
    type(cheby_t), intent(out)    :: cb

    real(WP)              :: x_a
    real(WP)              :: x_b
    real(WP), allocatable :: c(:)

    ! Read the cheby_t

    call read_attr(hg, 'x_a', x_a)
    call read_attr(hg, 'x_b', x_b)

    call read_dset_alloc(hg, 'c', c)

    cb = cheby_t(x_a, x_b, c)

    ! Finish

    return

  end subroutine read_

!****

  subroutine write_ (hg, cb)

    type(hgroup_t), intent(inout) :: hg
    type(cheby_t), intent(in)     :: cb

    ! Write the cheby_t

    call write_attr(hg, 'x_a', cb%x_a)
    call write_attr(hg, 'x_b', cb%x_b)

    call write_dset(hg, 'c', cb%c)

    ! Finish

    return

  end subroutine write_

!****

  subroutine truncate_ (this, tol)

    class(cheby_t), intent(inout) :: this
    real(WP), intent(in)          :: tol

    real(WP) :: c_max
    integer  :: j

    ! Truncate the Chebyshev series to relative tolerance tol (i.e.,
    ! assuming that the discarded terms are all smaller than tol times
    ! the maximum term)

    c_max = MAXVAL(ABS(this%c))

    do j = 1, this%n
       if (ALL(ABS(this%c(j:)) < tol*c_max)) exit
    end do

    if (j <= this%n) then
       this%n = j - 1
       call reallocate(this%c, [this%n])
    end if

    ! Finish

    return

  end subroutine truncate_

!****

  function eval_r_ (this, x) result (f)

    class(cheby_t), intent(in) :: this
    real(WP), intent(in)      :: x
    real(WP)                  :: f

    real(WP) :: d
    real(WP) :: dd
    real(WP) :: y
    real(WP) :: y2
    integer  :: j
    real(WP) :: sv

    ! Evaluate the polynomial at x

    d = 0._WP
    dd = 0._WP

    y = (2._WP*x - this%x_a - this%x_b)/(this%x_b - this%x_a)
    y2 = 2._WP*y

    do j = this%n, 2, -1
       sv = d
       d = y2*d - dd + this%c(j)
       dd = sv
    end do

    f = y*d - dd + 0.5*this%c(1)

    ! Finish

    return

  end function eval_r_

!****

  function eval_c_ (this, z) result (f)

    class(cheby_t), intent(in) :: this
    complex(WP), intent(in)    :: z
    complex(WP)                :: f

    complex(WP) :: d
    complex(WP) :: dd
    complex(WP) :: y
    complex(WP) :: y2
    integer     :: j
    complex(WP) :: sv

    ! Evaluate the polynomial at x

    d = 0._WP
    dd = 0._WP

    y = (2._WP*z - this%x_a - this%x_b)/(this%x_b - this%x_a)
    y2 = 2._WP*y

    do j = this%n, 2, -1
       sv = d
       d = y2*d - dd + this%c(j)
       dd = sv
    end do

    f = y*d - dd + 0.5*this%c(1)

    ! Finish

    return

  end function eval_c_

end module gyre_cheby

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_spline gyre_cocache core_kinds gyre_model core_parallel ISO_FORTRAN_ENV
!   provides: gyre_poly_model
!end dependencies
!
!end fpx3_header
! Module   : gyre_poly_model
! Purpose  : stellar polytropic model
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_poly_model

  ! Uses

  use core_kinds
  use core_parallel
  use core_spline

  use gyre_model
  use gyre_cocache

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type, extends(model_t) :: poly_model_t
     private
     type(spline_t)   :: sp_Theta
     type(spline_t)   :: sp_dTheta
     type(spline_t)   :: sp_Omega_rot
     real(WP)         :: dt_Gamma_1
     real(WP), public :: n_poly
     real(WP), public :: xi_1
   contains
     private

    procedure :: V_1_
    procedure :: V_v_

    procedure :: As_1_
    procedure :: As_v_

    procedure :: U_1_
    procedure :: U_v_

    procedure :: c_1_1_
    procedure :: c_1_v_

    procedure :: Gamma_1_1_
    procedure :: Gamma_1_v_

    procedure :: nabla_ad_1_
    procedure :: nabla_ad_v_

    procedure :: delta_1_
    procedure :: delta_v_

    procedure :: c_rad_1_
    procedure :: c_rad_v_

    procedure :: dc_rad_1_
    procedure :: dc_rad_v_

    procedure :: c_thm_1_
    procedure :: c_thm_v_

    procedure :: c_dif_1_
    procedure :: c_dif_v_

    procedure :: c_eps_ad_1_
    procedure :: c_eps_ad_v_

    procedure :: c_eps_S_1_
    procedure :: c_eps_S_v_

    procedure :: nabla_1_
    procedure :: nabla_v_

    procedure :: kappa_ad_1_
    procedure :: kappa_ad_v_

    procedure :: kappa_S_1_
    procedure :: kappa_S_v_

    procedure :: tau_thm_1_
    procedure :: tau_thm_v_

    procedure :: Omega_rot_1_
    procedure :: Omega_rot_v_

     procedure, public :: pi_c => pi_c_
     procedure, public :: is_zero => is_zero_
     procedure, public :: attach_cache => attach_cache_
     procedure, public :: detach_cache => detach_cache_
     procedure, public :: fill_cache => fill_cache_
  end type poly_model_t

  ! Interfaces

  interface poly_model_t
     module procedure poly_model_t_
  end interface poly_model_t

  ! Access specifiers

  private

  public :: poly_model_t

  ! Procedures

contains

  function poly_model_t_ (xi, Theta, dTheta, Omega_rot, n_poly, Gamma_1, deriv_type) result (ml)

    real(WP), intent(in)         :: xi(:)
    real(WP), intent(in)         :: Theta(:)
    real(WP), intent(in)         :: dTheta(:)
    real(WP), intent(in)         :: Omega_rot(:)
    real(WP), intent(in)         :: n_poly
    real(WP), intent(in)         :: Gamma_1
    character(LEN=*), intent(in) :: deriv_type
    type(poly_model_t)           :: ml

    integer  :: n
    real(WP) :: d2Theta(SIZE(xi))

  if(SIZE(Theta)/= SIZE(xi)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Theta) :', SIZE(Theta)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(xi) :', SIZE(xi)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Theta)==SIZE(xi) failed at line 119 <gyre_poly_model:poly_model_t_>'
    stop
  endif

  if(SIZE(Omega_rot)/= SIZE(xi)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Omega_rot) :', SIZE(Omega_rot)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(xi) :', SIZE(xi)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Omega_rot)==SIZE(xi) failed at line 120 <gyre_poly_model:poly_model_t_>'
    stop
  endif

    ! Construct the poly_model_t from the polytrope functions

    n = SIZE(xi)

    if(n_poly /= 0._WP) then

       where (xi /= 0._WP)
          d2Theta = -2._WP*dTheta/xi - Theta**n_poly
       elsewhere
          d2Theta = -1._WP/3._WP
       end where

    else

       d2Theta = -1._WP/3._WP

    endif

    ml%sp_Theta = spline_t(xi, Theta, dTheta)
    ml%sp_dTheta = spline_t(xi, dTheta, d2Theta)

    ml%sp_Omega_rot = spline_t(xi/xi(n), Omega_rot, deriv_type, dy_dx_a=0._WP, dy_dx_b=0._WP)

    ml%n_poly = n_poly
    ml%dt_Gamma_1 = Gamma_1
    ml%xi_1 = xi(n)

    ! Finish

    return

  end function poly_model_t_

!****

  function V_1_ (this, x) result (V)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: V

    real(WP) :: xi
    real(WP) :: Theta
    real(WP) :: dTheta

    ! Calculate V

    xi = x*this%xi_1

    Theta = this%sp_Theta%interp(xi)
    dTheta = this%sp_dTheta%interp(xi)

    V = -(this%n_poly + 1._WP)*xi*dTheta/Theta

    ! Finish

    return

  end function V_1_

!****

  function V_v_ (this, x) result (V)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)             :: x(:)
    real(WP)                         :: V(SIZE(x))

    integer :: i

    ! Calculate V

    x_loop : do i = 1,SIZE(x)
       V(i) = this%V(x(i))
    end do x_loop

    ! Finish

    return

  end function V_v_

!****

  function As_1_ (this, x) result (As)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: As

    ! Calculate As

    As = this%V(x)*(this%n_poly/(this%n_poly + 1._WP) - 1._WP/this%Gamma_1(x))

    ! Finish

    return

  end function As_1_

!****

  function As_v_ (this, x) result (As)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: As(SIZE(x))

    integer :: i

    ! Calculate As

    x_loop : do i = 1,SIZE(x)
       As(i) = this%As(x(i))
    end do x_loop

    ! Finish

    return

  end function As_v_

!****

  function U_1_ (this, x) result (U)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: U

    real(WP) :: xi
    real(WP) :: Theta
    real(WP) :: dTheta

    ! Calculate U

    xi = x*this%xi_1

    Theta = this%sp_Theta%interp(xi)
    dTheta = this%sp_dTheta%interp(xi)

    if(x /= 0._WP) then
       U = -xi*Theta**this%n_poly/dTheta
    else
       U = 3._WP
    endif

    ! Finish

    return

  end function U_1_

!****

  function U_v_ (this, x) result (U)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: U(SIZE(x))

    integer :: i

    ! Calculate U

    x_loop : do i = 1,SIZE(x)
       U(i) = this%U(x(i))
    end do x_loop

    ! Finish

    return

  end function U_v_

!****

  function c_1_1_ (this, x) result (c_1)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_1

    real(WP) :: xi
    real(WP) :: dTheta
    real(WP) :: dTheta_1

    ! Calculate c_1

    xi = x*this%xi_1

    dTheta = this%sp_dTheta%interp(xi)
    dTheta_1 = this%sp_dTheta%interp(this%xi_1)

    if(x /= 0._WP) then
       c_1 = x*dTheta_1/dTheta
    else
       c_1 = -3._WP*dTheta_1/this%xi_1
    endif

    ! Finish

    return

  end function c_1_1_

!****

  function c_1_v_ (this, x) result (c_1)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_1(SIZE(x))

    integer :: i

    ! Calculate c_1

    x_loop : do i = 1,SIZE(x)
       c_1(i) = this%c_1(x(i))
    end do x_loop

    ! Finish

    return

  end function c_1_v_

!****

  function Gamma_1_1_ (this, x) result (Gamma_1)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: Gamma_1

    ! Calculate Gamma_1

    Gamma_1 = this%dt_Gamma_1

    ! Finish

    return

  end function Gamma_1_1_

!****

  function Gamma_1_v_ (this, x) result (Gamma_1)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: Gamma_1(SIZE(x))

    integer :: i

    ! Calculate Gamma_1

    x_loop : do i = 1,SIZE(x)
       Gamma_1(i) = this%Gamma_1(x(i))
    end do x_loop

    ! Finish

    return

  end function Gamma_1_v_

!****

  function nabla_ad_1_ (this, x) result (nabla_ad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: nabla_ad

    ! Calculate nabla_ad (assume ideal gas)

    nabla_ad = 2._WP/5._WP

    ! Finish

    return

  end function nabla_ad_1_

!****

  function nabla_ad_v_ (this, x) result (nabla_ad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: nabla_ad(SIZE(x))

    integer :: i

    ! Calculate nabla_ad

    x_loop : do i = 1,SIZE(x)
       nabla_ad(i) = this%nabla_ad(x(i))
    end do x_loop

    ! Finish

    return

  end function nabla_ad_v_

!****

  function delta_1_ (this, x) result (delta)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: delta

    ! Calculate delta (assume ideal gas)

    delta = 1._WP

    ! Finish

    return

  end function delta_1_

!****

  function delta_v_ (this, x) result (delta)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: delta(SIZE(x))

    integer :: i

    ! Calculate delta

    x_loop : do i = 1,SIZE(x)
       delta(i) = this%delta(x(i))
    end do x_loop

    ! Finish

    return

  end function delta_v_

!****

  function c_rad_1_ (this, x) result (c_rad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_rad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 512 <gyre_poly_model:c_rad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_rad_1_

!****

  function c_rad_v_ (this, x) result (c_rad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_rad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 512 <gyre_poly_model:c_rad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_rad_v_

  function dc_rad_1_ (this, x) result (dc_rad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: dc_rad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 513 <gyre_poly_model:dc_rad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'dc_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function dc_rad_1_

!****

  function dc_rad_v_ (this, x) result (dc_rad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: dc_rad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 513 <gyre_poly_model:dc_rad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'dc_rad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function dc_rad_v_

  function c_thm_1_ (this, x) result (c_thm)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_thm

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 514 <gyre_poly_model:c_thm_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_thm_1_

!****

  function c_thm_v_ (this, x) result (c_thm)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_thm(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 514 <gyre_poly_model:c_thm_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_thm_v_

  function c_dif_1_ (this, x) result (c_dif)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_dif

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 515 <gyre_poly_model:c_dif_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_dif is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_dif_1_

!****

  function c_dif_v_ (this, x) result (c_dif)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_dif(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 515 <gyre_poly_model:c_dif_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_dif is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_dif_v_

  function c_eps_ad_1_ (this, x) result (c_eps_ad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_eps_ad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 516 <gyre_poly_model:c_eps_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_ad_1_

!****

  function c_eps_ad_v_ (this, x) result (c_eps_ad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_eps_ad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 516 <gyre_poly_model:c_eps_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_ad_v_

  function c_eps_S_1_ (this, x) result (c_eps_S)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_eps_S

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 517 <gyre_poly_model:c_eps_S_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_S_1_

!****

  function c_eps_S_v_ (this, x) result (c_eps_S)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_eps_S(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 517 <gyre_poly_model:c_eps_S_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function c_eps_S_v_

  function nabla_1_ (this, x) result (nabla)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: nabla

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 518 <gyre_poly_model:nabla_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function nabla_1_

!****

  function nabla_v_ (this, x) result (nabla)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: nabla(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 518 <gyre_poly_model:nabla_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function nabla_v_

  function kappa_S_1_ (this, x) result (kappa_S)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: kappa_S

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 519 <gyre_poly_model:kappa_S_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_S_1_

!****

  function kappa_S_v_ (this, x) result (kappa_S)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: kappa_S(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 519 <gyre_poly_model:kappa_S_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_S is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_S_v_

  function kappa_ad_1_ (this, x) result (kappa_ad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: kappa_ad

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 520 <gyre_poly_model:kappa_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_ad_1_

!****

  function kappa_ad_v_ (this, x) result (kappa_ad)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: kappa_ad(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 520 <gyre_poly_model:kappa_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_ad is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function kappa_ad_v_

  function tau_thm_1_ (this, x) result (tau_thm)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: tau_thm

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 521 <gyre_poly_model:tau_thm_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'tau_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function tau_thm_1_

!****

  function tau_thm_v_ (this, x) result (tau_thm)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: tau_thm(SIZE(x))

    ! Abort with $NAME undefined

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 521 <gyre_poly_model:tau_thm_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'tau_thm is undefined'

  stop 'Program aborted'

    ! Finish

    return

  end function tau_thm_v_

!****

  function Omega_rot_1_ (this, x) result (Omega_rot)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: Omega_rot

    ! Interpolate Omega_rot

    Omega_rot = this%sp_Omega_rot%interp(x)

    ! Finish

    return

  end function Omega_rot_1_

!****

  function Omega_rot_v_ (this, x) result (Omega_rot)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: Omega_rot(SIZE(x))

    integer :: j

    ! Interpolate Omega_rot

    Omega_rot = this%sp_Omega_rot%interp(x)

    ! Finish

    return

  end function Omega_rot_v_

!****

  function pi_c_ (this) result (pi_c)

    class(poly_model_t), intent(in) :: this
    real(WP)                        :: pi_c

    ! Calculate pi_c = V/x^2 as x -> 0

    pi_c =  (this%n_poly + 1._WP)*this%xi_1**2/3._WP

    ! Finish

    return

  end function pi_c_

!****

  function is_zero_ (this, x) result (is_zero)

    class(poly_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    logical                         :: is_zero

    real(WP) :: xi

    ! Determine whether the point at x has a vanishing pressure and/or density

    xi = x*this%xi_1

    is_zero = this%sp_Theta%interp(xi) == 0._WP

    ! Finish

    return

  end function is_zero_

!****

  subroutine attach_cache_ (this, cc)

    class(poly_model_t), intent(inout)    :: this
    class(cocache_t), pointer, intent(in) :: cc

    ! Enable a coefficient cache (no-op, since we don't cache)

    ! Finish

    return

  end subroutine attach_cache_

!****

  subroutine detach_cache_ (this)

    class(poly_model_t), intent(inout) :: this

    ! Detach the coefficient cache (no-op, since we don't cache)

    ! Finish

    return

  end subroutine detach_cache_

!****

  subroutine fill_cache_ (this, x)

    class(poly_model_t), intent(inout) :: this
    real(WP), intent(in)               :: x(:)

    ! Fill the coefficient cache (no-op, since we don't cache)

    ! Finish

    return

  end subroutine fill_cache_

!****

end module gyre_poly_model

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core_memory.inc ../extern/core/core.inc
!   uses: core_kinds ISO_FORTRAN_ENV
!   provides: core_memory
!end dependencies
!
!end fpx3_header
! Module   : core_memory
! Purpose  : memory management

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

! Incfile  : core_memory
! Purpose  : memory management fpx3 macros

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_memory

  ! Uses

  use core_kinds

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Interfaces

  interface reallocate
     module procedure reallocate_i_i4_1_
     module procedure reallocate_i_i4_2_
     module procedure reallocate_i_i4_3_
     module procedure reallocate_i_i4_4_
     module procedure reallocate_i_i8_1_
     module procedure reallocate_i_i8_2_
     module procedure reallocate_i_i8_3_
     module procedure reallocate_i_i8_4_
     module procedure reallocate_r_sp_1_
     module procedure reallocate_r_sp_2_
     module procedure reallocate_r_sp_3_
     module procedure reallocate_r_sp_4_
     module procedure reallocate_r_dp_1_
     module procedure reallocate_r_dp_2_
     module procedure reallocate_r_dp_3_
     module procedure reallocate_r_dp_4_
     module procedure reallocate_c_sp_1_
     module procedure reallocate_c_sp_2_
     module procedure reallocate_c_sp_3_
     module procedure reallocate_c_sp_4_
     module procedure reallocate_c_dp_1_
     module procedure reallocate_c_dp_2_
     module procedure reallocate_c_dp_3_
     module procedure reallocate_c_dp_4_
     module procedure reallocate_a_1_
     module procedure reallocate_a_2_
     module procedure reallocate_a_3_
     module procedure reallocate_a_4_
     module procedure reallocate_l_1_
     module procedure reallocate_l_2_
     module procedure reallocate_l_3_
     module procedure reallocate_l_4_
  end interface reallocate

  ! Access specifiers

  private

  public :: reallocate

  ! Procedures

contains

subroutine reallocate_i_i4_1_ (array, shape_new, start)

  integer(I4), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I4), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 66 <core_memory:reallocate_i_i4_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 66 <core_memory:reallocate_i_i4_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i4_1_

subroutine reallocate_i_i4_2_ (array, shape_new, start)

  integer(I4), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I4), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 67 <core_memory:reallocate_i_i4_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 67 <core_memory:reallocate_i_i4_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i4_2_

subroutine reallocate_i_i4_3_ (array, shape_new, start)

  integer(I4), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I4), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 68 <core_memory:reallocate_i_i4_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 68 <core_memory:reallocate_i_i4_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i4_3_

subroutine reallocate_i_i4_4_ (array, shape_new, start)

  integer(I4), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I4), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 69 <core_memory:reallocate_i_i4_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 69 <core_memory:reallocate_i_i4_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i4_4_

subroutine reallocate_i_i8_1_ (array, shape_new, start)

  integer(I8), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I8), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 71 <core_memory:reallocate_i_i8_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 71 <core_memory:reallocate_i_i8_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i8_1_

subroutine reallocate_i_i8_2_ (array, shape_new, start)

  integer(I8), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I8), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 72 <core_memory:reallocate_i_i8_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 72 <core_memory:reallocate_i_i8_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i8_2_

subroutine reallocate_i_i8_3_ (array, shape_new, start)

  integer(I8), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I8), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 73 <core_memory:reallocate_i_i8_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 73 <core_memory:reallocate_i_i8_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i8_3_

subroutine reallocate_i_i8_4_ (array, shape_new, start)

  integer(I8), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  integer(I8), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 74 <core_memory:reallocate_i_i8_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 74 <core_memory:reallocate_i_i8_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_i_i8_4_

subroutine reallocate_r_sp_1_ (array, shape_new, start)

  real(SP), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(SP), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 76 <core_memory:reallocate_r_sp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 76 <core_memory:reallocate_r_sp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_sp_1_

subroutine reallocate_r_sp_2_ (array, shape_new, start)

  real(SP), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(SP), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 77 <core_memory:reallocate_r_sp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 77 <core_memory:reallocate_r_sp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_sp_2_

subroutine reallocate_r_sp_3_ (array, shape_new, start)

  real(SP), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(SP), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 78 <core_memory:reallocate_r_sp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 78 <core_memory:reallocate_r_sp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_sp_3_

subroutine reallocate_r_sp_4_ (array, shape_new, start)

  real(SP), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(SP), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 79 <core_memory:reallocate_r_sp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 79 <core_memory:reallocate_r_sp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_sp_4_

subroutine reallocate_r_dp_1_ (array, shape_new, start)

  real(DP), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(DP), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 81 <core_memory:reallocate_r_dp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 81 <core_memory:reallocate_r_dp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_dp_1_

subroutine reallocate_r_dp_2_ (array, shape_new, start)

  real(DP), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(DP), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 82 <core_memory:reallocate_r_dp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 82 <core_memory:reallocate_r_dp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_dp_2_

subroutine reallocate_r_dp_3_ (array, shape_new, start)

  real(DP), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(DP), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 83 <core_memory:reallocate_r_dp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 83 <core_memory:reallocate_r_dp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_dp_3_

subroutine reallocate_r_dp_4_ (array, shape_new, start)

  real(DP), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  real(DP), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 84 <core_memory:reallocate_r_dp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 84 <core_memory:reallocate_r_dp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_r_dp_4_

subroutine reallocate_c_sp_1_ (array, shape_new, start)

  complex(SP), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(SP), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 86 <core_memory:reallocate_c_sp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 86 <core_memory:reallocate_c_sp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_sp_1_

subroutine reallocate_c_sp_2_ (array, shape_new, start)

  complex(SP), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(SP), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 87 <core_memory:reallocate_c_sp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 87 <core_memory:reallocate_c_sp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_sp_2_

subroutine reallocate_c_sp_3_ (array, shape_new, start)

  complex(SP), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(SP), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 88 <core_memory:reallocate_c_sp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 88 <core_memory:reallocate_c_sp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_sp_3_

subroutine reallocate_c_sp_4_ (array, shape_new, start)

  complex(SP), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(SP), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 89 <core_memory:reallocate_c_sp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 89 <core_memory:reallocate_c_sp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_sp_4_

subroutine reallocate_c_dp_1_ (array, shape_new, start)

  complex(DP), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(DP), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 91 <core_memory:reallocate_c_dp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 91 <core_memory:reallocate_c_dp_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_dp_1_

subroutine reallocate_c_dp_2_ (array, shape_new, start)

  complex(DP), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(DP), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 92 <core_memory:reallocate_c_dp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 92 <core_memory:reallocate_c_dp_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_dp_2_

subroutine reallocate_c_dp_3_ (array, shape_new, start)

  complex(DP), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(DP), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 93 <core_memory:reallocate_c_dp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 93 <core_memory:reallocate_c_dp_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_dp_3_

subroutine reallocate_c_dp_4_ (array, shape_new, start)

  complex(DP), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  complex(DP), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 94 <core_memory:reallocate_c_dp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 94 <core_memory:reallocate_c_dp_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_c_dp_4_

subroutine reallocate_a_1_ (array, shape_new, start)

  character(*), allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  character(LEN(array)), allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 96 <core_memory:reallocate_a_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 96 <core_memory:reallocate_a_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_a_1_

subroutine reallocate_a_2_ (array, shape_new, start)

  character(*), allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  character(LEN(array)), allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 97 <core_memory:reallocate_a_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 97 <core_memory:reallocate_a_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_a_2_

subroutine reallocate_a_3_ (array, shape_new, start)

  character(*), allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  character(LEN(array)), allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 98 <core_memory:reallocate_a_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 98 <core_memory:reallocate_a_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_a_3_

subroutine reallocate_a_4_ (array, shape_new, start)

  character(*), allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  character(LEN(array)), allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 99 <core_memory:reallocate_a_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 99 <core_memory:reallocate_a_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_a_4_

subroutine reallocate_l_1_ (array, shape_new, start)

  logical, allocatable, intent(inout) :: array(:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  logical, allocatable :: array_new(:)
  integer                      :: i_a(1)
  integer                      :: i_b(1)
  integer                      :: i_c(1)

    if(.NOT. (SIZE(shape_new) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 1'' failed at line 101 <core_memory:reallocate_l_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 1'' failed at line 101 <core_memory:reallocate_l_1_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1)))

  ! Copy the data from old to new

  array_new(:i_a(1)) = array(:i_a(1))
array_new(i_c(1):) = array(i_b(1):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_l_1_

subroutine reallocate_l_2_ (array, shape_new, start)

  logical, allocatable, intent(inout) :: array(:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  logical, allocatable :: array_new(:,:)
  integer                      :: i_a(2)
  integer                      :: i_b(2)
  integer                      :: i_c(2)

    if(.NOT. (SIZE(shape_new) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 2'' failed at line 102 <core_memory:reallocate_l_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 2'' failed at line 102 <core_memory:reallocate_l_2_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2)) = array(:i_a(1),:i_a(2))
array_new(i_c(1):,:i_a(2)) = array(i_b(1):,:i_a(2))
array_new(:i_a(1),i_c(2):) = array(:i_a(1),i_b(2):)
array_new(i_c(1):,i_c(2):) = array(i_b(1):,i_b(2):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_l_2_

subroutine reallocate_l_3_ (array, shape_new, start)

  logical, allocatable, intent(inout) :: array(:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  logical, allocatable :: array_new(:,:,:)
  integer                      :: i_a(3)
  integer                      :: i_b(3)
  integer                      :: i_c(3)

    if(.NOT. (SIZE(shape_new) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 3'' failed at line 103 <core_memory:reallocate_l_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 3)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 3'' failed at line 103 <core_memory:reallocate_l_3_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3)) = array(:i_a(1),:i_a(2),:i_a(3))
array_new(i_c(1):,:i_a(2),:i_a(3)) = array(i_b(1):,:i_a(2),:i_a(3))
array_new(:i_a(1),i_c(2):,:i_a(3)) = array(:i_a(1),i_b(2):,:i_a(3))
array_new(i_c(1):,i_c(2):,:i_a(3)) = array(i_b(1):,i_b(2):,:i_a(3))
array_new(:i_a(1),:i_a(2),i_c(3):) = array(:i_a(1),:i_a(2),i_b(3):)
array_new(i_c(1):,:i_a(2),i_c(3):) = array(i_b(1):,:i_a(2),i_b(3):)
array_new(:i_a(1),i_c(2):,i_c(3):) = array(:i_a(1),i_b(2):,i_b(3):)
array_new(i_c(1):,i_c(2):,i_c(3):) = array(i_b(1):,i_b(2):,i_b(3):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_l_3_

subroutine reallocate_l_4_ (array, shape_new, start)

  logical, allocatable, intent(inout) :: array(:,:,:,:)
  integer, intent(in)                     :: shape_new(:)
  integer, intent(in), optional           :: start(:)

  logical, allocatable :: array_new(:,:,:,:)
  integer                      :: i_a(4)
  integer                      :: i_b(4)
  integer                      :: i_c(4)

    if(.NOT. (SIZE(shape_new) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(shape_new) == 4'' failed at line 104 <core_memory:reallocate_l_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  if(PRESENT(start)) then

    if(.NOT. (SIZE(start) == 4)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(start) == 4'' failed at line 104 <core_memory:reallocate_l_4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Dimension mismatch'
      stop
    endif

  end if

  ! Set up the reallocation indices

  if(PRESENT(start)) then
     i_a = start - 1
  else
     i_a = MIN(SHAPE(array), shape_new)
  endif

  i_b = MAX(i_a, i_a+SHAPE(array)-shape_new) + 1
  i_c = MAX(i_a, i_a+shape_new-SHAPE(array)) + 1

  ! Allocate the new array

  allocate(array_new(shape_new(1),shape_new(2),shape_new(3),shape_new(4)))

  ! Copy the data from old to new

  array_new(:i_a(1),:i_a(2),:i_a(3),:i_a(4)) = array(:i_a(1),:i_a(2),:i_a(3),:i_a(4))
array_new(i_c(1):,:i_a(2),:i_a(3),:i_a(4)) = array(i_b(1):,:i_a(2),:i_a(3),:i_a(4))
array_new(:i_a(1),i_c(2):,:i_a(3),:i_a(4)) = array(:i_a(1),i_b(2):,:i_a(3),:i_a(4))
array_new(i_c(1):,i_c(2):,:i_a(3),:i_a(4)) = array(i_b(1):,i_b(2):,:i_a(3),:i_a(4))
array_new(:i_a(1),:i_a(2),i_c(3):,:i_a(4)) = array(:i_a(1),:i_a(2),i_b(3):,:i_a(4))
array_new(i_c(1):,:i_a(2),i_c(3):,:i_a(4)) = array(i_b(1):,:i_a(2),i_b(3):,:i_a(4))
array_new(:i_a(1),i_c(2):,i_c(3):,:i_a(4)) = array(:i_a(1),i_b(2):,i_b(3):,:i_a(4))
array_new(i_c(1):,i_c(2):,i_c(3):,:i_a(4)) = array(i_b(1):,i_b(2):,i_b(3):,:i_a(4))
array_new(:i_a(1),:i_a(2),:i_a(3),i_c(4):) = array(:i_a(1),:i_a(2),:i_a(3),i_b(4):)
array_new(i_c(1):,:i_a(2),:i_a(3),i_c(4):) = array(i_b(1):,:i_a(2),:i_a(3),i_b(4):)
array_new(:i_a(1),i_c(2):,:i_a(3),i_c(4):) = array(:i_a(1),i_b(2):,:i_a(3),i_b(4):)
array_new(i_c(1):,i_c(2):,:i_a(3),i_c(4):) = array(i_b(1):,i_b(2):,:i_a(3),i_b(4):)
array_new(:i_a(1),:i_a(2),i_c(3):,i_c(4):) = array(:i_a(1),:i_a(2),i_b(3):,i_b(4):)
array_new(i_c(1):,:i_a(2),i_c(3):,i_c(4):) = array(i_b(1):,:i_a(2),i_b(3):,i_b(4):)
array_new(:i_a(1),i_c(2):,i_c(3):,i_c(4):) = array(:i_a(1),i_b(2):,i_b(3):,i_b(4):)
array_new(i_c(1):,i_c(2):,i_c(3):,i_c(4):) = array(i_b(1):,i_b(2):,i_b(3):,i_b(4):)

  ! Move the allocation

  call MOVE_ALLOC(array_new, array)

  ! Finish

  return

end subroutine reallocate_l_4_

end module core_memory

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: gyre_atmos gyre_rot gyre_scons_model ISO_FORTRAN_ENV core_parallel core_memory core_kinds gyre_scanpar gyre_evol_model gyre_rot_factory gyre_oscpar gyre_model gyre_gridpar gyre_modepar gyre_hom_model gyre_poly_model gyre_numpar gyre_constants
!   provides: gyre_util
!end dependencies
!
!end fpx3_header
! Program  : gyre_util
! Purpose  : miscellaneous utility routines
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_util

  ! Uses

  use core_kinds
  use core_parallel
  use core_memory

  use gyre_atmos
  use gyre_constants
  use gyre_evol_model
  use gyre_gridpar
  use gyre_hom_model
  use gyre_model
  use gyre_modepar
  use gyre_numpar
  use gyre_oscpar
  use gyre_poly_model
  use gyre_scanpar
  use gyre_scons_model
  use gyre_rot
  use gyre_rot_factory

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Module variables

  character(64), save :: log_level_m

  ! Interfaces

  interface omega_from_freq
     module procedure omega_from_freq_r_
     module procedure omega_from_freq_c_
  end interface omega_from_freq

interface freq_from_omega
     module procedure freq_from_omega_r_
     module procedure freq_from_omega_c_
  end interface freq_from_omega

  interface select_par
     module procedure select_par_op_
     module procedure select_par_np_
     module procedure select_par_gp_
     module procedure select_par_sp_
  end interface select_par

  interface sprint
     module procedure sprint_
  end interface sprint

  interface integrate
     module procedure integrate_r_
     module procedure Integrate_c_
  end interface integrate

  interface integral
     module procedure integral_r_
     module procedure Integral_c_
  end interface integral

  ! Access specifiers

  private

  public :: form_header
  public :: set_log_level
  public :: check_log_level
  public :: omega_from_freq
  public :: freq_from_omega
  public :: eval_cutoff_freqs
  public :: select_par
  public :: split_list
  public :: join_fmts
  public :: sprint
  public :: rjust
  public :: phase
  public :: integrate
  public :: integral

  ! Procedures

contains

  function form_header (header, underchar)

    character(*), intent(in)           :: header
    character(*), optional, intent(in) :: underchar
    character(:), allocatable          :: form_header

    ! Format the header string

    if(PRESENT(underchar)) then

       if(underchar == '') then

          form_header = NEW_LINE('') // &
                        TRIM(header) // NEW_LINE('') // &
                        REPEAT(' ', LEN(header)) // NEW_LINE('')

       else

          form_header = NEW_LINE('') // &
                        TRIM(header) // NEW_LINE('') // &
                        REPEAT(underchar, LEN(header)/LEN(underchar)) // NEW_LINE('')

       endif

    else

       form_header = NEW_LINE('') // &
                     TRIM(header) // NEW_LINE('')

    endif

    ! Finish

    return

  end function form_header

!****

  subroutine set_log_level (log_level)

    character(*), intent(in) :: log_level

    ! Set the log level

    select case (log_level)
    case ('DEBUG')
    case ('INFO')
    case ('WARN')
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 159 <gyre_util:set_log_level>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid log_level'

  stop 'Program aborted'

    end select

    log_level_m = log_level

    ! Finish

    return

  end subroutine set_log_level

!****

  function check_log_level (log_level, rank)

    character(*), intent(in)      :: log_level
    integer, optional, intent(in) :: rank
    logical                       :: check_log_level

    integer :: rank_

    if(PRESENT(rank)) then
       rank_ = rank
    else
       rank_ = 0
    endif

    ! Check whether we should write log output

    if(MPI_RANK == rank_) then

       select case (log_level)
       case ('DEBUG')
          check_log_level = log_level_m == 'DEBUG'
       case ('INFO')
          check_log_level = log_level_m == 'INFO' .OR. &
                            log_level_m == 'DEBUG'
       case ('WARN')
          check_log_level = log_level_m == 'WARN' .OR. &
                            log_level_m == 'INFO' .OR. &
                            log_level_m == 'DEBUG'
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 201 <gyre_util:check_log_level>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid log_level'

  stop 'Program aborted'

       end select

    else

       check_log_level = .FALSE.

    endif

    ! Finish

    return

  end function check_log_level

!****

  function omega_from_freq_r_ (freq, ml, mp, op, x_i, x_o, freq_units, freq_frame) result (omega)

    real(WP), intent(in)               :: freq
    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    real(WP), intent(in)                :: x_i
    real(WP), intent(in)                :: x_o
    character(*), intent(in)            :: freq_units
    character(*), intent(in)            :: freq_frame
    real(WP)                           :: omega

    real(WP)                      :: omega_l
    class(r_rot_t), allocatable :: rt
    real(WP)                       :: omega_cutoff_lo
    real(WP)                       :: omega_cutoff_hi

    ! Calculate the dimensionless inertial-frame frequency omega from
    ! the dimensioned local-frame frequency freq

    ! First calculate the dimensionless frequency in the local frame

    select type (ml)

    class is (evol_model_t)

       select case(freq_units)
       case('NONE')
          omega_l = freq
       case('HZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/1E6_WP
       case('PER_DAY')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 336 <gyre_util:omega_from_freq_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (scons_model_t)

       select case(freq_units)
       case('NONE')
          omega_l = freq
       case('HZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/1E6_WP
       case('PER_DAY')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 336 <gyre_util:omega_from_freq_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (poly_model_t)

       select case (freq_units)
       case ('NONE')
          omega_l = freq
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 336 <gyre_util:omega_from_freq_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

   class is (hom_model_t)

       select case (freq_units)
       case ('NONE')
          omega_l = freq
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 336 <gyre_util:omega_from_freq_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

    class default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 336 <gyre_util:omega_from_freq_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid ml type'

  stop 'Program aborted'

    end select

    ! Now convert to the inertial frame

    allocate(rt, SOURCE=r_rot_t(ml, mp, op))

    select case (freq_frame)
    case ('INERTIAL')
       omega = omega_l
    case ('COROT_I')
       omega = rt%omega(x_i, omega_l)
    case ('COROT_O')
       omega = rt%omega(x_o, omega_l)
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 336 <gyre_util:omega_from_freq_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_frame'

  stop 'Program aborted'

    end select

    ! Finish

    return

  end function omega_from_freq_r_

  function omega_from_freq_c_ (freq, ml, mp, op, x_i, x_o, freq_units, freq_frame) result (omega)

    complex(WP), intent(in)               :: freq
    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    real(WP), intent(in)                :: x_i
    real(WP), intent(in)                :: x_o
    character(*), intent(in)            :: freq_units
    character(*), intent(in)            :: freq_frame
    complex(WP)                           :: omega

    complex(WP)                      :: omega_l
    class(c_rot_t), allocatable :: rt
    real(WP)                       :: omega_cutoff_lo
    real(WP)                       :: omega_cutoff_hi

    ! Calculate the dimensionless inertial-frame frequency omega from
    ! the dimensioned local-frame frequency freq

    ! First calculate the dimensionless frequency in the local frame

    select type (ml)

    class is (evol_model_t)

       select case(freq_units)
       case('NONE')
          omega_l = freq
       case('HZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/1E6_WP
       case('PER_DAY')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 337 <gyre_util:omega_from_freq_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (scons_model_t)

       select case(freq_units)
       case('NONE')
          omega_l = freq
       case('HZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/1E6_WP
       case('PER_DAY')
          omega_l = freq*(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))/86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          omega_l = freq*omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 337 <gyre_util:omega_from_freq_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (poly_model_t)

       select case (freq_units)
       case ('NONE')
          omega_l = freq
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 337 <gyre_util:omega_from_freq_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

   class is (hom_model_t)

       select case (freq_units)
       case ('NONE')
          omega_l = freq
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 337 <gyre_util:omega_from_freq_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

    class default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 337 <gyre_util:omega_from_freq_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid ml type'

  stop 'Program aborted'

    end select

    ! Now convert to the inertial frame

    allocate(rt, SOURCE=c_rot_t(ml, mp, op))

    select case (freq_frame)
    case ('INERTIAL')
       omega = omega_l
    case ('COROT_I')
       omega = rt%omega(x_i, omega_l)
    case ('COROT_O')
       omega = rt%omega(x_o, omega_l)
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 337 <gyre_util:omega_from_freq_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_frame'

  stop 'Program aborted'

    end select

    ! Finish

    return

  end function omega_from_freq_c_

!****

  function freq_from_omega_r_ (omega, ml, mp, op, x_i, x_o, freq_units, freq_frame) result (freq)

    real(WP), intent(in)               :: omega
    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    real(WP), intent(in)                :: x_i
    real(WP), intent(in)                :: x_o
    character(*), intent(in)            :: freq_units
    character(*), intent(in)            :: freq_frame
    real(WP)                           :: freq

    real(WP)                      :: omega_l
    class(r_rot_t), allocatable :: rt
    real(WP)                       :: omega_cutoff_lo
    real(WP)                       :: omega_cutoff_hi

    ! Calculate the dimensionless inertial-frame frequency omega from
    ! the dimensioned local-frame frequency freq

    ! First convert from the inertial frame

    allocate(rt, SOURCE=r_rot_t(ml, mp, op))

    select case (freq_frame)
    case ('INERTIAL')
       omega_l = omega
    case ('COROT_I')
       omega_l = rt%omega_c(x_i, omega)
    case ('COROT_O')
       omega_l = rt%omega_c(x_o, omega)
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 459 <gyre_util:freq_from_omega_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_frame'

  stop 'Program aborted'

    end select

    ! Now calculate the dimensionless frequency in the local frame

    select type (ml)

    class is (evol_model_t)

       select case(freq_units)
       case('NONE')
          freq = omega_l
       case('HZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*1E6_WP
       case('PER_DAY')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 459 <gyre_util:freq_from_omega_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (scons_model_t)

       select case(freq_units)
       case('NONE')
          freq = omega_l
       case('HZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*1E6_WP
       case('PER_DAY')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 459 <gyre_util:freq_from_omega_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (poly_model_t)

       select case (freq_units)
       case ('NONE')
          freq = omega_l
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 459 <gyre_util:freq_from_omega_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

    class is (hom_model_t)

       select case (freq_units)
       case ('NONE')
          freq = omega_l
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 459 <gyre_util:freq_from_omega_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

    class default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 459 <gyre_util:freq_from_omega_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid ml type'

  stop 'Program aborted'

    end select

    ! Finish

    return

  end function freq_from_omega_r_

  function freq_from_omega_c_ (omega, ml, mp, op, x_i, x_o, freq_units, freq_frame) result (freq)

    complex(WP), intent(in)               :: omega
    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    real(WP), intent(in)                :: x_i
    real(WP), intent(in)                :: x_o
    character(*), intent(in)            :: freq_units
    character(*), intent(in)            :: freq_frame
    complex(WP)                           :: freq

    complex(WP)                      :: omega_l
    class(c_rot_t), allocatable :: rt
    real(WP)                       :: omega_cutoff_lo
    real(WP)                       :: omega_cutoff_hi

    ! Calculate the dimensionless inertial-frame frequency omega from
    ! the dimensioned local-frame frequency freq

    ! First convert from the inertial frame

    allocate(rt, SOURCE=c_rot_t(ml, mp, op))

    select case (freq_frame)
    case ('INERTIAL')
       omega_l = omega
    case ('COROT_I')
       omega_l = rt%omega_c(x_i, omega)
    case ('COROT_O')
       omega_l = rt%omega_c(x_o, omega)
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 460 <gyre_util:freq_from_omega_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_frame'

  stop 'Program aborted'

    end select

    ! Now calculate the dimensionless frequency in the local frame

    select type (ml)

    class is (evol_model_t)

       select case(freq_units)
       case('NONE')
          freq = omega_l
       case('HZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*1E6_WP
       case('PER_DAY')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 460 <gyre_util:freq_from_omega_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (scons_model_t)

       select case(freq_units)
       case('NONE')
          freq = omega_l
       case('HZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))
       case('UHZ')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*1E6_WP
       case('PER_DAY')
          freq = omega_l/(TWOPI*SQRT(ml%R_star**3/(G_GRAVITY*ml%M_star)))*86400._WP
       case('ACOUSTIC_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_hi
       case('GRAVITY_CUTOFF')
          call eval_cutoff_freqs(ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)
          freq = omega_l/omega_cutoff_lo
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 460 <gyre_util:freq_from_omega_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

       end select

    class is (poly_model_t)

       select case (freq_units)
       case ('NONE')
          freq = omega_l
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 460 <gyre_util:freq_from_omega_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

    class is (hom_model_t)

       select case (freq_units)
       case ('NONE')
          freq = omega_l
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 460 <gyre_util:freq_from_omega_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid freq_units'

  stop 'Program aborted'

      end select

    class default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 460 <gyre_util:freq_from_omega_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid ml type'

  stop 'Program aborted'

    end select

    ! Finish

    return

  end function freq_from_omega_c_

!****

  subroutine eval_cutoff_freqs (ml, mp, op, x_o, omega_cutoff_lo, omega_cutoff_hi)

    class(model_t), intent(in)  :: ml
    type(modepar_t), intent(in) :: mp
    type(oscpar_t), intent(in)  :: op
    real(WP), intent(in)        :: x_o
    real(WP), intent(out)       :: omega_cutoff_lo
    real(WP), intent(out)       :: omega_cutoff_hi

    real(WP)      :: V_g
    real(WP)      :: As
    real(WP)      :: c_1
    logical, save :: warned = .FALSE.

     ! Evaluate the cutoff frequencies

     select case (op%outer_bound_type)

     case ('ZERO')

        omega_cutoff_lo = 0._WP
        omega_cutoff_hi = HUGE(0._WP)

     case ('DZIEM')

        omega_cutoff_lo = 0._WP
        omega_cutoff_hi = HUGE(0._WP)

     case ('UNNO')

        call eval_atmos_coeffs_unno(ml, x_o, V_g, As, c_1)
        call eval_atmos_cutoff_freqs(V_g, As, c_1, mp%l*(mp%l+1._WP), omega_cutoff_lo, omega_cutoff_hi)

     case('JCD')

        call eval_atmos_coeffs_jcd(ml, x_o, V_g, As, c_1)
        call eval_atmos_cutoff_freqs(V_g, As, c_1, mp%l*(mp%l+1._WP), omega_cutoff_lo, omega_cutoff_hi)

     case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 504 <gyre_util:eval_cutoff_freqs>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid outer_bound_type'

  stop 'Program aborted'

     end select

     if (.not. warned) then

    write(UNIT=ERROR_UNIT, FMT=*) 'INFO at line 509 <gyre_util:eval_cutoff_freqs>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'WARNING: Cutoff frequencies do not account for rotation effects'

        warned = .TRUE.
     endif

     ! Finish

     return

   end subroutine eval_cutoff_freqs

!****

   subroutine select_par_op_ (par, tag, par_sel, last)

     type(oscpar_t), intent(in)               :: par(:)
     character(*), intent(in)                  :: tag
     type(oscpar_t), allocatable, intent(out) :: par_sel(:)
     logical, optional, intent(in)             :: last

     logical :: last_
     integer :: i
     logical :: mask(SIZE(par))
     integer :: n_par_sel
     integer :: j

     if(PRESENT(last)) then
        last_ = last
     else
        last_ = .FALSE.
     endif

     ! Select all parameters whose tag_list matches tag

     mask_loop : do i = 1,SIZE(par)
        mask(i) = (par(i)%tag_list == '') .OR. &
                  (tag /= '' .AND. ANY(split_list(par(i)%tag_list, ',') == tag))
    end do mask_loop

    n_par_sel = COUNT(mask)

    allocate(par_sel(n_par_sel))

    j = 0

    select_loop : do i = 1,SIZE(par)
       if(mask(i)) then
          j = j + 1
          par_sel(j) = par(i)
       endif
    end do select_loop

    ! If necessary, shrink par_sel to contain only the last element

    if(last_ .AND. n_par_sel > 1) then
       par_sel = par_sel(1:1)
    endif

    ! Finish

    return

  end subroutine select_par_op_

   subroutine select_par_np_ (par, tag, par_sel, last)

     type(numpar_t), intent(in)               :: par(:)
     character(*), intent(in)                  :: tag
     type(numpar_t), allocatable, intent(out) :: par_sel(:)
     logical, optional, intent(in)             :: last

     logical :: last_
     integer :: i
     logical :: mask(SIZE(par))
     integer :: n_par_sel
     integer :: j

     if(PRESENT(last)) then
        last_ = last
     else
        last_ = .FALSE.
     endif

     ! Select all parameters whose tag_list matches tag

     mask_loop : do i = 1,SIZE(par)
        mask(i) = (par(i)%tag_list == '') .OR. &
                  (tag /= '' .AND. ANY(split_list(par(i)%tag_list, ',') == tag))
    end do mask_loop

    n_par_sel = COUNT(mask)

    allocate(par_sel(n_par_sel))

    j = 0

    select_loop : do i = 1,SIZE(par)
       if(mask(i)) then
          j = j + 1
          par_sel(j) = par(i)
       endif
    end do select_loop

    ! If necessary, shrink par_sel to contain only the last element

    if(last_ .AND. n_par_sel > 1) then
       par_sel = par_sel(1:1)
    endif

    ! Finish

    return

  end subroutine select_par_np_

   subroutine select_par_gp_ (par, tag, par_sel, last)

     type(gridpar_t), intent(in)               :: par(:)
     character(*), intent(in)                  :: tag
     type(gridpar_t), allocatable, intent(out) :: par_sel(:)
     logical, optional, intent(in)             :: last

     logical :: last_
     integer :: i
     logical :: mask(SIZE(par))
     integer :: n_par_sel
     integer :: j

     if(PRESENT(last)) then
        last_ = last
     else
        last_ = .FALSE.
     endif

     ! Select all parameters whose tag_list matches tag

     mask_loop : do i = 1,SIZE(par)
        mask(i) = (par(i)%tag_list == '') .OR. &
                  (tag /= '' .AND. ANY(split_list(par(i)%tag_list, ',') == tag))
    end do mask_loop

    n_par_sel = COUNT(mask)

    allocate(par_sel(n_par_sel))

    j = 0

    select_loop : do i = 1,SIZE(par)
       if(mask(i)) then
          j = j + 1
          par_sel(j) = par(i)
       endif
    end do select_loop

    ! If necessary, shrink par_sel to contain only the last element

    if(last_ .AND. n_par_sel > 1) then
       par_sel = par_sel(1:1)
    endif

    ! Finish

    return

  end subroutine select_par_gp_

   subroutine select_par_sp_ (par, tag, par_sel, last)

     type(scanpar_t), intent(in)               :: par(:)
     character(*), intent(in)                  :: tag
     type(scanpar_t), allocatable, intent(out) :: par_sel(:)
     logical, optional, intent(in)             :: last

     logical :: last_
     integer :: i
     logical :: mask(SIZE(par))
     integer :: n_par_sel
     integer :: j

     if(PRESENT(last)) then
        last_ = last
     else
        last_ = .FALSE.
     endif

     ! Select all parameters whose tag_list matches tag

     mask_loop : do i = 1,SIZE(par)
        mask(i) = (par(i)%tag_list == '') .OR. &
                  (tag /= '' .AND. ANY(split_list(par(i)%tag_list, ',') == tag))
    end do mask_loop

    n_par_sel = COUNT(mask)

    allocate(par_sel(n_par_sel))

    j = 0

    select_loop : do i = 1,SIZE(par)
       if(mask(i)) then
          j = j + 1
          par_sel(j) = par(i)
       endif
    end do select_loop

    ! If necessary, shrink par_sel to contain only the last element

    if(last_ .AND. n_par_sel > 1) then
       par_sel = par_sel(1:1)
    endif

    ! Finish

    return

  end subroutine select_par_sp_

!****

  function split_list (list, delim) result (elems)

    character(*), intent(in)          :: list
    character(1), intent(in)          :: delim
    character(LEN(list)), allocatable :: elems(:)

    character(LEN(list)) :: list_
    integer              :: d
    integer              :: n
    integer              :: j

    ! Split the delimited list into an array of elements

    d = 16

    allocate(elems(d))

    n = 0

    ! Repeatedly split on delimiters

    list_ = list

    split_loop : do

       if(list_ == '') exit split_loop

       j = INDEX(list_, delim)

       if(j <= 0) then
          n = n + 1
          elems(n) = list_
          exit split_loop
       endif

       n = n + 1

       ! Chop out the element

       elems(n) = list_(:j-1)
       list_ = list_(j+1:)

       ! If necessary, expand the array

       if(n >= d) then
          d = 2*d
          call reallocate(elems, [d])
       end if

    end do split_loop

    ! Reallocate elems to the correct length

    call reallocate(elems, [n])

    ! Finish

    return

  end function split_list

!****

  function join_fmts (fmts, n) result (fmt)

    character(*), intent(in)  :: fmts(:)
    integer, intent(in)       :: n(:)
    character(:), allocatable :: fmt

    integer :: i

  if(SIZE(n)/= SIZE(fmts)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(n) :', SIZE(n)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(fmts) :', SIZE(fmts)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(n)==SIZE(fmts) failed at line 657 <gyre_util:join_fmts>'
    stop
  endif

    ! Join format strings with the appropriate repeat counts

    if(SUM(n) > 0) then

       do i = 1, SIZE(fmts)

          if(ALLOCATED(fmt)) then
             fmt = fmt//','//sprint(n(i))//fmts(i)
          else
             fmt = sprint(n(i))//fmts(i)
          endif

       end do

    else

       fmt = ''

    endif

    ! Add wrap-around parens

    fmt = '('//fmt//')'

    ! Finish

    return

  end function join_fmts

!****

  function sprint_ (i) result (a)

    integer, intent(in)       :: i
    character(:), allocatable :: a

    integer :: n

    ! Print an integer into a character

    ! First, determine the length

    if(i > 0) then
       n = FLOOR(LOG10(REAL(i))) + 1
    elseif(i < 0) then
       n = FLOOR(LOG10(REAL(ABS(i)))) + 2
    else
       n = 1
    endif

    allocate(character(n)::a)

    ! Do the conversion

    write(a, 100) i
100 format(I0)

    ! Finish

    return

  end function sprint_

!****

  function rjust (a, n) result (a_just)

    character(*), intent(in) :: a
    integer, intent(in)      :: n
    character(n)             :: a_just

    ! Right-justify a in a field width of n

    a_just = REPEAT(' ', MAX(n-LEN_TRIM(a), 0))//a

    ! Finish

    return

  end function rjust

!****

  function phase (z)

    complex(WP), intent(in) :: z
    real(WP)                :: phase

    ! Calculate the phase (in radians) of the complex number z

    phase = ATAN2(AIMAG(z), REAL(z))

    ! Finish

    return

  end function phase

!****

  function integrate_r_ (x, y) result (int_y)

    real(WP), intent(in)  :: x(:)
    real(WP), intent(in) :: y(:)
    real(WP)             :: int_y

    integer :: n

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 789 <gyre_util:integrate_r_>'
    stop
  endif

    ! Integrate y(x) using trapezoidal quadrature

    n = SIZE(x)

    int_y = SUM(0.5_WP*(y(2:) + y(:n-1))*(x(2:) - x(:n-1)))

    ! Finish

    return

  end function integrate_r_

  function integrate_c_ (x, y) result (int_y)

    real(WP), intent(in)  :: x(:)
    complex(WP), intent(in) :: y(:)
    complex(WP)             :: int_y

    integer :: n

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 790 <gyre_util:integrate_c_>'
    stop
  endif

    ! Integrate y(x) using trapezoidal quadrature

    n = SIZE(x)

    int_y = SUM(0.5_WP*(y(2:) + y(:n-1))*(x(2:) - x(:n-1)))

    ! Finish

    return

  end function integrate_c_

!****

  function integral_r_ (x, y) result (int_y)

    real(WP), intent(in)  :: x(:)
    real(WP), intent(in) :: y(:)
    real(WP)             :: int_y(SIZE(x))

    integer :: n
    integer :: i

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 828 <gyre_util:integral_r_>'
    stop
  endif

    ! Calculate the integral of y(x) using trapezoidal quadrature

    n = SIZE(x)

    int_y(1) = 0._WP

    int_loop : do i = 2, n
       int_y(i) = int_y(i-1) + 0.5_WP*(y(i) + y(i-1))*(x(i) - x(i-1))
    end do int_loop

    ! Finish

    return

  end function integral_r_

  function integral_c_ (x, y) result (int_y)

    real(WP), intent(in)  :: x(:)
    complex(WP), intent(in) :: y(:)
    complex(WP)             :: int_y(SIZE(x))

    integer :: n
    integer :: i

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 829 <gyre_util:integral_c_>'
    stop
  endif

    ! Calculate the integral of y(x) using trapezoidal quadrature

    n = SIZE(x)

    int_y(1) = 0._WP

    int_loop : do i = 2, n
       int_y(i) = int_y(i-1) + 0.5_WP*(y(i) + y(i-1))*(x(i) - x(i-1))
    end do int_loop

    ! Finish

    return

  end function integral_c_

end module gyre_util

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_hgroup gyre_trad_table core_constants ISO_FORTRAN_ENV core_kinds core_system
!   provides: gyre_trad
!end dependencies
!
!end fpx3_header
! Program  : gyre_trad
! Purpose  : traditional approximation support
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_trad

  ! Uses

  use core_kinds
  use core_constants
  use core_hgroup
  use core_system

  use gyre_trad_table

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Module variables

  type(trad_table_t), save :: tt_m

  ! Interfaces

  interface trad_lambda
     module procedure trad_lambda_r_
     module procedure trad_lambda_c_
  end interface trad_lambda

  ! Access specifiers

  private

  public :: init_trad
  public :: trad_lambda

  ! Procedures

contains

  subroutine init_trad ()

    type(hgroup_t) :: hg

    character(FILENAME_LEN) :: gyre_dir

    ! Load the trad_table_t from the data directory

!    call get_env('GYRE_DIR', gyre_dir)
    gyre_dir = '/Users/townsend/devel/gyre-4'

    print *,"Open:",TRIM(gyre_dir)//'/data/trad_table.h5'

    hg = hgroup_t(TRIM(gyre_dir)//'/data/trad_table.h5', OPEN_FILE)
    call read(hg, tt_m)
    call hg%final()

    ! Finish

    return

  end subroutine init_trad

!****

  function trad_lambda_r_ (nu, l, m) result (lambda)

    integer, intent(in)  :: l
    integer, intent(in)  :: m
    real(WP), intent(in) :: nu
    real(WP)             :: lambda

    ! Evaluate the eigenvalue of Laplace's tidal equation (real)

    lambda = tt_m%tf(l,m)%lambda(nu)

    ! Finish

    return

  end function trad_lambda_r_

!****

  function trad_lambda_c_ (nu, l, m) result (lambda)

    integer, intent(in)     :: l
    integer, intent(in)     :: m
    complex(WP), intent(in) :: nu
    complex(WP)             :: lambda

    ! Evaluate the eigenvalue of Laplace's tidal equation (complex)

    lambda = tt_m%tf(l,m)%lambda(nu)

    ! Finish

    return

  end function trad_lambda_c_

end module gyre_trad

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core_parallel.inc ../extern/core/core.inc
!   uses: core_kinds ISO_FORTRAN_ENV core_order core_linalg core_parallel core_hgroup
!   provides: core_spline
!end dependencies
!
!end fpx3_header
! Module   : core_spline
! Purpose  : spline interpolation

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

! Incfile  : core_parallel
! Purpose  : parallel support fpx3 macros

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_spline

  ! Uses

  use core_kinds

  use core_hgroup

  use core_parallel
  use core_order
  use core_linalg

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type spline_t
!     private
     real(WP), allocatable :: x(:)     ! Abscissa
     real(WP), allocatable :: y(:)     ! Ordinate
     real(WP), allocatable :: dy_dx(:) ! First derivatives
     integer               :: n        ! Number of points
   contains
     private
     procedure       :: interp_1_
     procedure       :: interp_v_
     procedure       :: interp_n_
     generic, public :: interp => interp_1_, interp_v_, interp_n_
     procedure       :: deriv_1_
     procedure       :: deriv_v_
     procedure       :: deriv_n_
     generic, public :: deriv => deriv_1_, deriv_v_, deriv_n_
     procedure       :: integ_n_
     generic, public :: integ => integ_n_
  end type spline_t

  ! Interfaces

  interface spline_t
     module procedure spline_t_
     module procedure spline_t_eval_derivs_
     module procedure spline_t_y_func_
  end interface spline_t

  interface read
     module procedure read_
  end interface read
  interface write
     module procedure write_
  end interface write

  ! Access specifiers

  private

  public :: spline_t

  public :: read
  public :: write

  ! Procedures

contains

  function spline_t_ (x, y, dy_dx) result (sp)

    real(WP), intent(in) :: x(:)
    real(WP), intent(in) :: y(:)
    real(WP), intent(in) :: dy_dx(:)
    type(spline_t)       :: sp

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 106 <core_spline:spline_t_>'
    stop
  endif

  if(SIZE(dy_dx)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(dy_dx) :', SIZE(dy_dx)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(dy_dx)==SIZE(x) failed at line 107 <core_spline:spline_t_>'
    stop
  endif

    ! Construct the spline_t

    sp%x = x
    sp%y = y

    sp%dy_dx = dy_dx

    sp%n = SIZE(x)

    ! Finish

    return

  end function spline_t_

!****

  function spline_t_eval_derivs_ (x, y, deriv_type, dy_dx_a, dy_dx_b) result (sp)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    character(*), intent(in)       :: deriv_type
    real(WP), optional, intent(in) :: dy_dx_a
    real(WP), optional, intent(in) :: dy_dx_b
    type(spline_t)                 :: sp

    real(WP) :: dy_dx(SIZE(x))

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 137 <core_spline:spline_t_eval_derivs_>'
    stop
  endif

    ! Construct the spline_t, with derivatives calculated according to
    ! deriv_type

    select case (deriv_type)
    case('NATURAL')
       dy_dx = natural_dy_dx_(x, y, dy_dx_a, dy_dx_b)
    case('FINDIFF')
       dy_dx = findiff_dy_dx_(x, y, dy_dx_a, dy_dx_b)
    case('MONO')
       dy_dx = mono_dy_dx_(x, y, dy_dx_a, dy_dx_b)
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 150 <core_spline:spline_t_eval_derivs_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid deriv_type'

  stop 'Program aborted'

    end select

    sp = spline_t(x, y, dy_dx)

    ! Finish

    return

  end function spline_t_eval_derivs_

!****

  function spline_t_y_func_ (x_a, x_b, y_func, y_tol, deriv_type, relative_tol, dy_dx_a, dy_dx_b) result (sp)

    real(WP), intent(in)           :: x_a
    real(WP), intent(in)           :: x_b
    interface
       function y_func (x) result (y)
         use core_kinds
         implicit none
         real(WP), intent(in) :: x
         real(WP)             :: y
       end function y_func
    end interface
    real(WP), optional, intent(in) :: y_tol
    character(*), intent(in)       :: deriv_type
    logical, optional, intent(in)  :: relative_tol
    real(WP), optional, intent(in) :: dy_dx_a
    real(WP), optional, intent(in) :: dy_dx_b
    type(spline_t)                 :: sp

    real(WP), parameter :: EPS = 4._WP*EPSILON(0._WP)

    logical               :: relative_tol_
    integer               :: n
    real(WP), allocatable :: x(:)
    real(WP), allocatable :: y(:)
    real(WP), allocatable :: x_dbl(:)
    real(WP), allocatable :: y_dbl(:)
    integer               :: j
    real(WP), allocatable :: err(:)
    real(WP), allocatable :: err_thresh(:)

    if (PRESENT(relative_tol)) then
       relative_tol_ = relative_tol
    else
       relative_tol_ = .FALSE.
    endif

    ! Construct the spline_t by sampling the function y(x) until the
    ! residuals drop below y_tol

    ! Initialize n to the smallest possible value

    n = 2

    x = [x_a,x_b]
    y = [y_func(x_a),y_func(x_b)]

    ! Now increase n until the desired tolerance is reached

    n_loop : do

       ! Construct the spline

       sp = spline_t(x, y, deriv_type, dy_dx_a=dy_dx_a, dy_dx_b=dy_dx_b)

       ! Calculate x and y at double the resolution

       allocate(x_dbl(2*n-1))
       allocate(y_dbl(2*n-1))

       x_dbl(1::2) = x
       x_dbl(2::2) = 0.5_WP*(x(:n-1) + x(2:))

       y_dbl(1::2) = y

       do j = 1, n-1
          y_dbl(2*j) = y_func(x_dbl(2*j))
       end do

       ! Examine how well the spline fits the double-res data

       err = ABS(sp%interp(x_dbl(2::2)) - y_dbl(2::2))

       if (relative_tol_) then
          err_thresh = (EPS + y_tol)*ABS(y_dbl(2::2))
       else
          err_thresh = EPS*ABS(y_dbl(2::2)) + y_tol
       endif

       if (ALL(err <= err_thresh)) exit n_loop

       ! Loop around

       call MOVE_ALLOC(x_dbl, x)
       call MOVE_ALLOC(y_dbl, y)

       n = 2*n-1

    end do n_loop

    ! Finish

    return

  end function spline_t_y_func_

!****

  subroutine read_ (hg, sp)

    type(hgroup_t), intent(inout) :: hg
    type(spline_t), intent(out)   :: sp

    real(WP), allocatable :: x(:)
    real(WP), allocatable :: y(:)
    real(WP), allocatable :: dy_dx(:)

    ! Read the spline_t

    call read_dset_alloc(hg, 'x', x)
    call read_dset_alloc(hg, 'y', y)
    call read_dset_alloc(hg, 'dy_dx', dy_dx)

    sp = spline_t(x, y, dy_dx)

    ! Finish

    return

  end subroutine read_

!****

  subroutine write_ (hg, sp)

    type(hgroup_t), intent(inout) :: hg
    type(spline_t), intent(in)    :: sp

    ! Write the spline_t

    call write_attr(hg, 'n', sp%n)

    call write_dset(hg, 'x', sp%x)
    call write_dset(hg, 'y', sp%y)
    call write_dset(hg, 'dy_dx', sp%dy_dx)

    ! Finish

    return

  end subroutine write_

!****

!****

  function interp_1_ (this, x) result (y)

    class(spline_t), intent(in) :: this
    real(WP), intent(in)        :: x
    real(WP)                    :: y

    real(WP) :: y_n(1)

    ! Interpolate y at a single point

    y_n = this%interp([x])

    y = y_n(1)

    ! Finish

    return

  end function interp_1_

!****

  function interp_v_ (this, x) result (y)

    class(spline_t), intent(in) :: this
    real(WP), intent(in)        :: x(:)
    real(WP)                    :: y(SIZE(x))

    integer  :: i
    integer  :: j
    real(WP) :: h
    real(WP) :: w

    ! Interpolate y at a vector of points

    i = 1

    x_loop : do j = 1,SIZE(x)

       ! Update the bracketing index

       call locate(this%x, x(j), i)

    if(.NOT. (i > 0 .AND. i < this%n)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < this%n'' failed at line 389 <core_spline:interp_v_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

       ! Set up the interpolation weights

       h = this%x(i+1) - this%x(i)
       w = (x(j) - this%x(i))/h

       ! Do the interpolation

       y(j) = this%y(i  )*phi_(1._WP-w) + &
              this%y(i+1)*phi_(w      ) - &
        h*this%dy_dx(i  )*psi_(1._WP-w) + &
        h*this%dy_dx(i+1)*psi_(w      )

    end do x_loop

    ! Finish

    return

  contains

    function phi_ (t)

      real(WP), intent(in) :: t
      real(WP)             :: phi_

      phi_ = 3._WP*t**2 - 2._WP*t**3

      return

    end function phi_

    function psi_ (t)

      real(WP), intent(in) :: t
      real(WP)             :: psi_

      psi_ = t**3 - t**2

      return

    end function psi_

  end function interp_v_

!****

  function interp_n_ (this) result (y)

    class(spline_t), intent(in) :: this
    real(WP)                    :: y(this%n)

    ! Interpolate y at abscissa points

    y = this%y

    ! Finish

  end function interp_n_

!****

  function deriv_1_ (this, x) result (dy_dx)

    class(spline_t), intent(in) :: this
    real(WP), intent(in)        :: x
    real(WP)                    :: dy_dx

    real(WP) :: dy_dx_n(1)

    ! Differentiate y at a single point

    dy_dx_n = this%deriv([x])

    dy_dx = dy_dx_n(1)

    ! Finish

    return

  end function deriv_1_

!****

  function deriv_v_ (this, x) result (dy_dx)

    class(spline_t), intent(in) :: this
    real(WP), intent(in)        :: x(:)
    real(WP)                    :: dy_dx(SIZE(x))

    integer  :: i
    integer  :: j
    real(WP) :: h
    real(WP) :: w

    ! Differentiate y at a vector of points

    i = 1

    x_loop : do j = 1,SIZE(x)

       ! Update the bracketing index

       call locate(this%x, x(j), i)

    if(.NOT. (i > 0 .AND. i < this%n)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i > 0 .AND. i < this%n'' failed at line 494 <core_spline:deriv_v_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Out-of-bounds interpolation'
      stop
    endif

       ! Set up the interpolation weights

       h = this%x(i+1) - this%x(i)
       w = (x(j) - this%x(i))/h

       ! Do the interpolation

       dy_dx(j) = -this%y(i  )*dphi_dt_(1._WP-w)/h + &
                   this%y(i+1)*dphi_dt_(w      )/h + &
               this%dy_dx(i  )*dpsi_dt_(1._WP-w) + &
               this%dy_dx(i+1)*dpsi_dt_(w      )

    end do x_loop

    ! Finish

    return

  contains

    function dphi_dt_ (t)

      real(WP), intent(in) :: t
      real(WP)             :: dphi_dt_

      dphi_dt_ = 6._WP*t - 6._WP*t**2

      return

    end function dphi_dt_

    function dpsi_dt_ (t)

      real(WP), intent(in) :: t
      real(WP)             :: dpsi_dt_

      dpsi_dt_ = 3._WP*t**2 - 2._WP*t

      return

    end function dpsi_dt_

  end function deriv_v_

!****

  function deriv_n_ (this) result (dy_dx)

    class(spline_t), intent(in) :: this
    real(WP)                    :: dy_dx(this%n)

    ! Differentiate y at abscissa points

    dy_dx = this%dy_dx

    ! Finish

    return

  end function deriv_n_

!****

  function integ_n_ (this) result (Y)

    class(spline_t), intent(in) :: this
    real(WP)                    :: Y(this%n)

    integer  :: i
    real(WP) :: h

    ! Calculate the integral of y

    Y(1) = 0._WP

    x_loop : do i = 1,this%n-1

       h = this%x(i+1) - this%x(i)

       Y(i+1) = Y(i) + (this%y(i) + this%y(i+1))*h/2._WP - &
                       (this%dy_dx(i+1) - this%dy_dx(i))*h**2/12._WP

    end do x_loop

    ! Finish

    return

  end function integ_n_

!****

  function natural_dy_dx_ (x, y, dy_dx_a, dy_dx_b) result (dy_dx)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    real(WP), intent(in), optional :: dy_dx_a
    real(WP), intent(in), optional :: dy_dx_b
    real(WP)                       :: dy_dx(SIZE(x))

    integer  :: n
    real(WP) :: h(SIZE(x)-1)
    real(WP) :: L(SIZE(x)-1)
    real(WP) :: D(SIZE(x))
    real(WP) :: U(SIZE(x)-1)
    real(WP) :: B(SIZE(x),1)
    integer  :: info

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 604 <core_spline:natural_dy_dx_>'
    stop
  endif

    ! Calcualte the first derivatives for a natural spline (ensuring
    ! the second derivatives are continuous)

    n = SIZE(x)

    h = x(2:) - x(:n-1)

    ! Set up the tridiagonal matrix and RHS

    ! Inner boundary

    D(1) = 1._WP
    U(1) = 0._WP

    if(PRESENT(dy_dx_a)) then
       B(1,1) = dy_dx_a
    else
       B(1,1) = (y(2) - y(1))/h(1)
    endif

    ! Internal points

    L(1:n-2) = 2._WP/h(1:n-2)
    D(2:n-1) = 4._WP/h(1:n-2) + 4._WP/h(2:n-1)
    U(2:n-1) = 2._WP/h(2:n-1)

    B(2:n-1,1) = -6._WP*y(1:n-2)/h(1:n-2)**2 + 6._WP*y(2:n-1)/h(1:n-2)**2 + &
                 6._WP*y(3:n  )/h(2:n-1)**2 - 6._WP*y(2:n-1)/h(2:n-1)**2

    ! Outer boundary

    L(n-1) = 0._WP
    D(n) = 1._WP

    if(PRESENT(dy_dx_b)) then
       B(n,1) = dy_dx_b
    else
       B(n,1) = (y(n) - y(n-1))/h(n-1)
    endif

    ! Solve the tridiagonal system

    call XGTSV(n, 1, L, D, U, B, SIZE(B, 1), info)

    if(.NOT. (info == 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''info == 0'' failed at line 649 <core_spline:natural_dy_dx_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-zero return from XTGSV'
      stop
    endif

    dy_dx = B(:,1)

    ! Finish

    return

  end function natural_dy_dx_

!****

  function findiff_dy_dx_ (x, y, dy_dx_a, dy_dx_b) result (dy_dx)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    real(WP), intent(in), optional :: dy_dx_a
    real(WP), intent(in), optional :: dy_dx_b
    real(WP)                       :: dy_dx(SIZE(x))

    integer  :: n
    real(WP) :: h(SIZE(x)-1)
    real(WP) :: s(SIZE(x)-1)

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 673 <core_spline:findiff_dy_dx_>'
    stop
  endif

    ! Calculate the first derivatives via centered finite differences

    n = SIZE(x)

    h = x(2:) - x(:n-1)

    s = (y(2:) - y(:n-1))/h

    if(PRESENT(dy_dx_a)) then
       dy_dx(1) = dy_dx_a
    else
       dy_dx(1) = s(1)
    endif

    dy_dx(2:n-1) = 0.5_WP*(s(1:n-2) + s(2:n-1))

    if(PRESENT(dy_dx_b)) then
       dy_dx(n) = dy_dx_b
    else
       dy_dx(n) = s(n-1)
    endif

    ! Finish

    return

  end function findiff_dy_dx_

!****

  function mono_dy_dx_ (x, y, dy_dx_a, dy_dx_b) result (dy_dx)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    real(WP), intent(in), optional :: dy_dx_a
    real(WP), intent(in), optional :: dy_dx_b
    real(WP)                       :: dy_dx(SIZE(x))

    integer  :: n
    real(WP) :: h(SIZE(x)-1)
    real(WP) :: s(SIZE(x)-1)
    real(WP) :: p(SIZE(x))
    integer  :: i

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 719 <core_spline:mono_dy_dx_>'
    stop
  endif

    ! Calculate the first derivatives using the Steffen (1990, A&A,
    ! 239, 443) monontonicity preserving algorithm

    n = SIZE(x)

    h = x(2:) - x(:n-1)

    s = (y(2:) - y(:n-1))/h

    ! Calculate parabolic gradients

    if(PRESENT(dy_dx_a)) then
       p(1) = dy_dx_a
    else
       p(1) = s(1)
    endif

    p(2:n-1) = (s(1:n-2)*h(2:n-1) + s(2:n-1)*h(1:n-2))/(h(1:n-2) + h(2:n-1))

    if(PRESENT(dy_dx_b)) then
       p(n) = dy_dx_b
    else
       p(n) = s(n-1)
    endif

    ! Calculate monotonic gradients

    dy_dx(1) = p(1)

    do i = 2,n-1
       dy_dx(i) = (SIGN(1._WP, s(i-1)) + SIGN(1._WP, s(i)))* &
                  MIN(ABS(s(i-1)), ABS(s(i)), 0.5*ABS(p(i)))
    end do

    dy_dx(n) = p(n)

    ! Finish

    return

  end function mono_dy_dx_

end module core_spline

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_order gyre_oscpar gyre_constants gyre_rot_factory gyre_rot gyre_gridpar gyre_model gyre_modepar gyre_util ISO_FORTRAN_ENV core_func core_kinds
!   provides: gyre_grid
!end dependencies
!
!end fpx3_header
! Module   : gyre_grid
! Purpose  : grid construction
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_grid

  ! Uses

  use core_kinds
  use gyre_constants
  use core_func
  use core_order

  use gyre_gridpar
  use gyre_model
  use gyre_modepar
  use gyre_oscpar
  use gyre_rot
  use gyre_rot_factory
  use gyre_util

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions (used internally for root-finding)

  type, extends (func_t) :: geom_func_t
     real(WP) :: s
     integer  :: n
   contains
     procedure :: eval_c_ => eval_geom_func_
  end type geom_func_t

  type, extends (func_t) :: gamma_func_t
     class(model_t), pointer     :: ml => null()
     class(r_rot_t), allocatable :: rt
     real(WP)                    :: omega
   contains
     procedure :: eval_c_ => eval_gamma_func_
  end type gamma_func_t

  ! Access specifiers

  private

  public :: build_grid
  public :: create_uniform
  public :: create_geom
  public :: create_log
  public :: find_x_turn

  ! Procedures

contains

  subroutine build_grid (gp, ml, mp, op, omega, x_in, x, verbose)

    type(gridpar_t), intent(in)         :: gp(:)
    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    real(WP), intent(in)                :: omega(:)
    real(WP), allocatable, intent(in)   :: x_in(:)
    real(WP), allocatable, intent(out)  :: x(:)
    logical, optional, intent(in)       :: verbose

    logical :: write_info
    integer :: n_in
    integer :: i

    if(.NOT. (SIZE(gp) >= 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(gp) >= 1'' failed at line 89 <gyre_grid:build_grid>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Empty gridpars'
      stop
    endif

    if(PRESENT(verbose)) then
       write_info = verbose .AND. check_log_level('INFO')
    else
       write_info = check_log_level('DEBUG')
    endif

    ! Build a grid using the supplied list of gridpars

    if(write_info) then

       write(OUTPUT_UNIT, 100) 'Building x grid'
100    format(A,1X,A)

    endif

    select case (gp(1)%op_type)
    case ('CREATE_CLONE')

    if(.NOT. (ALLOCATED(x_in))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x_in)'' failed at line 108 <gyre_grid:build_grid>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No grid to clone'
      stop
    endif

       x = x_in
    case ('CREATE_MIDPOINT')

    if(.NOT. (ALLOCATED(x_in))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x_in)'' failed at line 111 <gyre_grid:build_grid>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No grid to clone'
      stop
    endif

       n_in = SIZE(x_in)
       x = [x_in(1),0.5_WP*(x_in(:n_in-1)+x_in(2:)),x_in(n_in)]
    case ('CREATE_UNIFORM')
       call create_uniform(gp(1)%n, x)
    case ('CREATE_GEOM')
       call create_geom(gp(1)%s, gp(1)%n, x)
    case ('CREATE_LOG')
       call create_log(gp(1)%s, gp(1)%n, x)
    case ('CREATE_FROM_FILE')
       call create_from_file_(gp(1)%file, x)
    case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 123 <gyre_grid:build_grid>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid op_type (the first op_type must be CREATE_*)'

  stop 'Program aborted'

    end select

    if(write_info) then
          write(OUTPUT_UNIT, 110) 'x points :', SIZE(x), '[after', TRIM(gp(1)%op_type), 'op]'
110    format(2X,A,1X,I0,1X,A,1X,A,1X,A)
    endif

    gp_loop : do i = 2,SIZE(gp)

       select case (gp(i)%op_type)
       case ('RESAMP_DISPERSION')
          call resample_dispersion_(ml, mp, op, omega, gp(i)%alpha_osc, gp(i)%alpha_exp, x)
       case ('RESAMP_THERMAL')
          call resample_thermal_(ml, mp, op, omega, gp(i)%alpha_thm, x)
       case ('RESAMP_CENTER')
          call resample_center_(ml, mp, op, omega, gp(i)%n, x)
       case ('RESAMP_STRUCT')
          call resample_struct_(ml, gp(i)%alpha_str, x)
       case ('RESAMP_UNIFORM')
          call resample_uniform_(gp(i)%n, x)
       case default

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 145 <gyre_grid:build_grid>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Invalid op_type (the second and subsequent op_types must be RESAMPLE_*)'

  stop 'Program aborted'

       end select

       if(write_info) then
          write(OUTPUT_UNIT, 110) 'x points :', SIZE(x), '[after', TRIM(gp(i)%op_type), 'op]'
       endif

    end do gp_loop

    if(write_info) then

       write(OUTPUT_UNIT, 120) 'x range  :', MINVAL(x), '->', MAXVAL(x)
120    format(2X,A,E24.16,1X,A,1X,E24.16)

       write(OUTPUT_UNIT, *)

    endif

    ! Finish

    return

  end subroutine build_grid

!****

  subroutine create_uniform (n, x)

    integer, intent(in)                :: n
    real(WP), allocatable, intent(out) :: x(:)

    integer :: i

    ! Create an n-point grid with uniform spacing across the [0,1]
    ! interval

    allocate(x(n))

    x(1) = 0._WP

    grid_loop : do i = 2,n-1
       x(i) = (i-1._WP)/(n-1._WP)
    end do grid_loop

    x(n) = 1._WP

    ! Finish

    return

  end subroutine create_uniform

!****

  subroutine create_geom (s, n, x)

    real(WP), intent(in)               :: s
    integer, intent(in)                :: n
    real(WP), allocatable, intent(out) :: x(:)

    integer           :: m
    real(WP)          :: g_a
    real(WP)          :: g_b
    real(WP)          :: g
    type(geom_func_t) :: gf
    real(WP)          :: dx
    integer           :: k

    ! Create an n-point grid with geometric spacing in each half of the
    ! [0,1] interval. The parameter s controls the ratio between the
    ! boundary cell size and the average cell size 1/(n-1)

    allocate(x(n))

    if(MOD(n, 2) == 0) then

       ! Even number of grid points / odd number of cells

       ! Solve for the growth factor g. The upper bound is derived
       ! by applying a Taylor expansion to the equation for g

       m = n/2-1

       gf%n = n
       gf%s = s

       g_a = EPSILON(0._WP)
       g_b = (s*(n-1)-2*m-1)/m

       g = gf%root(g_a, g_b, 0._WP)

       ! Set up the inner part of the grid

       x(1) = 0._WP
       dx = 1._WP/(s*(n-1))

       even_grid_loop : do k = 1,m
          x(k+1) = x(k) + dx
          dx = (1._WP+g)*dx
       end do even_grid_loop

       ! Reflect to get the outer part of the grid

       x(m+2:) = 1._WP - x(m+1:1:-1)

    else

       ! Odd number of grid points / even number of cells

       ! Solve for the growth factor g. The upper bound is derived
       ! by applying a Taylor expansion to the equation for g

       m = (n-1)/2

       gf%n = n
       gf%s = s

       g_a = EPSILON(0._WP)
       g_b = (s*(n-1)-2*m)/(m*(m-1))

       g = gf%root(g_a, g_b, 0._WP)

       ! Set up the inner part of the grid

       x(1) = 0._WP
       dx = 1._WP/(s*(n-1))

       odd_grid_loop : do k = 1,m-1
          x(k+1) = x(k) + dx
          dx = (1._WP+g)*dx
       end do odd_grid_loop

       ! Reflect to get the outer part of the grid

       x(m+1:) = 0.5_WP

       x(m+2:) = 1._WP - x(m:1:-1)

    end if

    ! Finish

    return

  end subroutine create_geom

!****

  function eval_geom_func_ (this, z) result (f_z)

    class(geom_func_t), intent(inout) :: this
    complex(WP), intent(in)           :: z
    complex(WP)                       :: f_z

    real(WP) :: g
    integer  :: m

    ! Calcuate the discriminant for the geom grid growth factor

    g = REAL(z)

    if(MOD(this%n, 2) == 0) then

       m = this%n/2-1

       if(1._WP+g > HUGE(0._WP)**(1._WP/m)) then
          f_z = - (2._WP + g)
       else
          f_z = (2._WP + this%s*(this%n-1)*g)/(1._WP + g)**m - (2._WP + g)
       endif

    else

       m = (this%n-1)/2

       if(1._WP+g > HUGE(0._WP)**(1._WP/m)) then
          f_z = -2._WP
       else
          f_z = (2._WP + this%s*(this%n-1)*g)/(1._WP + g)**m - 2._WP
       endif

    endif

    ! Finish

    return

  end function eval_geom_func_

!****

  subroutine create_log (s, n, x)

    real(WP), intent(in)               :: s
    integer, intent(in)                :: n
    real(WP), allocatable, intent(out) :: x(:)

    real(WP) :: dx_1
    integer  :: k
    real(WP) :: w
    real(WP) :: t

    ! Create an n-point grid with logarithmic spacing in each half of
    ! the [0,1] interval. The parameter s controls the ratio between
    ! the mean cell size and the boundary cell size. omega is not used

    allocate(x(n))

    dx_1 = 1._WP/(s*(n-1))

    if(MOD(n, 2) == 0) then

       ! Even number of grid points / odd number of cells

       ! Set up the inner part of the grid

       x(1) = 0._WP

       even_grid_loop : do k = 2,n/2

          w = (k-1.5_WP)/(n/2-1.5_WP)
          t = LOG(0.5_WP)*(1._WP-w) + LOG(dx_1)*w

          x(n/2-k+2) = EXP(t)

       enddo even_grid_loop

       ! Reflect to get the outer part of the grid

       x(n/2+1:) = 1._WP - x(n/2:1:-1)

    else

       ! Odd number of grid points / even number of cells

       ! Set up the inner part of the grid

       x(1) = 0._WP

       odd_grid_loop : do k = 2,(n-1)/2

          w = (k-1._WP)/((n-1)/2-1._WP)
          t = LOG(0.5_WP)*(1._WP-w) + LOG(dx_1)*w

          x((n-1)/2-k+2) = EXP(t)

       end do odd_grid_loop

       x((n+1)/2) = 0.5_WP

       ! Reflect to get the outer part of the grid

       x((n+1)/2+1:) = 1._WP - x((n-1)/2:1:-1)

    end if

    ! Finish

    return

  end subroutine create_log

!****

  subroutine create_from_file_ (file, x)

    character(LEN=*), intent(in)       :: file
    real(WP), allocatable, intent(out) :: x(:)

    integer :: unit
    integer :: n
    integer :: k

    ! Create a grid by reading from the file

    ! Count lines

    open(NEWUNIT=unit, FILE=file, STATUS='OLD')

    n = 0

    count_loop : do
       read(unit, *, END=100)
       n = n + 1
    end do count_loop

100 continue

    ! Read data

    rewind(unit)

    allocate(x(n))

    read_loop : do k = 1,n
       read(unit, *) x(k)
    end do read_loop

    close(unit)

    ! Finish

    return

  end subroutine create_from_file_

!****

  subroutine resample_ (x, dn)

    real(WP), allocatable, intent(inout) :: x(:)
    integer, intent(in)                  :: dn(:)

    integer               :: n
    real(WP), allocatable :: x_new(:)
    integer               :: i
    integer               :: j
    integer               :: k

  if(SIZE(dn)/= SIZE(x)-1) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(dn) :', SIZE(dn)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x)-1 :', SIZE(x)-1
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(dn)==SIZE(x)-1 failed at line 464 <gyre_grid:resample_>'
    stop
  endif

    ! Resample x by inserting dn additional points across the cells

    n = SIZE(x)

    allocate(x_new(SUM(dn) + n))

    k = 1

    do i = 1,n-1
       do j = 1,dn(i)+1
          x_new(k) = x(i) + (j-1)*(x(i+1)-x(i))/(dn(i)+1)
          k = k + 1
       end do
    end do

    x_new(k) = x(n)

    call MOVE_ALLOC(x_new, x)

    ! Finish

    return

  end subroutine resample_

!****

  subroutine resample_dispersion_ (ml, mp, op, omega, alpha_osc, alpha_exp, x)

    class(model_t), pointer, intent(in)  :: ml
    type(modepar_t), intent(in)          :: mp
    type(oscpar_t), intent(in)           :: op
    real(WP), intent(in)                 :: omega(:)
    real(WP), intent(in)                 :: alpha_osc
    real(WP), intent(in)                 :: alpha_exp
    real(WP), allocatable, intent(inout) :: x(:)

    class(r_rot_t), allocatable :: rt
    integer                     :: n_x
    real(WP), allocatable       :: k_r_max(:)
    real(WP), allocatable       :: k_i_max(:)
    integer                     :: i
    integer                     :: j
    real(WP)                    :: omega_c
    real(WP)                    :: lambda
    real(WP)                    :: l_0
    real(WP)                    :: g_4
    real(WP)                    :: g_2
    real(WP)                    :: g_0
    real(WP)                    :: gamma
    integer, allocatable        :: dn(:)
    real(WP)                    :: dphi_osc
    real(WP)                    :: dphi_exp

    if(.NOT. (ALLOCATED(x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x)'' failed at line 520 <gyre_grid:resample_dispersion_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No input grid'
      stop
    endif

    ! Resample x by adding points to each cell, such that there are at
    ! least alpha_osc points per oscillatory wavelength and alpha_exp
    ! points per exponential wavelength.
    !
    ! Wavelengths are calculated based on a local dispersion analysis
    ! of the adibatic/Cowling wave equation, for inertial frequencies
    ! specified by omega

    allocate(rt, SOURCE=r_rot_t(ml, mp, op))

    ! At each point of x, determine the maximum absolute value of the
    ! real and imaginary parts of the local wavenumber

    n_x = SIZE(x)

    allocate(k_r_max(n_x))
    allocate(k_i_max(n_x))

    k_r_max(1) = 0._WP
    k_i_max(1) = 0._WP

    wavenumber_loop : do i = 2,n_x-1

       associate (V_g => ml%V(x(i))/ml%Gamma_1(x(i)), As => ml%As(x(i)), &
                  U => ml%U(x(i)), c_1 => ml%c_1(x(i)))

         k_r_max(i) = 0._WP
         k_i_max(i) = 0._WP

         omega_loop : do j = 1, SIZE(omega)

            omega_c = rt%omega_c(x(i), omega(j))

            lambda = rt%lambda(x(i), omega(j))
            l_0 = rt%l_0(omega(j))

            ! Calculate the propagation discriminant gamma

            g_4 = -4._WP*V_g*c_1
            g_2 = (As - V_g - U + 4._WP)**2 + 4._WP*V_g*As + 4._WP*lambda
            g_0 = -4._WP*lambda*As/c_1

            gamma = (g_4*omega_c**4 + g_2*omega_c**2 + g_0)/omega_c**2

            ! Update the wavenumber maxima

            if (gamma < 0._WP) then

               ! Propagation zone

               k_r_max(i) = MAX(k_r_max(i), ABS(0.5_WP*SQRT(-gamma))/x(i))
               k_i_max(i) = MAX(k_i_max(i), ABS(0.5_WP*(As + V_g - U + 2._WP - 2._WP*l_0))/x(i))

            else

               ! Evanescent zone

               k_i_max(i) = MAX(k_i_max(i), ABS(0.5_WP*(As + V_g - U + 2._WP - 2._WP*l_0 - SQRT(gamma)))/x(i), &
                                            ABS(0.5_WP*(As + V_g - U + 2._WP - 2._WP*l_0 + SQRT(gamma)))/x(i))

            end if

         end do omega_loop

       end associate

    end do wavenumber_loop

    k_r_max(n_x) = 0._WP
    k_i_max(n_x) = 0._WP

    ! Determine how many points to add to each cell

    allocate(dn(n_x-1))

    sample_loop : do i = 1,n_x-1

       ! Calculate the oscillatory and exponential phase change across
       ! the cell

       dphi_osc = MAX(k_r_max(i), k_r_max(i+1))*(x(i+1) - x(i))
       dphi_exp = MAX(k_i_max(i), k_i_max(i+1))*(x(i+1) - x(i))

       ! Set up dn

       dn(i) = MAX(FLOOR((alpha_osc*dphi_osc)/TWOPI), FLOOR((alpha_exp*dphi_exp)/TWOPI))

    end do sample_loop

    ! Perform the resampling

    call resample_(x, dn)

    ! Finish

    return

  end subroutine resample_dispersion_

!****

  subroutine resample_thermal_ (ml, mp, op, omega, alpha_thm, x)

    class(model_t), pointer, intent(in)  :: ml
    type(modepar_t), intent(in)          :: mp
    type(oscpar_t), intent(in)           :: op
    real(WP), intent(in)                 :: omega(:)
    real(WP), intent(in)                 :: alpha_thm
    real(WP), allocatable, intent(inout) :: x(:)

    class(r_rot_t), allocatable :: rt
    integer                     :: n_x
    real(WP), allocatable       :: k_t_max(:)
    integer                     :: i
    integer                     :: j
    real(WP)                    :: omega_c
    integer, allocatable        :: dn(:)
    real(WP)                    :: dphi_thm

    if(.NOT. (ALLOCATED(x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x)'' failed at line 641 <gyre_grid:resample_thermal_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No input grid'
      stop
    endif

    ! Resample x by adding points to each cell, such that there are at
    ! least alpha_thm points per thermal length c_thm

    allocate(rt, SOURCE=r_rot_t(ml, mp, op))

    ! At each point of x, determine the maximum absolute value of the
    ! local thermal wavenumber

    n_x = SIZE(x)

    allocate(k_t_max(n_x))

    k_t_max(1) = 0._WP

    wavenumber_loop : do i = 2,n_x-1

       associate(V => ml%V(x(i)), nabla => ml%nabla(x(i)), &
                c_rad => ml%c_rad(x(i)), c_thm => ml%c_thm(x(i)))

         k_t_max(i) = 0._WP

         omega_loop : do j = 1, SIZE(omega)

            omega_c = rt%omega_c(x(i), omega(j))

            k_t_max(i) = MAX(k_t_max(i), SQRT(ABS(V*nabla*omega_c*c_thm/c_rad))/x(i))

         end do omega_loop

       end associate

    end do wavenumber_loop

    k_t_max(n_x) = 0._WP

    ! Determine how many points to add to each cell

    allocate(dn(n_x-1))

    sample_loop : do i = 1,n_x-1

       ! Calculate the thermal phase change across the cell

       dphi_thm = MAX(k_t_max(i), k_t_max(i+1))*(x(i+1) - x(i))

       ! Set up dn

       dn(i) = FLOOR((alpha_thm*dphi_thm)/TWOPI)

    end do sample_loop

    ! Perform the resampling

    call resample_(x, dn)

    ! Finish

    return

  end subroutine resample_thermal_

!****

  subroutine resample_center_ (ml, mp, op, omega, n, x)

    class(model_t), pointer,  intent(in) :: ml
    type(modepar_t), intent(in)          :: mp
    type(oscpar_t), intent(in)           :: op
    real(WP), intent(in)                 :: omega(:)
    integer, intent(in)                  :: n
    real(WP), allocatable, intent(inout) :: x(:)

    real(WP)             :: x_turn
    integer              :: j
    real(WP)             :: x_turn_j
    integer              :: i_turn
    integer              :: n_x
    integer, allocatable :: dn(:)

    if(.NOT. (ALLOCATED(x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x)'' failed at line 722 <gyre_grid:resample_center_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No input grid'
      stop
    endif

    ! Resample x by adding points to central cells, such that there
    ! are n_floor points covering the evanescent region at the
    ! center. Evanescence is determined based on a local dispersion
    ! analysis of the adibatic/Cowling wave equation, for frequencies
    ! in the interval [omega_min,omega_max]

    ! First, locate the innermost turning point

    x_turn = HUGE(0._WP)

    omega_loop : do j = 1, SIZE(omega)
       call find_x_turn(x, ml, mp, op, omega(j), x_turn_j)
       x_turn = MIN(x_turn, x_turn_j)
    end do omega_loop

    call locate(x, x_turn, i_turn)

    ! Determine how many points to add to each cell

    n_x = SIZE(x)

    allocate(dn(n_x-1))

    dn = 0

    if(i_turn >= 1 .AND. i_turn < n_x) then
       dn(:i_turn) = CEILING(n*x(i_turn+1)/x_turn/i_turn)
    endif

    ! Perform the resampling

    call resample_(x, dn)

    ! Finish

    return

  end subroutine resample_center_

!****

  subroutine resample_struct_ (ml, alpha_str, x)

    class(model_t), pointer, intent(in)  :: ml
    real(WP), intent(in)                 :: alpha_str
    real(WP), allocatable, intent(inout) :: x(:)

    integer :: dn(SIZE(x)-1)
    integer :: i

    if(.NOT. (ALLOCATED(x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x)'' failed at line 774 <gyre_grid:resample_struct_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No input grid'
      stop
    endif

    ! Resample x by adding points to each cell, such that there are at
    ! least alpha_str points per dex change in the structure variables (V,
    ! As, Gamma_1, c_1, & U)

    ! Calculate the number of points to add to each cell

    dn = 0

    cell_loop : do i = 1, SIZE(x)-1

       dn(i) = dn(i) + FLOOR(alpha_str*dlog_(ml%V(x(i)), ml%V(x(i+1)))) + &
                       FLOOR(alpha_str*dlog_(ml%As(x(i)), ml%V(x(i+1)))) + &
                       FLOOR(alpha_str*dlog_(ml%Gamma_1(x(i)), ml%Gamma_1(x(i+1)))) + &
                       FLOOR(alpha_str*dlog_(ml%c_1(x(i)), ml%c_1(x(i+1)))) + &
                       FLOOR(alpha_str*dlog_(ml%U(x(i)), ml%U(x(i+1))))

    end do cell_loop

    ! Perform the resampling

    call resample_(x, dn)

    ! Finish

    return

  contains

    function dlog_ (y_a, y_b) result (dlog)

      real(WP), intent(in) :: y_a
      real(WP), intent(in) :: y_b
      real(WP)             :: dlog

      ! Calculate the logarithmic change between y_a and y_b

      if ((y_a > 0._WP .AND. y_b > 0._WP) .OR. &
          (y_a < 0._WP .AND. y_b < 0._WP)) then
         dlog = ABS(LOG10(y_b/y_a))
      else
         dlog = 0._WP
      endif

      ! Finish

      return

    end function dlog_

  end subroutine resample_struct_

!****

  subroutine resample_uniform_ (n, x)

    integer, intent(in)                  :: n
    real(WP), allocatable, intent(inout) :: x(:)

    integer              :: n_x
    integer, allocatable :: dn(:)

    if(.NOT. (ALLOCATED(x))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALLOCATED(x)'' failed at line 837 <gyre_grid:resample_uniform_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No input grid'
      stop
    endif

    ! Resample x by adding n points to each cell

    n_x = SIZE(x)

    allocate(dn(n_x-1))

    dn = n

    ! Perform the resampling

    call resample_(x, dn)

    ! Finish

    return

  end subroutine resample_uniform_

!****

  subroutine find_x_turn (x, ml, mp, op, omega, x_turn)

    real(WP), intent(in)                :: x(:)
    class(model_t), pointer, intent(in) :: ml
    type(modepar_t), intent(in)         :: mp
    type(oscpar_t), intent(in)          :: op
    real(WP), intent(in)                :: omega
    real(WP)                            :: x_turn

    type(gamma_func_t) :: gf
    integer            :: i

    ! Find the inner turning point at frequency omega

    x_turn = HUGE(0._WP)

    gf%ml => ml
    allocate(gf%rt, SOURCE=r_rot_t(ml, mp, op))

    gf%omega = omega

    turn_loop : do i = 1,SIZE(x)-1
       if(.NOT. (ml%is_zero(x(i)) .OR. ml%is_zero(x(i+1)))) then
          if(gf%eval(x(i)) > 0._WP .AND. gf%eval(x(i+1)) <= 0._WP) then
             x_turn = gf%root(x(i), x(i+1), 0._WP)
             exit turn_loop
          end if
       endif
    end do turn_loop

    ! Finish

    return

  end subroutine find_x_turn

!****

  function eval_gamma_func_ (this, z) result (gamma)

    class(gamma_func_t), intent(inout) :: this
    complex(WP), intent(in)            :: z
    complex(WP)                        :: gamma

    real(WP) :: x
    real(WP) :: g_4
    real(WP) :: g_2
    real(WP) :: g_0

    ! Calculate the propagation discriminant

    x = REAL(z)

    associate(V_g => this%ml%V(x)/this%ml%Gamma_1(x), As => this%ml%As(x), &
              U => this%ml%U(x), c_1 => this%ml%c_1(x), &
              lambda => this%rt%lambda(x, this%omega))

      g_4 = -4._WP*V_g*c_1
      g_2 = (As - V_g - U + 4._WP)**2 + 4._WP*V_g*As + 4._WP*lambda
      g_0 = -4._WP*lambda*As/c_1

      gamma = (g_4*this%omega**4 + g_2*this%omega**2 + g_0)/this%omega**2

    end associate

    ! Finish

    return

  end function eval_gamma_func_

end module gyre_grid

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: gyre_model ISO_FORTRAN_ENV core_kinds
!   provides: gyre_atmos
!end dependencies
!
!end fpx3_header
! Module   : gyre_atmos
! Purpose  : atmosphere utility routines
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_atmos

  ! Uses

  use core_kinds

  use gyre_model

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Interfaces

  interface atmos_beta
     module procedure atmos_beta_r_
     module procedure atmos_beta_c_
  end interface atmos_beta

  ! Access specifiers

  private

  public :: atmos_beta
  public :: eval_atmos_cutoff_freqs
  public :: eval_atmos_coeffs_unno
  public :: eval_atmos_coeffs_jcd

  ! Procedures

contains

  function atmos_beta_r_ (V_g, As, c_1, omega, lambda) result (beta)

    real(WP)             :: V_g
    real(WP), intent(in) :: As
    real(WP), intent(in) :: c_1
    real(WP), intent(in) :: omega
    real(WP), intent(in) :: lambda
    real(WP)             :: beta

    real(WP)      :: psi2
    logical, save :: warned = .FALSE.

    ! Calculate the atmospheric radial wavenumber, as defined by
    ! [Tow2000b] (real frequencies)

    psi2 = (As - V_g + 4._WP)**2 + 4._WP*(lambda/(c_1*omega**2) - V_g)*(c_1*omega**2 - As)

    if (psi2 < 0._WP) then

       if (.NOT. warned) then

    write(UNIT=ERROR_UNIT, FMT=*) 'INFO at line 74 <gyre_atmos:atmos_beta_r_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'WARNING: Discarding imaginary part of atmospheric radial wavenumber'

          warned = .TRUE.
       endif

       beta = 0.5_WP*(V_g + As - 2._WP)

    else

       beta = 0.5_WP*(V_g + As - 2._WP - SQRT(psi2))

    endif

    ! Finish

    return

  end function atmos_beta_r_

!****

  function atmos_beta_c_ (V_g, As, c_1, omega, lambda) result (beta)

    real(WP)                :: V_g
    real(WP), intent(in)    :: As
    real(WP), intent(in)    :: c_1
    complex(WP), intent(in) :: omega
    complex(WP), intent(in) :: lambda
    complex(WP)             :: beta

    complex(WP) :: psi2
    complex(WP) :: psi

    ! Calculate the atmospheric radial wavenumber, as defined by
    ! [Tow2000b] (complex frequencies)

    psi2 = (As - V_g + 4._WP)**2 + 4._WP*(lambda/(c_1*omega**2) - V_g)*(c_1*omega**2 - As)
    psi = SQRT(psi2)

    ! Adjust the sign of psi to choose the correct solution

    if (AIMAG(omega) > 0._WP) then

       ! Decaying mode; choose the solution with diverging energy density

       if (REAL(psi) < 0._WP) psi = -psi

    elseif (AIMAG(omega) < 0._WP) then

       ! Growing mode; choose the solution with non-diverging energy
       ! density

       if (REAL(psi) > 0._WP) psi = -psi

    else

       ! Steady-state mode;

    if(.NOT. (AIMAG(psi2) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''AIMAG(psi2) == 0._WP'' failed at line 131 <gyre_atmos:atmos_beta_c_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Steady-state mode with complex propagation discriminant'
      stop
    endif

       if (REAL(psi2) > 0._WP) then

          ! Evanescent wave; choose the solution with non-diverging
          ! energy density

          psi = -psi

       else

          if (REAL(c_1*omega**2) < As) then

             ! Gravity wave; choose the solution with downward phase
             ! velocity

             if (AIMAG(psi) < 0._WP) psi = -psi

          else

             ! Acoustic wave; choose the solution with upward phase
             ! velocity

             if (AIMAG(psi) > 0._WP) psi = -psi

          end if

       end if

    end if

    beta = 0.5_WP*(V_g + As - 2._WP + psi)

    ! Finish

    return

  end function atmos_beta_c_

!****

  subroutine eval_atmos_cutoff_freqs (V_g, As, c_1, lambda, omega_cutoff_lo, omega_cutoff_hi)

    real(WP), intent(in)  :: V_g
    real(WP), intent(in)  :: As
    real(WP), intent(in)  :: c_1
    real(WP), intent(in)  :: lambda
    real(WP), intent(out) :: omega_cutoff_lo
    real(WP), intent(out) :: omega_cutoff_hi

    real(WP) :: a
    real(WP) :: b
    real(WP) :: c

    ! Evaluate the atmospheric cutoff frequencies from the supplied coefficients

    a = -4._WP*V_g*c_1**2
    b = ((As - V_g + 4._WP)**2 + 4._WP*V_g*As + 4._WP*lambda)*c_1
    c = -4._WP*lambda*As

    omega_cutoff_lo = SQRT((-b + SQRT(b**2 - 4._WP*a*c))/(2._WP*a))
    omega_cutoff_hi = SQRT((-b - SQRT(b**2 - 4._WP*a*c))/(2._WP*a))

    if(.NOT. (omega_cutoff_hi >= omega_cutoff_lo)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''omega_cutoff_hi >= omega_cutoff_lo'' failed at line 194 <gyre_atmos:eval_atmos_cu' &
 & // 'toff_freqs>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Incorrect cutoff frequency ordering'
      stop
    endif

    ! Finish

    return

  end subroutine eval_atmos_cutoff_freqs

!****

  subroutine eval_atmos_coeffs_unno (ml, x_o, V_g, As, c_1)

    class(model_t), intent(in) :: ml
    real(WP), intent(in)       :: x_o
    real(WP), intent(out)      :: V_g
    real(WP), intent(out)      :: As
    real(WP), intent(out)      :: c_1

    ! Evaluate atmosphere coefficients (Unno et al. formulation)

    V_g = ml%V(x_o)/ml%Gamma_1(x_o)
    As = ml%As(x_o)
    c_1 = ml%c_1(x_o)

    ! Finish

    return

  end subroutine eval_atmos_coeffs_unno

!****

  subroutine eval_atmos_coeffs_jcd (ml, x_o, V_g, As, c_1)

    class(model_t), intent(in) :: ml
    real(WP), intent(in)       :: x_o
    real(WP), intent(out)      :: V_g
    real(WP), intent(out)      :: As
    real(WP), intent(out)      :: c_1

    ! Evaluate atmosphere coefficients (JCD formulation)

    V_g = ml%V(x_o)/ml%Gamma_1(x_o)
    As = ml%V(x_o)*(1._WP-1._WP/ml%Gamma_1(x_o))
    c_1 = ml%c_1(x_o)

    ! Finish

    return

  end subroutine eval_atmos_coeffs_jcd

end module gyre_atmos

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_order core_parallel core_kinds ISO_FORTRAN_ENV
!   provides: gyre_cocache
!end dependencies
!
!end fpx3_header
! Module   : gyre_cocache
! Purpose  : coefficients cache
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_cocache

  ! Uses

  use core_kinds
  use core_parallel
  use core_order

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: cocache_t
     private
     real(WP), allocatable :: x(:)
     real(WP), allocatable :: c(:,:)
     integer               :: n
     integer               :: n_c
   contains
     private
     procedure, public :: lookup => lookup_
  end type cocache_t

  ! Interfaces

  interface cocache_t
     module procedure cocache_t_
  end interface cocache_t

  ! Access specifiers

  private

  public :: cocache_t

contains

  function cocache_t_ (x, c) result (cc)

    real(WP), intent(in) :: x(:)
    real(WP), intent(in) :: c(:,:)
    type(cocache_t)      :: cc

    integer, allocatable :: i(:)

  if(SIZE(c, 2)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(c, 2) :', SIZE(c, 2)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(c, 2)==SIZE(x) failed at line 78 <gyre_cocache:cocache_t_>'
    stop
  endif

    ! Construct the cocache_t

    i = unique_indices(x)

    cc%x = x(i)
    cc%c = c(:,i)

    cc%n = SIZE(i)
    cc%n_c = SIZE(c, 1)

    ! Finish

    return

  end function cocache_t_

!****

!****

  function lookup_ (this, j, x) result (c)

    class(cocache_t), intent(in) :: this
    integer, intent(in)          :: j
    real(WP), intent(in)         :: x
    real(WP)                     :: c

    integer :: k

    if(.NOT. (j >= 1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''j >= 1'' failed at line 132 <gyre_cocache:lookup_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid index'
      stop
    endif

    if(.NOT. (j <= this%n_c)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''j <= this%n_c'' failed at line 133 <gyre_cocache:lookup_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid index'
      stop
    endif

    ! Find where x falls in the cache

    call locate_(this%x, x, k)

    ! Lookup the coeff

    c = this%c(j,k)

    ! Finish

    return

  contains

    subroutine locate_ (x, x_loc, i_loc)

      real(WP), intent(in) :: x(:)
      real(WP), intent(in) :: x_loc
      integer, intent(out) :: i_loc

      integer       :: n
      integer, save :: i_lo
      integer, save :: i_hi
      integer       :: di
      integer       :: i_mid

      !$OMP THREADPRIVATE (i_lo, i_hi)

      ! Use a binary search to find where x_loc falls in x (assumed to
      ! be in ascending order); x(i_loc) == x_loc

      n = SIZE(x)

      if(x_loc == x(n)) then

         i_loc = n

      elseif(x_loc == x(1)) then

         i_loc = 1

      else

         if(i_lo < 1 .OR. i_lo >= n) then

            i_lo = 0
            i_hi = n+1

         else

            di = 1

            if(x_loc >= x(i_lo)) then

               search_up_loop : do

                  i_hi = i_lo + di

                  if(i_hi > n) then
                     i_hi = n + 1
                     exit search_up_loop
                  endif

                  if(x_loc < x(i_hi)) exit search_up_loop

                  i_lo = i_hi
                  di = 2*di

               end do search_up_loop

            else

               search_down_loop : do

                  i_hi = i_lo
                  i_lo = i_hi - di

                  if(i_lo < 1) then
                     i_lo = 0
                     exit search_down_loop
                  endif

                  if(x_loc >= x(i_lo)) exit search_down_loop

               end do search_down_loop

            endif

         endif

         refine_loop : do

            if(i_hi-i_lo <= 1) exit refine_loop

            i_mid = (i_hi + i_lo)/2

            if(x_loc >= x(i_mid)) then
               i_lo = i_mid
            else
               i_hi = i_mid
            endif

         end do refine_loop

         i_loc = i_lo

      endif

    if(.NOT. (x(i_loc) == x_loc)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''x(i_loc) == x_loc'' failed at line 243 <gyre_cocache:lookup_:locate_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Value not found in cache'
      stop
    endif

      ! Finish

      return

    end subroutine locate_

  end function lookup_

end module gyre_cocache

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc ../extern/core/core_parallel.inc
!   uses: core_kinds core_parallel
!   provides: gyre_scanpar
!end dependencies
!
!end fpx3_header
! Module   : gyre_scanpar
! Purpose  : frequency scan parameters
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

! Incfile  : core_parallel
! Purpose  : parallel support fpx3 macros

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_scanpar

  ! Uses

  use core_kinds
  use core_parallel

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: scanpar_t
     real(WP)        :: freq_min
     real(WP)        :: freq_max
     integer         :: n_freq
     character(64)   :: grid_type
     character(64)   :: freq_units
     character(64)   :: freq_frame
     character(2048) :: tag_list
  end type scanpar_t

  ! Interfaces

  ! Access specifiers

  private

  public :: scanpar_t

  ! Procedures

contains

end module gyre_scanpar

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_order f95_lapack ISO_FORTRAN_ENV core_linalg core_kinds
!   provides: astro_hough
!end dependencies
!
!end fpx3_header
! Module  : astro_hough
! Purpose : calculation of Hough eigenvalues & eigenfunctions, incl. hough_t type
! Notes   : This code adopts the sign convention m*nu > 0 for prograde modes

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module astro_hough

  ! Uses

  use core_kinds
  use core_linalg
  use core_order

  use f95_lapack

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: hough_t
     private
     real(WP), allocatable :: b(:)
     real(WP), allocatable :: c_r(:)
     real(WP), allocatable :: c_t(:)
     real(WP), allocatable :: c_p(:)
     real(WP), public      :: lambda
     real(WP), public      :: nu
     integer, public       :: m
     integer, public       :: k
     integer               :: n
   contains
     private
     procedure, public :: Theta => Theta_
     procedure, public :: Theta_xi => Theta_xi_
  end type hough_t

  ! Interfaces

  interface hough_t
     module procedure hough_t_n_
     module procedure hough_t_tol_
  end interface hough_t

  interface lambda
     module procedure lambda_n_
     module procedure lambda_tol_
  end interface lambda

  ! Access specifiers

  private

  public :: hough_t
  public :: lambda
  public :: lambda_asymp

  ! Procedures

contains

  function hough_t_n_ (nu, m, k, n) result (ho)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: k
    integer, intent(in)  :: n
    type(hough_t)        :: ho

    ! Construct the hough_t for fixed matrix dimension

    call eigen_W_n_(nu, m, k, n, ho%lambda, ho%b)

    allocate(ho%c_r(n))
    allocate(ho%c_t(n))
    allocate(ho%c_p(n))

    call eval_coeffs_(nu, m, k, ho%lambda, ho%b, ho%c_r, ho%c_t, ho%c_p)

    ho%nu = nu

    ho%m = m
    ho%k = k
    ho%n = n

    ! Finish

    return

  end function hough_t_n_

!****

  function hough_t_tol_ (nu, m, k, tol) result (ho)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: k
    real(WP), intent(in) :: tol
    type(hough_t)        :: ho

    integer :: n

    ! Construct the hough_t to the specified tolerance

    call eigen_W_tol_(nu, m, k, tol, ho%lambda, ho%b)

    n = SIZE(ho%b)

    allocate(ho%c_r(n))
    allocate(ho%c_t(n))
    allocate(ho%c_p(n))

    call eval_coeffs_(nu, m, k, ho%lambda, ho%b, ho%c_r, ho%c_t, ho%c_p)

    ho%nu = nu

    ho%m = m
    ho%k = k
    ho%n = n

    ! Finish

    return

  end function hough_t_tol_

!****

  function Theta_ (this, mu) result (Theta)

    class(hough_t), intent(in) :: this
    real(WP), intent(in)       :: mu
    real(WP)                   :: Theta(3)

    logical  :: parity
    real(WP) :: P_lm(2*this%n)

    ! Evaluate the Hough Theta functions (see Townsend 2003) at
    ! mu=cos theta

    parity = MOD(this%k, 2) == 0

    P_lm = P_lm_series(2*this%n, this%m, mu)

    if (parity) then
       associate (P_l_j => P_lm(1::2), P_n_j => P_lm(2::2))
         Theta(1) = DOT_PRODUCT(this%c_r, P_l_j)
         Theta(2) = DOT_PRODUCT(this%c_t, P_n_j)
         Theta(3) = DOT_PRODUCT(this%c_p, P_l_j)
       end associate
    else
       associate (P_l_j => P_lm(2::2), P_n_j => P_lm(1::2))
         Theta(1) = DOT_PRODUCT(this%c_r, P_l_j)
         Theta(2) = DOT_PRODUCT(this%c_t, P_n_j)
         Theta(3) = DOT_PRODUCT(this%c_p, P_l_j)
       end associate
    endif

    ! Finish

    return

  end function Theta_

!****

  function Theta_xi_ (this, mu) result (Theta_xi)

    class(hough_t), intent(in) :: this
    real(WP), intent(in)       :: mu
    real(WP)                   :: Theta_xi(3)

    logical  :: parity
    real(WP) :: stheta
    real(WP) :: P_lm(2*this%n)
    real(WP) :: dP_lm(2*this%n)

    ! Evaluate the Hough theta-function parts of the displacement
    ! vector (see Townsend 2003) at mu=cos theta

    parity = MOD(this%k, 2) == 0

    stheta = SQRT(1._WP - mu**2)

    if (stheta > EPSILON(0._WP)) then

       P_lm = P_lm_series(2*this%n, this%m, mu)

       if (parity) then
          associate (P_l_j => P_lm(1::2), P_n_j => P_lm(2::2))
            Theta_xi(1) = DOT_PRODUCT(this%c_r, P_l_j)
            Theta_xi(2) = DOT_PRODUCT(this%c_t, P_n_j)/stheta
            Theta_xi(3) = DOT_PRODUCT(this%c_p, P_l_j)/stheta
          end associate
       else
          associate (P_l_j => P_lm(2::2), P_n_j => P_lm(1::2))
            Theta_xi(1) = DOT_PRODUCT(this%c_r, P_l_j)
            Theta_xi(2) = DOT_PRODUCT(this%c_t, P_n_j)/stheta
            Theta_xi(3) = DOT_PRODUCT(this%c_p, P_l_j)/stheta
          end associate
       endif

    else

       ! Use L'Hopital's rule to deal with the poles

       P_lm = P_lm_series(2*this%n, this%m, mu)
       dP_lm = dP_lm_series(2*this%n, this%m, mu)

       if (parity) then
          associate (P_l_j => P_lm(1::2), P_n_j => P_lm(2::2), dP_l_j => dP_lm(1::2), dP_n_j => dP_lm(2::2))
            Theta_xi(1) = DOT_PRODUCT(this%c_r, P_l_j)
            Theta_xi(2) = DOT_PRODUCT(this%c_t, dP_n_j)/(-mu)
            Theta_xi(3) = DOT_PRODUCT(this%c_p, dP_l_j)/(-mu)
          end associate
       else
          associate (P_l_j => P_lm(2::2), P_n_j => P_lm(1::2), dP_l_j => dP_lm(2::2), dP_n_j => dP_lm(1::2))
            Theta_xi(1) = DOT_PRODUCT(this%c_r, P_l_j)
            Theta_xi(2) = DOT_PRODUCT(this%c_t, dP_n_j)/(-mu)
            Theta_xi(3) = DOT_PRODUCT(this%c_p, dP_l_j)/(-mu)
          end associate
       endif

    end if

    ! Finish

    return

  end function Theta_xi_

!****

  subroutine eval_coeffs_ (nu, m, k, lambda, b, c_r, c_t, c_p)

    real(WP), intent(in)  :: nu
    integer, intent(in)   :: m
    integer, intent(in)   :: k
    real(WP), intent(in)  :: lambda
    real(WP), intent(in)  :: b(:)
    real(WP), intent(out) :: c_r(:)
    real(WP), intent(out) :: c_t(:)
    real(WP), intent(out) :: c_p(:)

    integer  :: n
    logical  :: parity
    real(WP) :: N_lm(2*SIZE(b))
    real(WP) :: q(SIZE(b))
    real(WP) :: r(SIZE(b))
    integer  :: l_j
    integer  :: n_j
    integer  :: j
    real(WP) :: P_lm(2*SIZE(b))
    real(WP) :: dP_lm(2*SIZE(b))

  if(SIZE(c_r)/= SIZE(b)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(c_r) :', SIZE(c_r)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b) :', SIZE(b)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(c_r)==SIZE(b) failed at line 265 <astro_hough:eval_coeffs_>'
    stop
  endif

  if(SIZE(c_t)/= SIZE(b)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(c_t) :', SIZE(c_t)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b) :', SIZE(b)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(c_t)==SIZE(b) failed at line 266 <astro_hough:eval_coeffs_>'
    stop
  endif

  if(SIZE(c_p)/= SIZE(b)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(c_p) :', SIZE(c_p)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b) :', SIZE(b)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(c_p)==SIZE(b) failed at line 267 <astro_hough:eval_coeffs_>'
    stop
  endif

    ! Calculate the assoc. Legendre polynomial expansion coefficients
    ! for the Hough functions

    n = SIZE(b)

    parity = MOD(k, 2) == 0

    ! Set up the radial coefficients c_r

    N_lm = N_lm_series(2*n, m)

    c_r = N_lm(1::2)*b

    ! Set up the polar (c_t) and azimuthal (c_p) coefficients

    call eval_eigvecs_(nu, m, k, lambda, b, q, r)

    if (parity) then

       l_j = ABS(m)
       n_j = l_j + 1

       associate (N_l_j => N_lm(1::2), N_n_j => N_lm(2::2))

         if (n == 1) then

            c_t(1) = (n_j-1)*(n_j-m)*N_l_j(1)*q(1)/(2*n_j-1) + m*N_n_j(1)*r(1)
            c_p(1) = (l_j+2)*(l_j+m+1)*N_n_j(1)*r(1)/(2*l_j+3) - m*N_l_j(1)*q(1)

         else

            c_t(1) = (n_j-1)*(n_j-m)*N_l_j(1)*q(1)/(2*n_j-1) - (n_j+2)*(n_j+m+1)*N_l_j(2)*q(2)/(2*n_j+3) + &
                     m*N_n_j(1)*r(1)
            c_p(1) = (l_j+2)*(l_j+m+1)*N_n_j(1)*r(1)/(2*l_j+3) - m*N_l_j(1)*q(1)

            l_j = l_j + 2
            n_j = n_j + 2

            do j = 2,n-1
               c_t(j) = (n_j-1)*(n_j-m)*N_l_j(j)*q(j)/(2*n_j-1) - (n_j+2)*(n_j+m+1)*N_l_j(j+1)*q(j+1)/(2*n_j+3) + &
                        m*N_n_j(j)*r(j)
               c_p(j) = (l_j+2)*(l_j+m+1)*N_n_j(j)*r(j)/(2*l_j+3) - (l_j-1)*(l_j-m)*N_n_j(j-1)*r(j-1)/(2*l_j-1) - &
                        m*N_l_j(j)*q(j)
               l_j = l_j + 2
               n_j = n_j + 2
            end do

            c_t(n) = (n_j-1)*(n_j-m)*N_l_j(n)*q(n)/(2*n_j-1) - m*N_n_j(n)*r(n)
            c_p(n) = (l_j+2)*(l_j+m+1)*N_n_j(n)*r(n)/(2*l_j+3) - (l_j-1)*(l_j-m)*N_n_j(n-1)*r(n-1)/(2*l_j-1) - &
                     m*N_l_j(n)*q(n)

         endif

       end associate

    else

       n_j = ABS(m)
       l_j = n_j + 1

       associate (N_l_j => N_lm(2::2), N_n_j => N_lm(1::2))

         if (n == 1) then

            c_t(1) = -(n_j+2)*(n_j+m+1)*N_l_j(1)*q(1)/(2*n_j+3) + m*N_n_j(1)*r(1)
            c_p(1) = -(l_j-1)*(l_j-m)*N_n_j(1)*r(1)/(2*l_j-1) - m*N_l_j(1)*q(1)

         else

            c_t(1) = -(n_j+2)*(n_j+m+1)*N_l_j(1)*q(1)/(2*n_j+3) + m*N_n_j(1)*r(1)
            c_p(1) = (l_j+2)*(l_j+m+1)*N_n_j(2)*r(2)/(2*l_j+3) - (l_j-1)*(l_j-m)*N_n_j(1)*r(1)/(2*l_j-1) - &
                     m*N_l_j(1)*q(1)

            l_j = l_j + 2
            n_j = n_j + 2

            do j = 2,n-1
               c_t(j) = (n_j-1)*(n_j-m)*N_l_j(j-1)*q(j-1)/(2*n_j-1) - (n_j+2)*(n_j+m+1)*N_l_j(j)*q(j)/(2*n_j+3) + &
                        m*N_n_j(j)*r(j)
               c_p(j) = (l_j+2)*(l_j+m+1)*N_n_j(j+1)*r(j+1)/(2*l_j+3) - (l_j-1)*(l_j-m)*N_n_j(j)*r(j)/(2*l_j-1) - &
                        m*N_l_j(j)*q(j)
               l_j = l_j + 2
               n_j = n_j + 2
            end do

            c_t(n) = (n_j-1)*(n_j-m)*N_l_j(n-1)*q(n-1)/(2*n_j-1) - (n_j+2)*(n_j+m+1)*N_l_j(n)*q(n)/(2*n_j+3) + &
                     m*N_n_j(n)*r(n)
            c_p(n) = -(l_j-1)*(l_j-m)*N_n_j(n)*r(n)/(2*l_j-1) - m*N_l_j(n)*q(n)

         endif

       end associate

    end if

    ! Adjust signs by considering the behavior at the pole

    if (parity) then
       P_lm = P_lm_series(2*n, m, 0._WP)
       if (DOT_PRODUCT(P_lm(1::2), c_r) < 0._WP) then
          c_r = -c_r
          c_t = -c_t
          c_p = -c_p
       endif
    else
       dP_lm = dP_lm_series(2*n, m, 0._WP)
       if (DOT_PRODUCT(dP_lm(2::2), c_r) < 0._WP) then
          c_r = -c_r
          c_t = -c_t
          c_p = -c_p
       endif
    endif

    ! Finish

    return

  end subroutine eval_coeffs_

!****

  subroutine eval_eigvecs_ (nu, m, k, lambda, b, q, r)

    real(WP), intent(in)  :: nu
    integer, intent(in)   :: m
    integer, intent(in)   :: k
    real(WP), intent(in)  :: lambda
    real(WP), intent(in)  :: b(:)
    real(WP), intent(out) :: q(:)
    real(WP), intent(out) :: r(:)

    integer :: n
    logical :: parity
    integer :: j
    integer :: l_j
    integer :: n_j

  if(SIZE(q)/= SIZE(b)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(q) :', SIZE(q)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b) :', SIZE(b)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(q)==SIZE(b) failed at line 406 <astro_hough:eval_eigvecs_>'
    stop
  endif

  if(SIZE(r)/= SIZE(b)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b) :', SIZE(b)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(r)==SIZE(b) failed at line 407 <astro_hough:eval_eigvecs_>'
    stop
  endif

    ! Calculate the q and r eigenvectors associated with the b
    ! eigenvector (see Townsend 1997)

    ! q eigenvector (poloidal)

    n = SIZE(b)

    parity = MOD(k, 2) == 0

    if (parity .AND. m == 0) then

       ! Special casing for parity=.TRUE., m=0 situations, since q(1)
       ! is not properly defined; its actual value doesn't matter,
       ! since it has no physical significance, so we set it to zero

       q(1) = 0._WP

       if(k == 0) then

          q(2:) = 0._WP

       else

          l_j = 2

          do j = 2, n
             q(j) = b(j)*lambda/(l_j*(l_j+1))
             l_j = l_j + 2
          end do

       endif

    else

       if (parity) then
          l_j = ABS(m)
       else
          l_j = ABS(m) + 1
       endif

       do j = 1, n
          q(j) = b(j)*lambda/(l_j*(l_j+1))
          l_j = l_j + 2
       end do

    endif

    ! r eigenvector (toroidal)

    if (parity) then

       if(m == 0 .AND. k == 0) then

          r = 0._WP

       else

          n_j = ABS(m) + 1

          do j = 1, n-1
             r(j) = nu*(J_lm_(n_j, m)*b(j)/n_j**2 + J_lm_(n_j+1, m)*b(j+1)/(n_j+1)**2)*lambda/(1._WP + m*nu/(n_j*(n_j+1)))
             n_j = n_j + 2
          enddo

          r(n) = nu*(J_lm_(n_j, m)*b(j)/n_j**2)*lambda/(1._WP + m*nu/(n_j*(n_j+1)))

       end if

    else

       n_j = ABS(m)

       if (m == 0) then

          ! Special casing for parity=.FALSE., m=0 situations, since
          ! r(1) is not properly defined; its actual value doesn't
          ! matter, since it has no physical significance, so we set
          ! it to zero

          r(1) = 0._WP

       else

          r(1) = nu*(J_lm_(n_j+1, m)*b(1)/(n_j+1)**2)*lambda/(1._WP + m*nu/(n_j*(n_j+1)))

       endif

       n_j = n_j + 2

       do j = 2,n
          r(j) = nu*(J_lm_(n_j+1, m)*b(j)/(n_j+1)**2 + J_lm_(n_j, m)*b(j-1)/n_j**2)*lambda/(1._WP + m*nu/(n_j*(n_j+1)))
          n_j = n_j + 2
       end do

    endif

    ! Finish

    return

  end subroutine eval_eigvecs_

!****

  subroutine eigen_W_n_ (nu, m, k, n, lambda, b)

    real(WP), intent(in)                         :: nu
    integer, intent(in)                          :: m
    integer, intent(in)                          :: k
    integer, intent(in)                          :: n
    real(WP), intent(out)                        :: lambda
    real(WP), allocatable, optional, intent(out) :: b(:)

    logical  :: h_over
    logical  :: h_zero
    logical  :: h_inval
    logical  :: parity
    real(WP) :: lambda_A(n)
    real(WP) :: b_A(n,n)
    integer  :: i

    ! Calculate the W matrix eigenvalue and (possibly) eigenvector for
    ! the supplied mode parameters and the indicated matrix dimension

    ! Calculate the full eigenvalue/eigenvector spectrum

    parity = MOD(k, 2) == 0

    if (PRESENT(b)) then
       call eigen_A_(nu, m, parity, n, lambda_A, b_A)
    else
       call eigen_A_(nu, m, parity, n, lambda_A)
    endif

    ! Determine the index of the required eigenpair

    if (k >= 0) then
       if (parity) then
          i = n - k/2
       else
          i = n - (k-1)/2
       endif
    else
       if (parity) then
          i = ABS(k)/2
       else
          i = ABS(k-1)/2
       endif
    endif

    i = MODULO(i-Xi_(nu, m, n, parity)-1, n) + 1    

    ! Pick out the eigenpair

    lambda = 1._WP/lambda_A(i)
    if (PRESENT(b)) b = b_A(:,i)

    ! Finish

    return

  end subroutine eigen_W_n_

!****

  subroutine eigen_W_tol_ (nu, m, k, tol, lambda, b)

    real(WP), intent(in)                         :: nu
    integer, intent(in)                          :: m
    integer, intent(in)                          :: k
    real(WP), intent(in)                         :: tol
    real(WP), intent(out)                        :: lambda
    real(WP), allocatable, optional, intent(out) :: b(:)

    real(WP), parameter :: EPS = EPSILON(0._WP)

    logical               :: parity
    integer               :: n
    real(WP)              :: lambda_cmp
    real(WP), allocatable :: b_cmp(:)

    ! Calculate the W matrix eigenvalue and (possibly) eigenvector for
    ! the supplied mode parameters and the indicated tolerance

    ! Initialize n to the smallest possible value

    parity = MODULO(k, 2) == 0

    if (k >= 0) then

       if (parity) then
          n = k/2+1
       else
          n = (k+1)/2+1
       endif

       if (m*nu < 0._WP) then
          n = n + Xi_(nu, m, n, parity)
       endif

    else

       if (parity) then
          n = ABS(k)/2
       else
          n = ABS(k-1)/2
       endif

    endif

    ! Now increase n until the desired tolerance is reached

!    allocate(b(n))

    call eigen_W_n_(nu, m, k, n, lambda, b)

    if (PRESENT(b)) b = b/MAXVAL(ABS(b))

    n_loop : do

       ! if (PRESENT(b)) then

       !    allocate(b_cmp(2*n))

       !    call eigen_W_n_(nu, m, k, 2*n, lambda_cmp, b_cmp)
       !    b_cmp = b_cmp/MAXVAL(ABS(b_cmp))

       !    print *,'Trying:',nu,n,COUNT(ABS(b - b_cmp(:n)) <= (4._WP*EPS+tol)*ABS(b_cmp(:n)))

       !    if(ALL(ABS(b - b_cmp(:n)) <= (4._WP*EPS+tol)*ABS(b_cmp(:n)))) exit n_loop

       !    lambda = lambda_cmp
       !    b = b_cmp

       !    deallocate(b_cmp)

       ! else

          call eigen_W_n_(nu, m, k, 2*n, lambda_cmp)

          if(ABS(lambda - lambda_cmp) <= (4._WP*EPS+tol)*ABS(lambda_cmp)) exit n_loop

          lambda = lambda_cmp

       ! endif

       n = 2*n

    end do n_loop

    ! Finish

    return

  end subroutine eigen_W_tol_

!****

  subroutine eigen_A_ (nu, m, parity, n, lambda, b)

    real(WP), intent(in)            :: nu
    integer, intent(in)             :: m
    logical, intent(in)             :: parity
    integer, intent(in)             :: n
    real(WP), intent(out)           :: lambda(:)
    real(WP), optional, intent(out) :: b(:,:)

    logical  :: h_over
    logical  :: h_zero
    logical  :: h_inval
    real(WP) :: A_1(n)
    real(WP) :: A_2n(n)
    real(WP) :: A_2d(n)
    real(WP) :: A_3n(n)
    real(WP) :: A_3d(n)
    real(WP) :: A_4n(n)
    real(WP) :: A_4d(n)
    real(WP) :: A_5(n)
    real(WP) :: A_D(n)
    real(WP) :: A_E(n)
    real(WP) :: abstol
    integer  :: j
    integer  :: j_inf

  if(SIZE(lambda)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(lambda) :', SIZE(lambda)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(lambda)==n failed at line 701 <astro_hough:eigen_A_>'
    stop
  endif

    if (PRESENT(b)) then

  if(SIZE(b, 1)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b, 1) :', SIZE(b, 1)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(b, 1)==n failed at line 704 <astro_hough:eigen_A_>'
    stop
  endif

  if(SIZE(b, 2)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(b, 2) :', SIZE(b, 2)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(b, 2)==n failed at line 705 <astro_hough:eigen_A_>'
    stop
  endif

    endif

    ! Calculate the A (alpeh) matrix eigenvalues and (possibly)
    ! eigenvectors for the supplied mode parameters

    ! Assemble the A-matrix

    call assemble_A_(nu, m, n, parity, A_1, A_2n, A_2d, A_3n, A_3d, A_4n, A_4d, A_5, &
                     A_D, A_E)

    A_E(n) = 0._WP

    ! Calculate the eigenvalues and eigenvectors, taking care to
    ! handle special cases where one or more components of A is
    ! infinite

    abstol = LA_LAMCH(1.0_WP, 'Safe minimum')

    if (A_5(1) == 0._WP) then

       ! A(1,1) infinite, causing a +inf eigenvalue

       if (PRESENT(b)) then

          call LA_STEVR(A_D(2:), A_E(2:), lambda(:n-1), Z=b(:n-1,:n-1))

          b(n,:n-1) = 0._WP
          b(:n-1,n) = 0._WP

          b(n,n) = 1._WP

       else

          call LA_STEVR(A_D(2:), A_E(2:), lambda(:n-1))

       endif

       lambda(n) = HUGE(0._WP)

    elseif (A_2d(1) == 0._WP .AND. A_2n(1) /= 0._WP) then

       ! A(1,1) infinite, causing a -inf eigenvalue

       if (PRESENT(b)) then

          call LA_STEVR(A_D(2:), A_E(2:), lambda(2:), Z=b(2:,2:))

          b(1,2:) = 0._WP
          b(2:,1) = 0._WP

          b(1,1) = 1._WP

       else

          call LA_STEVR(A_D(2:), A_E(2:), lambda(2:))

       endif

       lambda(1) = -HUGE(0._WP)

    elseif (A_3d(n) == 0._WP .AND. A_3n(n) /= 0._WP) then

       ! A(n,n) infinite, causing a -inf eigenvalue

       if (PRESENT(b)) then

          call LA_STEVR(A_D(:n-1), A_E(:n-1), lambda(2:), Z=b(2:,2:))

          b(1,2:) = 0._WP
          b(2:,1) = 0._WP

          b(1,1) = 1._WP

       else

          call LA_STEVR(A_D(:n-1), A_E(:n-1), lambda(2:))

       endif

       lambda(1) = -HUGE(0._WP)

    else

       ! Scan for a 2x2 block of infinite components (arising from a
       ! pure Rossby mode being part of the spectrum)

       j_inf = 0

       scan_loop : do j = 1, n-1
          if (A_3d(j) == 0._WP .AND. A_3n(j) /= 0._WP) then
             j_inf = j
             exit scan_loop
          endif
       end do scan_loop

       if (j_inf /= 0) then

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 819 <astro_hough:eigen_A_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Pure Rossby mode encountered'

  stop 'Program aborted'

       else

          call LA_STEVR(A_D, A_E, lambda, Z=b)

       endif

    endif

    ! Finish

    return

  end subroutine eigen_A_

!****

  subroutine eval_A_ (nu, m, n, parity, A_D, A_E)

    real(WP), intent(in)  :: nu
    integer, intent(in)    :: m
    integer, intent(in)    :: n
    logical, intent(in)    :: parity
    real(WP), intent(out) :: A_D(:)
    real(WP), intent(out) :: A_E(:)

    real(WP) :: A_1(n)
    real(WP) :: A_2n(n)
    real(WP) :: A_2d(n)
    real(WP) :: A_3n(n)
    real(WP) :: A_3d(n)
    real(WP) :: A_4n(n)
    real(WP) :: A_4d(n)
    real(WP) :: A_5(n)
    integer   :: j

  if(SIZE(A_D)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_D) :', SIZE(A_D)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_D)==n failed at line 860 <astro_hough:eval_A_>'
    stop
  endif

  if(SIZE(A_E)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_E) :', SIZE(A_E)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_E)==n failed at line 861 <astro_hough:eval_A_>'
    stop
  endif

    ! Evaluate the A matrix

    call assemble_A_(nu, m, n, parity, A_1, A_2n, A_2d, A_3n, A_3d, A_4n, A_4d, A_5, A_D, A_E)

    ! Finish

    return

  end subroutine eval_A_

!****

  subroutine assemble_A_ (nu, m, n, parity, A_1, A_2n, A_2d, A_3n, A_3d, A_4n, A_4d, A_5, A_D, A_E)

    real(WP), intent(in)  :: nu
    integer, intent(in)   :: m
    integer, intent(in)   :: n
    logical, intent(in)   :: parity
    real(WP), intent(out) :: A_1(:)
    real(WP), intent(out) :: A_2n(:)
    real(WP), intent(out) :: A_2d(:)
    real(WP), intent(out) :: A_3n(:)
    real(WP), intent(out) :: A_3d(:)
    real(WP), intent(out) :: A_4n(:)
    real(WP), intent(out) :: A_4d(:)
    real(WP), intent(out) :: A_5(:)
    real(WP), intent(out) :: A_D(:)
    real(WP), intent(out) :: A_E(:)

    integer  :: j
    integer  :: l_j
    real(WP) :: A_2
    real(WP) :: A_3
    real(WP) :: A_4

  if(SIZE(A_1)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_1) :', SIZE(A_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_1)==n failed at line 898 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_2n)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_2n) :', SIZE(A_2n)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_2n)==n failed at line 899 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_2d)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_2d) :', SIZE(A_2d)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_2d)==n failed at line 900 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_3n)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_3n) :', SIZE(A_3n)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_3n)==n failed at line 901 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_3d)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_3d) :', SIZE(A_3d)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_3d)==n failed at line 902 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_4n)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_4n) :', SIZE(A_4n)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_4n)==n failed at line 903 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_4d)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_4d) :', SIZE(A_4d)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_4d)==n failed at line 904 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_5)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_5) :', SIZE(A_5)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_5)==n failed at line 905 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_D)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_D) :', SIZE(A_D)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_D)==n failed at line 907 <astro_hough:assemble_A_>'
    stop
  endif

  if(SIZE(A_E)/= n) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(A_E) :', SIZE(A_E)
    write(UNIT=ERROR_UNIT, FMT=*) 'n :', n
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(A_E)==n failed at line 908 <astro_hough:assemble_A_>'
    stop
  endif

    ! Evaluate constituent parts of the A matrix. These are defined so
    ! that:
    !
    ! A_D(j) = A(j,j) = A_D(j) = [A_1(j) + A_2n(j)/A_2d(j) + A_3n(j)/A_3d(j)] / A_5(j)
    ! A_E(j) = A(j+1,j) = A(j, j+1) = A_4n(j)/A_4d(j)
    !
    ! A_E(n) is unused

    if (parity) then
       l_j = ABS(m)
    else
       l_j = ABS(m) + 1
    endif

    do j = 1, n

       if (l_j == ABS(m)) then
          A_1(j) = 1._WP + SIGN(1, m)*nu/REAL(l_j+1, WP)
          A_2n(j) = 0._WP
       else
          A_1(j) = 1._WP + m*nu/(REAL(l_j, WP)*REAL(l_j+1, WP))
          A_2n(j) = -nu**2*REAL(l_j-1, WP)**2*REAL(l_j+1, WP)*J_lm_(l_j, m)**2/REAL(l_j, WP)
       endif

       A_2d(j) = REAL(l_j-1, WP)*REAL(l_j, WP) + m*nu

       A_3n(j) = -nu**2*REAL(l_j, WP)*REAL(l_j+2, WP)**2*J_lm_(l_j+1, m)**2/REAL(l_j+1, WP)
       A_3d(j) = REAL(l_j+1, WP)*REAL(l_j+2, WP) + m*nu

       A_4n(j) = -nu**2*J_lm_(l_j+1, m)*J_lm_(l_j+2, m)
       A_4d(j) = A_3d(j)

       A_5(j) = REAL(l_j, WP)*REAL(l_j+1, WP)

       l_j = l_j + 2

    end do

    ! Now assemble the matrix

    do j = 1, n-1

       if (A_2n(j) /= 0._WP) then
          A_2 = A_2n(j)/A_2d(j)
       else
          A_2 = 0._WP
       endif

       if (A_3n(j) /= 0._WP) then
          A_3 = A_3n(j)/A_3d(j)
       else
          A_3 = 0._WP
       endif

       if (A_4n(j) /= 0._WP) then
          A_4 = A_4n(j)/A_4d(j)
       else
          A_4 = 0._WP
       endif

       A_D(j) = (A_1(j) + A_2 + A_3)/A_5(j)
       A_E(j) = A_4

    end do

    if (A_2n(n) /= 0._WP) then
       A_2 = A_2n(n)/A_2d(n)
    else
       A_2 = 0._WP
    endif

    if (A_3n(n) /= 0._WP .AND. parity) then
       A_3 = A_3n(n)/A_3d(n)
    else
       A_3 = 0._WP
    endif

    A_D(n) = (A_1(n) + A_2 + A_3)/A_5(n)

    ! Finish

    return

  end subroutine assemble_A_

!****

  function Xi_ (nu, m, n, parity)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: n
    logical, intent(in)  :: parity
    integer              :: Xi_

    integer :: l_j
    integer :: j

    ! Calculate the permutation constant Xi (see Townsend 1997)

    Xi_ = 0

    if(-m*nu > 0._WP) then

       if(parity) then
          l_j = ABS(m)
       else
          l_j = ABS(m) + 1
       endif

       j_loop : do j = 1,n
          if (-m*nu > REAL(l_j+1, WP)*REAL(l_j+2, WP)) Xi_ = Xi_ + 1
          l_j = l_j + 2
       enddo j_loop

       if(.NOT. parity .AND. -m*nu > REAL(ABS(m), WP)*REAL(ABS(m)+1, WP)) Xi_ = Xi_ + 1

    endif

    ! Finish

    return

  end function Xi_

!****

  function J_lm_ (l, m)

    integer, intent(in) :: l
    integer, intent(in) :: m
    real(WP)            :: J_lm_

    ! Calculate the J_lm function, being the integral of Y_lm Y_{l+1}m
    ! cos(theta) over all solid angles

    if(ABS(m) >= l) then

       J_lm_ = 0._WP

    else

       J_lm_ = SQRT(REAL(l-m, WP)*REAL(l+m, WP)/(REAL(2*l+1, WP)*REAL(2*l-1, WP)))

    endif

    ! Finish

    return

  end function J_lm_

!****

  function P_lm_series (n, m, x) result (P_lm)

    integer, intent(in)  :: n
    integer, intent(in)  :: m
    real(WP), intent(in) :: x
    real(WP)             :: P_lm(n)

    integer  :: am
    real(WP) :: sqrt_term
    real(WP) :: fact_term
    integer  :: i
    integer  :: l

    ! Calculate an n-term series of associated Legendre functions
    ! P_lm(x), with l=|m|,|m|+1,...,|m|+n-1

    if (n > 0) then

       ! First calculate the P_mm term

       P_lm(1) = 1._WP
       am = ABS(m)

       if (m > 0) then

          sqrt_term = -SQRT((1._WP-x)*(1._WP+x))
          fact_term = 1._WP

          do i = 1,am
             P_lm(1) = P_lm(1)*fact_term*sqrt_term
             fact_term = fact_term + 2._WP
          end do

       elseif (m < 0) then

          sqrt_term = SQRT((1._WP-x)*(1._WP+x))
          fact_term = 2._WP

          do i = 1,am
             P_lm(1) = P_lm(1)*sqrt_term/fact_term
             fact_term = fact_term + 2.
          end do

       endif

       ! Now calculate the other terms using recursion

       if (n > 1) then

          P_lm(2) = x*(2*am+1)*P_lm(1)/(am+1-m)

          l = am + 2

          do i = 3,n
             P_lm(i) = (x*(2*l-1)*P_lm(i-1) - (l+m-1)*P_lm(i-2))/(l-m)
             l = l + 1
          end do

       endif

    end if

    ! Finish

    return

  end function P_lm_series

!****

  function dP_lm_series (n, m, x) result (dP_lm)

    integer, intent(in)  :: n
    integer, intent(in)  :: m
    real(WP), intent(in) :: x
    real(WP)             :: dP_lm(n)

    integer  :: am
    real(WP) :: P_lm_sqrt(n)
    real(WP) :: sqrt_term
    real(WP) :: fact_term
    integer  :: i
    integer  :: l

    ! Calculate an n-term series of associated Legendre function derivatives
    ! -sqrt(1-x^2) dP_lm(x)/dx = dP_lm(cos theta)/dtheta, with l=|m|,|m|+1,...,|m|+n-1

    if(n > 0) then

       if (m /= 0) then

          ! This algorithm is based on calculating the functions
          ! P_lm/sqrt(1-x^2), and then using the formula for (x^2-1)
          ! dP_lm/dx

          ! First calculate the P_mm term

          am = ABS(m)

          if (m > 0) then

             P_lm_sqrt(1) = 1._WP

             sqrt_term = -SQRT((1._WP-x)*(1._WP+x))
             fact_term = 3._WP

             do i = 2,am
                P_lm_sqrt(1) = P_lm_sqrt(1)*fact_term*sqrt_term
                fact_term = fact_term + 2._WP
             end do

          elseif (m < 0) then

             P_lm_sqrt(1) = -0.5_WP

             sqrt_term = SQRT((1._WP-x)*(1._WP+x))
             fact_term = 4._WP

             do i = 2,am
                P_lm_sqrt(1) = P_lm_sqrt(1)*sqrt_term/fact_term
                fact_term = fact_term + 2._WP
             end do

          endif

          ! Now calculate the other terms using recursion

          if (n > 1) then

             P_lm_sqrt(2) = x*(2*am+1)*P_lm_sqrt(1)/(am+1-m)

             l = am + 2

             do i = 3,n
                P_lm_sqrt(i) = (x*(2*l-1)*P_lm_sqrt(i-1) - (l+m-1)*P_lm_sqrt(i-2))/(l-m)
                l = l + 1
             end do

          endif

          ! Apply the formula

          dP_lm(1) = am*x*P_lm_sqrt(1)

          l = am + 1

          do i = 2, n
             dP_lm(i) = l*x*P_lm_sqrt(i) - (l+m)*P_lm_sqrt(i-1)
             l = l + 1
          end do

       else

          ! m=0 is a special case

          dP_lm(1) = 0.
          dP_lm(2:) = -P_lm_series(n-1, 1, x)

       endif

    endif

    ! Finish

    return

  end function dP_lm_series

!****

  function N_lm_series (n, m) result (N_lm)

    integer, intent(in) :: n
    integer, intent(in) :: m
    real(WP)            :: N_lm(n)

    integer  :: am
    real(WP) :: fact_term
    integer  :: i
    integer  :: l

    ! Calculate an n-term series of spherical harmonic normalizing
    ! factors N_lm, with l=|m|,|m|+1,...,|m|+n-1

    if (n > 0) then

       am = ABS(m)

       fact_term = 1._WP

       if (m >= 0) then

          do i = 1,2*am
             fact_term = fact_term/i
          end do

       else

          do i = 1,2*am
             fact_term = fact_term*i
          end do

       endif

       N_lm(1) = fact_term*(2*am+1)

       l = am + 1

       if (m >= 0) then

          do i = 2,n
             fact_term = (l-am)*fact_term/(l+am)
             N_lm(i) = fact_term*(2*l+1)
             l = l + 1
          end do

       else

          do i = 2,n
             fact_term = (l+am)*fact_term/(l-am)
             N_lm(i) = fact_term*(2*l+1)
             l = l + 1
          end do

       endif

       N_lm = SQRT(0.5_WP)*SQRT(N_lm)

    endif

    ! Finish

    return

  end function N_lm_series

!****

!****

  function lambda_n_ (nu, m, k, n) result (lambda)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: k
    integer, intent(in)  :: n
    real(WP)             :: lambda

    ! Evaluate the Hough eigenvalue lambda for the supplied mode
    ! parameters and the indicated matrix dimension

    call eigen_W_n_(nu, m, k, n, lambda)

    ! Finish

    return

  end function lambda_n_

!****

  function lambda_tol_ (nu, m, k, tol) result (lambda)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: k
    real(WP), intent(in) :: tol
    real(WP)             :: lambda

    ! Evaluate the Hough eigenvalue lambda for the supplied mode
    ! parameters and the indicated tolerance

    call eigen_W_tol_(nu, m, k, tol, lambda)

    ! Finish

    return

  end function lambda_tol_

!****

  function lambda_asymp (nu, m, k) result (lambda)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: k
    real(WP)             :: lambda

    integer :: s

    ! Evaluate the (m, k) Hough eigenvalue lambda using the asymptotic
    ! expressions by Townsend (2003, MNRAS, 340,1020)

    if (m*nu >= 0) then

    if(.NOT. (k >= 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''k >= 0'' failed at line 1406 <astro_hough:lambda_asymp>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid k'
      stop
    endif

       if (k > 0) then

          s = k - 1

          lambda = m*nu + m**2 + 0.5_WP*nu**2*(2*s + 1)**2* &
                                 (1._WP + SQRT(1._WP + 4._WP*(m*nu + m**2)/(nu**2*(2*s + 1)**2)))

!          lambda = m*nu + m**2 + 0.5_WP*(2*s + 1)**2* &
!                                 (nu**2 + SQRT(nu**4 + 4._WP*nu**2*(m*nu + m**2)/(2*s + 1)**2))

       else

          lambda = m**2*(2._WP*m*nu)/(2._WP*m*nu - 1._WP)

       endif

    else

       if (k >= -1) then

          s = k + 1

          lambda = m*nu + m**2 + 0.5_WP*nu**2*(2*s + 1)**2* &
                                 (1._WP + SQRT(1._WP + 4._WP*(m*nu + m**2)/(nu**2*(2*s + 1)**2)))

!          lambda = m*nu + m**2 + 0.5_WP*(2*s + 1)**2* &
!                                 (nu**2 + SQRT(nu**4 + 4._WP*nu**2*(m*nu + m**2)/(2*s + 1)**2))

       else

          s = -k -1

          lambda = (m*nu - m**2)**2/(nu**2*(2*s+1)**2)

       endif

    endif

    ! Finish

    return

  end function lambda_asymp

end module astro_hough

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc ../rot/gyre_rot.inc
!   uses: core_kinds gyre_modepar
!   provides: gyre_c_rot
!end dependencies
!
!end fpx3_header
! Incfile  : gyre_r_rot
! Purpose  : rotational effects (complex)
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : gyre_rot
! Purpose  : rotational effects (template)
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_c_rot

  ! Uses

  use core_kinds

  use gyre_modepar

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type, abstract :: c_rot_t
     private
     type(modepar_t), public :: mp
   contains
     private
     procedure(omega_), deferred, public :: omega
     procedure(omega_c_1_), deferred     :: omega_c_1_
     procedure(omega_c_v_), deferred     :: omega_c_v_
     generic, public                     :: omega_c => omega_c_1_, omega_c_v_
     procedure                           :: l_e_1_
     procedure                           :: l_e_v_
     generic, public                     :: l_e => l_e_1_, l_e_v_
     procedure, public                   :: l_0 => l_0_
     procedure(lambda_1_), deferred      :: lambda_1_
     procedure(lambda_v_), deferred      :: lambda_v_
     generic, public                     :: lambda => lambda_1_, lambda_v_
  end type c_rot_t

  ! Interfaces

  abstract interface

     function omega_ (this, x, omega_c) result (omega)
       use core_kinds
       import c_rot_t
       class(c_rot_t), intent(in) :: this
       real(WP), intent(in)          :: x
       complex(WP), intent(in)         :: omega_c
       complex(WP)                     :: omega
     end function omega_

     function omega_c_1_ (this, x, omega) result (omega_c)
       use core_kinds
       import c_rot_t
       class(c_rot_t), intent(in) :: this
       real(WP), intent(in)          :: x
       complex(WP), intent(in)         :: omega
       complex(WP)                     :: omega_c
     end function omega_c_1_

     function omega_c_v_ (this, x, omega) result (omega_c)
       use core_kinds
       import c_rot_t
       class(c_rot_t), intent(in) :: this
       real(WP), intent(in)          :: x(:)
       complex(WP), intent(in)         :: omega
       complex(WP)                     :: omega_c(SIZE(x))
     end function omega_c_v_

     function lambda_1_ (this, x, omega) result (lambda)
       use core_kinds
       import c_rot_t
       class(c_rot_t), intent(in) :: this
       real(WP), intent(in)          :: x
       complex(WP), intent(in)         :: omega
       complex(WP)                     :: lambda
     end function lambda_1_

     function lambda_v_ (this, x, omega) result (lambda)
       use core_kinds
       import c_rot_t
       class(c_rot_t), intent(in) :: this
       real(WP), intent(in)          :: x(:)
       complex(WP), intent(in)         :: omega
       complex(WP)                     :: lambda(SIZE(x))
     end function lambda_v_

  end interface

  ! Access specifiers

  private

  public :: c_rot_t

contains

  function l_e_1_ (this, x, omega) result (l_e)

    class(c_rot_t), intent(in) :: this
    real(WP), intent(in)          :: x
    complex(WP), intent(in)         :: omega
    complex(WP)                     :: l_e

    ! Evaluate the effective harmonic degree (scalar)

    l_e = 0.5_WP*(-1._WP + SQRT(1._WP + 4._WP*this%lambda(x, omega)))

    ! Finish

    return

  end function l_e_1_

!****

  function l_e_v_ (this, x, omega) result (l_e)

    class(c_rot_t), intent(in) :: this
    real(WP), intent(in)          :: x(:)
    complex(WP), intent(in)         :: omega
    complex(WP)                     :: l_e(SIZE(x))

    ! Evaluate the effective harmonic degree (vector)

    l_e = 0.5_WP*(-1._WP + SQRT(1._WP + 4._WP*this%lambda(x, omega)))

    ! Finish

    return

  end function l_e_v_

!****

  function l_0_ (this, omega) result (l_0)

    class(c_rot_t), intent(in) :: this
    complex(WP), intent(in)         :: omega
    complex(WP)                     :: l_0

    ! Evaluate the effective harmonic degree at the origin

    l_0 = this%l_e(0._WP, omega)

    ! Finish

    return

  end function l_0_

end module gyre_c_rot

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_memory ISO_FORTRAN_ENV core_kinds odepack
!   provides: gyre_lane_emden
!end dependencies
!
!end fpx3_header
! Module   : gyre_lane_emden
! Purpose  : Lane-Emden equation solver
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_lane_emden

  ! Uses

  use core_kinds
  use core_memory

  use odepack

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Module variables

  real(WP), save :: n_poly_m

  !$OMP THREADPRIVATE(n_poly_m)

  ! Access specifiers

  private

  public :: solve_lane_emden

  ! Procedures

contains

  subroutine solve_lane_emden (n_poly, dxi, tol, xi, Theta, dTheta)

    real(WP), intent(in)               :: n_poly
    real(WP), intent(in)               :: dxi
    real(WP), intent(in)               :: tol
    real(WP), allocatable, intent(out) :: xi(:)
    real(WP), allocatable, intent(out) :: Theta(:)
    real(WP), allocatable, intent(out) :: dTheta(:)

    real(WP), parameter :: X_BEG = SQRT(EPSILON(0._WP))
    integer, parameter  :: D_0 = 512
    integer, parameter  :: NEQ = 2
    integer, parameter  :: NG = 1

    integer               :: d
    integer               :: n
    real(WP), allocatable :: x(:)
    real(WP), allocatable :: y(:,:)
    real(WP)              :: dx
    integer               :: istate
    real(WP)              :: rwork(22+NEQ*MAX(16,NEQ+9)+3*NG)
    integer               :: iwork(20+NEQ)
    integer               :: jroot(NG)
    real(WP)              :: x_end

    ! Set up module variables

    n_poly_m = n_poly

    ! Initialize arrays

    d = D_0

    allocate(x(d))
    allocate(y(2,d))

    n = 0

    ! Perform a series expansion out to x_beg

    dx = dxi

    expand_loop : do

       ! If necessary, expand arrays

       n = n + 1

       if(n > d) then
          d = 2*d
          call reallocate(x, [d])
          call reallocate(y, [2,d])
       endif

       ! Use a forth-order expansion of the Lane-Emden solutions

       x(n) = dx*(n-1)

       y(1,n) = 1._WP - x(n)**2/6._WP + n_poly*x(n)**4/120._WP
       y(2,n) = -x(n)/3._WP + n_poly*x(n)**3/30._WP

       if(x(n) > X_BEG) exit expand_loop

    end do expand_loop

    ! Now continue by integration

    istate = 1

    integrate_loop : do

       ! If necessary, expand arrays

       n = n + 1

       if(n > d) then
          d = 2*d
          call reallocate(x, [d])
          call reallocate(y, [2,d])
       endif

       ! Integrate one step

       x(n) = x(n-1)
       y(:,n) = y(:,n-1)

       call LSODAR(lane_emden_rhs, [NEQ], y(:,n), x(n), x(n-1)+dx, 1, [0._WP,0._WP], [tol,tol], &
            1, istate, 0, rwork, SIZE(rwork), iwork, SIZE(iwork), lane_emden_jac, 1, &
            lane_emden_constr, NG, jroot)

       ! Check for success

       select case (istate)
       case (2)
       case (3)

    if(.NOT. (jroot(1)==1)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''jroot(1)==1'' failed at line 146 <gyre_lane_emden:solve_lane_emden>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Root not found'
      stop
    endif

          exit integrate_loop
       case default
          write(ERROR_UNIT, *) 'istate is ',istate
          write(ERROR_UNIT, *) 'Integration range x=',x(n-1)
          write(ERROR_UNIT, *) 'Starting location y=',y(:,n-1)
          write(ERROR_UNIT, *) 'Relative tolerance =',0._WP
          write(ERROR_UNIT, *) 'Absolute tolerance =',tol
          write(ERROR_UNIT, *) 'Number of steps    =',n

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 155 <gyre_lane_emden:solve_lane_emden>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Integration failed'

  stop 'Program aborted'

       end select

    end do integrate_loop

    ! Fix the final point

    y(1,n) = 0._WP

    ! Initialize the polytropic variables

    xi = x(:n)

    Theta = y(1,:n)
    dTheta = y(2,:n)

    ! Finish

    return

  end subroutine solve_lane_emden

!****

  subroutine lane_emden_rhs (neq, x, y, dy_dx)

    integer, intent(in)   :: neq
    real(WP), intent(in)  :: x
    real(WP), intent(in)  :: y(neq)
    real(WP), intent(out) :: dy_dx(neq)

    ! Calculate the right-hand side vector

    dy_dx(1) = y(2)
    dy_dx(2) = -ABS(y(1))**n_poly_m - 2._WP*y(2)/x

    ! Finish

    return

  end subroutine lane_emden_rhs

!****

  subroutine lane_emden_jac (neq, x, y, ml, mu, pd, nrowpd)

    integer, intent(in)   :: neq
    real(WP), intent(in)  :: x
    real(WP), intent(in)  :: y(neq)
    integer, intent(in)   :: ml
    integer, intent(in)   :: mu
    integer, intent(in)   :: nrowpd
    real(WP), intent(out) :: pd(nrowpd,neq)

    ! Calculate the Jacobian matrix

    pd(1,1) = 0._WP
    pd(1,2) = 1._WP

    pd(2,1) = -n_poly_m*ABS(y(1))**(n_poly_m-1._WP)*SIGN(1._WP, y(1))
    pd(2,2) = -2._WP/x

    ! Finish

    return

  end subroutine lane_emden_jac

!****

  subroutine lane_emden_constr (neq, x, y, ng, gout)

    integer, intent(in)   :: neq
    real(WP), intent(in)  :: x
    real(WP), intent(in)  :: y(neq)
    integer, intent(in)   :: ng
    real(WP), intent(out) :: gout(ng)

    ! Calculate the constraint function

    gout(1) = y(1) 

    ! Finish

    return

  end subroutine lane_emden_constr

end module gyre_lane_emden

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: gyre_constants core_hgroup ISO_FORTRAN_ENV core_kinds gyre_lane_emden
!   provides: 
!end dependencies
!
!end fpx3_header
! Program  : build_poly
! Purpose  : build a polytrope
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

program build_poly

  ! Uses

  use core_kinds
  use gyre_constants
  use core_hgroup

  use gyre_lane_emden

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Variables

  real(WP)                    :: Gamma_1
  real(WP)                    :: Omega_rot
  real(WP)                    :: n_poly
  real(WP)                    :: dxi
  real(WP)                    :: toler
  character(LEN=FILENAME_LEN) :: file
  real(WP), allocatable       :: xi(:)
  real(WP), allocatable       :: Theta(:)
  real(WP), allocatable       :: dTheta(:)
  integer                     :: n
  type(hgroup_t)              :: hg

  namelist /poly/ n_poly, Gamma_1, Omega_rot, dxi, toler
  namelist /output/ file

  ! Read parameters

  Gamma_1 = 5._WP/3._WP
  Omega_rot = 0._WP

  dxi = 1.E-3_WP
  toler = EPSILON(0._WP)

  read(INPUT_UNIT, NML=poly)

  read(INPUT_UNIT, NML=output)

  ! Solve the Lane-Emden equation

  call solve_lane_emden(n_poly, dxi, toler, xi, Theta, dTheta)

  n = SIZE(xi)

  ! Write the model

  hg = hgroup_t(file, CREATE_FILE)

  call write_attr(hg, 'n', n)

  call write_attr(hg, 'n_poly', n_poly)
  call write_attr(hg, 'Gamma_1', Gamma_1)

  call write_dset(hg, 'xi', xi)
  call write_dset(hg, 'Theta', Theta)
  call write_dset(hg, 'dTheta', dTheta)
  call write_dset(hg, 'Omega_rot', SPREAD(Omega_rot, DIM=1, NCOPIES=n))

  call hg%final()

  ! Finish

end program build_poly

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: 
!   uses: core_constants core_parallel core_kinds
!   provides: gyre_constants
!end dependencies
!
!end fpx3_header
! Module   : gyre_constants
! Purpose  : (mutable) physical constants

module gyre_constants

  ! Uses

  use core_kinds
  use core_parallel
  use core_constants, &
       G_GRAVITY_ => G_GRAVITY, &
       C_LIGHT_ => C_LIGHT, &
       A_RADIATION_ => A_RADIATION, &
       M_SUN_ => M_SUN, &
       R_SUN_ => R_SUN, &
       L_SUN_ => L_SUN

  ! No implicit typing

  implicit none

  ! Module variables

  ! Physical constants (cgs)

  real(WP), save :: G_GRAVITY = G_GRAVITY_     ! Gravitational constant
  real(WP), save :: C_LIGHT = C_LIGHT_         ! Speed of light in vacuuo
  real(WP), save :: A_RADIATION = A_RADIATION_ ! Radiation constant

  ! Astronomical constants (cgs)

  real(WP), save :: M_SUN = M_SUN_ ! Solar mass
  real(WP), save :: R_SUN = R_SUN_ ! Solar radius
  real(WP), save :: L_SUN = L_SUN_ ! Solar luminosity (Allen, 1973)

  ! Acess specifiers

  private

  public :: PI
  public :: TWOPI
  public :: HALFPI
  public :: DEG_TO_RAD
  public :: RAD_TO_DEG

  public :: G_GRAVITY
  public :: C_LIGHT
  public :: A_RADIATION

  public :: M_SUN
  public :: R_SUN
  public :: L_SUN

  public :: FILENAME_LEN

  ! Procedures

contains

end module gyre_constants

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: 
!   uses: core_kinds
!   provides: core_constants
!end dependencies
!
!end fpx3_header
! Module   : core_constants
! Purpose  : physical constants

module core_constants

  ! Uses

  use core_kinds

  ! No implicit typing

  implicit none

  ! Parameter definitions

  ! Mathematical constants

  real(WP), parameter :: PI = ACOS(-1._WP)
  real(WP), parameter :: TWOPI = 2._WP*PI
  real(WP), parameter :: HALFPI = ASIN(1._WP)

  real(WP), parameter :: DEG_TO_RAD = PI/180._WP
  real(WP), parameter :: RAD_TO_DEG = 1._WP/DEG_TO_RAD

  ! Physical constants (cgs)

  real(WP), parameter :: G_GRAVITY = 6.67428E-8_WP                ! Gravitational constant
  real(WP), parameter :: H_PLANCK =  6.62606896E-27_WP            ! Planck's constant
  real(WP), parameter :: K_BOLTZMANN = 1.3806504E-16_WP           ! Boltzmann's constant
  real(WP), parameter :: C_LIGHT = 2.99792458E10_WP               ! Speed of light in vacuuo
  real(WP), parameter :: SIGMA_STEFAN = 5.670400E-5_WP            ! Stefan's constant
  real(WP), parameter :: A_RADIATION = 4._WP*SIGMA_STEFAN/C_LIGHT ! Radiation constant
  real(WP), parameter :: U_ATOMIC = 1.660538782E-24_WP            ! Atomic mass unit
  real(WP), parameter :: ELECTRON_VOLT = 1.602176487E-12_WP       ! Electron volt
  real(WP), parameter :: E_ELECTRON = 4.80320427E-10_WP           ! Electron charge
  real(WP), parameter :: M_ELECTRON = 9.10938215E-28_WP           ! Electron mass
  real(WP), parameter :: SIGMA_THOMSON = 6.6524586E-25_WP         ! Thomson cross section
  real(WP), parameter :: N_AVOGADRO = 6.0221415E23_WP             ! Avogadro's number

  ! Astronomical constants (cgs)

  real(WP), parameter :: M_SUN = 1.9891E33_WP             ! Solar mass
  real(WP), parameter :: R_SUN = 6.96E10_WP               ! Solar radius
  real(WP), parameter :: L_SUN = 3.826E33_WP              ! Solar luminosity (Allen, 1973)
  real(WP), parameter :: YEAR = 365.25_WP*24._WP*3600._WP ! Solar Year

  ! Filename lengths etc

  integer, parameter :: FILENAME_LEN = 256

  ! Acess specifiers

  private

  public :: PI
  public :: TWOPI
  public :: HALFPI
  public :: DEG_TO_RAD
  public :: RAD_TO_DEG

  public :: G_GRAVITY
  public :: H_PLANCK
  public :: K_BOLTZMANN
  public :: C_LIGHT
  public :: SIGMA_STEFAN
  public :: A_RADIATION
  public :: U_ATOMIC
  public :: ELECTRON_VOLT
  public :: E_ELECTRON
  public :: M_ELECTRON
  public :: SIGMA_THOMSON
  public :: N_AVOGADRO

  public :: M_SUN
  public :: R_SUN
  public :: L_SUN
  public :: YEAR

  public :: FILENAME_LEN

end module core_constants

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_kinds gyre_cocache
!   provides: gyre_model
!end dependencies
!
!end fpx3_header
! Module   : gyre_model
! Purpose  : stellar model (interface)
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_model

  ! Uses

  use core_kinds

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type, abstract :: model_t
   contains
     private

    procedure(y_1_), deferred :: V_1_
    procedure(y_v_), deferred :: V_v_
    generic, public           :: V => V_1_, V_v_

    procedure(y_1_), deferred :: As_1_
    procedure(y_v_), deferred :: As_v_
    generic, public           :: As => As_1_, As_v_

    procedure(y_1_), deferred :: U_1_
    procedure(y_v_), deferred :: U_v_
    generic, public           :: U => U_1_, U_v_

    procedure(y_1_), deferred :: c_1_1_
    procedure(y_v_), deferred :: c_1_v_
    generic, public           :: c_1 => c_1_1_, c_1_v_

    procedure(y_1_), deferred :: Gamma_1_1_
    procedure(y_v_), deferred :: Gamma_1_v_
    generic, public           :: Gamma_1 => Gamma_1_1_, Gamma_1_v_

    procedure(y_1_), deferred :: nabla_ad_1_
    procedure(y_v_), deferred :: nabla_ad_v_
    generic, public           :: nabla_ad => nabla_ad_1_, nabla_ad_v_

    procedure(y_1_), deferred :: delta_1_
    procedure(y_v_), deferred :: delta_v_
    generic, public           :: delta => delta_1_, delta_v_

    procedure(y_1_), deferred :: c_rad_1_
    procedure(y_v_), deferred :: c_rad_v_
    generic, public           :: c_rad => c_rad_1_, c_rad_v_

    procedure(y_1_), deferred :: dc_rad_1_
    procedure(y_v_), deferred :: dc_rad_v_
    generic, public           :: dc_rad => dc_rad_1_, dc_rad_v_

    procedure(y_1_), deferred :: c_thm_1_
    procedure(y_v_), deferred :: c_thm_v_
    generic, public           :: c_thm => c_thm_1_, c_thm_v_

    procedure(y_1_), deferred :: c_dif_1_
    procedure(y_v_), deferred :: c_dif_v_
    generic, public           :: c_dif => c_dif_1_, c_dif_v_

    procedure(y_1_), deferred :: c_eps_ad_1_
    procedure(y_v_), deferred :: c_eps_ad_v_
    generic, public           :: c_eps_ad => c_eps_ad_1_, c_eps_ad_v_

    procedure(y_1_), deferred :: c_eps_S_1_
    procedure(y_v_), deferred :: c_eps_S_v_
    generic, public           :: c_eps_S => c_eps_S_1_, c_eps_S_v_

    procedure(y_1_), deferred :: nabla_1_
    procedure(y_v_), deferred :: nabla_v_
    generic, public           :: nabla => nabla_1_, nabla_v_

    procedure(y_1_), deferred :: kappa_ad_1_
    procedure(y_v_), deferred :: kappa_ad_v_
    generic, public           :: kappa_ad => kappa_ad_1_, kappa_ad_v_

    procedure(y_1_), deferred :: kappa_S_1_
    procedure(y_v_), deferred :: kappa_S_v_
    generic, public           :: kappa_S => kappa_S_1_, kappa_S_v_

    procedure(y_1_), deferred :: tau_thm_1_
    procedure(y_v_), deferred :: tau_thm_v_
    generic, public           :: tau_thm => tau_thm_1_, tau_thm_v_

    procedure(y_1_), deferred :: Omega_rot_1_
    procedure(y_v_), deferred :: Omega_rot_v_
    generic, public           :: Omega_rot => Omega_rot_1_, Omega_rot_v_

     procedure(pi_c_), deferred, public         :: pi_c
     procedure(is_zero_), deferred, public      :: is_zero
     procedure(attach_cache_), deferred, public :: attach_cache
     procedure(detach_cache_), deferred, public :: detach_cache
     procedure(fill_cache_), deferred, public   :: fill_cache
  end type model_t

  ! Interfaces

  abstract interface

     function y_1_ (this, x) result (y)
       use core_kinds
       import model_t
       class(model_t), intent(in) :: this
       real(WP), intent(in)       :: x
       real(WP)                   :: y
     end function y_1_

     function y_v_ (this, x) result (y)
       use core_kinds
       import model_t
       class(model_t), intent(in) :: this
       real(WP), intent(in)       :: x(:)
       real(WP)                   :: y(SIZE(x))
     end function y_v_

     function pi_c_ (this) result (pi_c)
       use core_kinds
       import model_t
       class(model_t), intent(in) :: this
       real(WP)                   :: pi_c
     end function pi_c_

     function is_zero_ (this, x) result (is_zero)
       use core_kinds
       import model_t
       class(model_t), intent(in) :: this
       real(WP), intent(in)       :: x
       logical                    :: is_zero
     end function is_zero_

     subroutine attach_cache_ (this, cc)
       use gyre_cocache
       import model_t
       class(model_t), intent(inout)         :: this
       class(cocache_t), pointer, intent(in) :: cc
     end subroutine attach_cache_

     subroutine detach_cache_ (this)
       import model_t
       class(model_t), intent(inout) :: this
     end subroutine detach_cache_

     subroutine fill_cache_ (this, x)
       use core_kinds
       import model_t
       class(model_t), intent(inout) :: this
       real(WP), intent(in)          :: x(:)
     end subroutine fill_cache_

  end interface

 ! Access specifiers

  private

  public :: model_t

end module gyre_model

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_spline core_kinds
!   provides: core_table
!end dependencies
!
!end fpx3_header
! Module   : core_table
! Purpose  : monovariate tables

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_table

  ! Uses

  use core_kinds
  use core_spline

  ! No implicit typing

  implicit none

  ! Access specifiers

  private

  public :: deriv
  public :: integ
  public :: integ_def

  ! Procedures

contains

  function deriv (x, y, deriv_type, dy_dx_a, dy_dx_b) result (dy_dx)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    character(*), intent(in)       :: deriv_type
    real(WP), optional, intent(in) :: dy_dx_a
    real(WP), optional, intent(in) :: dy_dx_b
    real(WP)                       :: dy_dx(SIZE(x))

    type(spline_t) :: sp

    ! Calculate dy/dx via spline fitting

    sp = spline_t(x, y, deriv_type, dy_dx_a, dy_dx_b)

    dy_dx = sp%deriv()

    ! Finish

    return

  end function deriv

!****

  function integ (x, y, deriv_type, dy_dx_a, dy_dx_b) result (Y_)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    character(*), intent(in)       :: deriv_type
    real(WP), optional, intent(in) :: dy_dx_a
    real(WP), optional, intent(in) :: dy_dx_b
    real(WP)                       :: Y_(SIZE(x))

    type(spline_t) :: sp

    ! Calculate int_0^y y dx via spline fitting

    sp = spline_t(x, y, deriv_type, dy_dx_a, dy_dx_b)

    Y_ = sp%integ()

    ! Finish

    return

  end function integ

!****

  function integ_def (x, y, deriv_type, dy_dx_a, dy_dx_b) result (Y_def)

    real(WP), intent(in)           :: x(:)
    real(WP), intent(in)           :: y(:)
    character(*), intent(in)       :: deriv_type
    real(WP), optional, intent(in) :: dy_dx_a
    real(WP), optional, intent(in) :: dy_dx_b
    real(WP)                       :: Y_def

    real(WP) :: Y_(SIZE(x))

    ! Calculate int_{x_min}^{x_max} y dx via spline fitting

    Y_ = integ(x, y, deriv_type, dy_dx_a, dy_dx_b)

    Y_def = Y_(SIZE(x))

    ! Finish

    return

  end function integ_def

end module core_table

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_kinds ISO_FORTRAN_ENV
!   provides: core_order
!end dependencies
!
!end fpx3_header
! $Id: core_order.fpp 12 2012-05-30 19:55:53Z townsend $

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_order

  ! Uses

  use core_kinds

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Interfaces

  interface sort_indices
     module procedure sort_indices_i_i4_
     module procedure sort_indices_i_i8_
     module procedure sort_indices_r_sp_
     module procedure sort_indices_r_dp_
     module procedure sort_indices_a_
  end interface sort_indices

  interface unique_indices
     module procedure unique_indices_i_i4_
     module procedure unique_indices_i_i8_
     module procedure unique_indices_r_sp_
     module procedure unique_indices_r_dp_
     module procedure unique_indices_a_
  end interface unique_indices

  interface locate
     module procedure locate_i_i4_
     module procedure locate_i_i8_
     module procedure locate_r_sp_
     module procedure locate_r_dp_
     module procedure locate_a_
     module procedure locate_uniform_r_sp_
     module procedure locate_uniform_r_dp_
  end interface locate

  interface index_1d
     module procedure index_1d_i_i4_
     module procedure index_1d_i_i8_
  end interface index_1d

  interface index_nd
     module procedure index_nd_i_i4_
     module procedure index_nd_i_i8_
  end interface index_nd

  ! Access specifiers

  private

  public :: sort_indices
  public :: unique_indices
  public :: index_1d
  public :: index_nd
  public :: locate

  ! Procedures

contains

  function sort_indices_i_i4_ (x, descend) result (indices)

    integer(I4), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer                       :: indices(SIZE(x))

    integer :: N
    integer :: L(0:SIZE(x)+1)
    integer :: i
    integer :: p
    integer :: q
    integer :: s
    integer :: t

    ! Calculate the indices to sort x in increasing order using the
    ! List Merge Sort algorithm described by Knuth (1998, The Art of
    ! Computer Programming Vol. 3, Addison- Wesley, Massachusetts, 3rd
    ! edn.). Labels and variable names deliberately follow those of
    ! Knuth (apart from K() -> x())

    N = SIZE(x)

    ! Special casing if N is 0 or 1; Knuth assumes N >= 2

    if(N == 0) then
       return
    elseif(N == 1) then
       indices(1) = 1
       return
    end if

    ! L1 : Prepare two lists

    L(0) = 1
    L(1:N-2) = [(-(i+2), i=1,N-2)]
    L(N-1:N) = 0
    L(N+1) = 2

    ! L2 : Begin new pass

    L2_loop : do

       s = 0
       t = N + 1

       p = L(s)
       q = L(t)

       if(q == 0) exit L2_loop

       ! L3 : Compare K_p:K_q

       L3_loop : do

          if(x(p) > x(q)) then

             ! L6 : Advance q

             L(s) = SIGN(q, L(s))
             s = q
             q = L(q)

             if(q > 0) cycle L3_loop

             ! L7 : Complete the sublist

             L(s) = p
             s = t

             L7_loop : do

                t = p
                p = L(p)

                if(p <= 0) exit L7_loop

             end do L7_loop

          else

             ! L4 : Advance q

             L(s) = SIGN(p, L(s))
             s = p
             p = L(p)

             if(p > 0) cycle L3_loop

             ! L5 : Complete the sublist

             L(s) = q
             s = t

             L5_loop : do

                t = q
                q = L(q)

                if(q <= 0) exit L5_loop

             end do L5_loop

          end if

          ! L8 : End of pass?

          p = -p
          q = -q

          if(q == 0) then
             L(s) = SIGN(p, L(s))
             L(t) = 0
             exit L3_loop
          endif

       end do L3_loop

    end do L2_loop

    ! Use the link list to set up the indices array

    indices(1) = L(0)

    do i = 2,N
       indices(i) = L(indices(i-1))
    enddo

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(N:1:-1)
    endif

    ! Finish

    return

  end function sort_indices_i_i4_

  function sort_indices_i_i8_ (x, descend) result (indices)

    integer(I8), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer                       :: indices(SIZE(x))

    integer :: N
    integer :: L(0:SIZE(x)+1)
    integer :: i
    integer :: p
    integer :: q
    integer :: s
    integer :: t

    ! Calculate the indices to sort x in increasing order using the
    ! List Merge Sort algorithm described by Knuth (1998, The Art of
    ! Computer Programming Vol. 3, Addison- Wesley, Massachusetts, 3rd
    ! edn.). Labels and variable names deliberately follow those of
    ! Knuth (apart from K() -> x())

    N = SIZE(x)

    ! Special casing if N is 0 or 1; Knuth assumes N >= 2

    if(N == 0) then
       return
    elseif(N == 1) then
       indices(1) = 1
       return
    end if

    ! L1 : Prepare two lists

    L(0) = 1
    L(1:N-2) = [(-(i+2), i=1,N-2)]
    L(N-1:N) = 0
    L(N+1) = 2

    ! L2 : Begin new pass

    L2_loop : do

       s = 0
       t = N + 1

       p = L(s)
       q = L(t)

       if(q == 0) exit L2_loop

       ! L3 : Compare K_p:K_q

       L3_loop : do

          if(x(p) > x(q)) then

             ! L6 : Advance q

             L(s) = SIGN(q, L(s))
             s = q
             q = L(q)

             if(q > 0) cycle L3_loop

             ! L7 : Complete the sublist

             L(s) = p
             s = t

             L7_loop : do

                t = p
                p = L(p)

                if(p <= 0) exit L7_loop

             end do L7_loop

          else

             ! L4 : Advance q

             L(s) = SIGN(p, L(s))
             s = p
             p = L(p)

             if(p > 0) cycle L3_loop

             ! L5 : Complete the sublist

             L(s) = q
             s = t

             L5_loop : do

                t = q
                q = L(q)

                if(q <= 0) exit L5_loop

             end do L5_loop

          end if

          ! L8 : End of pass?

          p = -p
          q = -q

          if(q == 0) then
             L(s) = SIGN(p, L(s))
             L(t) = 0
             exit L3_loop
          endif

       end do L3_loop

    end do L2_loop

    ! Use the link list to set up the indices array

    indices(1) = L(0)

    do i = 2,N
       indices(i) = L(indices(i-1))
    enddo

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(N:1:-1)
    endif

    ! Finish

    return

  end function sort_indices_i_i8_

  function sort_indices_r_sp_ (x, descend) result (indices)

    real(SP), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer                       :: indices(SIZE(x))

    integer :: N
    integer :: L(0:SIZE(x)+1)
    integer :: i
    integer :: p
    integer :: q
    integer :: s
    integer :: t

    ! Calculate the indices to sort x in increasing order using the
    ! List Merge Sort algorithm described by Knuth (1998, The Art of
    ! Computer Programming Vol. 3, Addison- Wesley, Massachusetts, 3rd
    ! edn.). Labels and variable names deliberately follow those of
    ! Knuth (apart from K() -> x())

    N = SIZE(x)

    ! Special casing if N is 0 or 1; Knuth assumes N >= 2

    if(N == 0) then
       return
    elseif(N == 1) then
       indices(1) = 1
       return
    end if

    ! L1 : Prepare two lists

    L(0) = 1
    L(1:N-2) = [(-(i+2), i=1,N-2)]
    L(N-1:N) = 0
    L(N+1) = 2

    ! L2 : Begin new pass

    L2_loop : do

       s = 0
       t = N + 1

       p = L(s)
       q = L(t)

       if(q == 0) exit L2_loop

       ! L3 : Compare K_p:K_q

       L3_loop : do

          if(x(p) > x(q)) then

             ! L6 : Advance q

             L(s) = SIGN(q, L(s))
             s = q
             q = L(q)

             if(q > 0) cycle L3_loop

             ! L7 : Complete the sublist

             L(s) = p
             s = t

             L7_loop : do

                t = p
                p = L(p)

                if(p <= 0) exit L7_loop

             end do L7_loop

          else

             ! L4 : Advance q

             L(s) = SIGN(p, L(s))
             s = p
             p = L(p)

             if(p > 0) cycle L3_loop

             ! L5 : Complete the sublist

             L(s) = q
             s = t

             L5_loop : do

                t = q
                q = L(q)

                if(q <= 0) exit L5_loop

             end do L5_loop

          end if

          ! L8 : End of pass?

          p = -p
          q = -q

          if(q == 0) then
             L(s) = SIGN(p, L(s))
             L(t) = 0
             exit L3_loop
          endif

       end do L3_loop

    end do L2_loop

    ! Use the link list to set up the indices array

    indices(1) = L(0)

    do i = 2,N
       indices(i) = L(indices(i-1))
    enddo

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(N:1:-1)
    endif

    ! Finish

    return

  end function sort_indices_r_sp_

  function sort_indices_r_dp_ (x, descend) result (indices)

    real(DP), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer                       :: indices(SIZE(x))

    integer :: N
    integer :: L(0:SIZE(x)+1)
    integer :: i
    integer :: p
    integer :: q
    integer :: s
    integer :: t

    ! Calculate the indices to sort x in increasing order using the
    ! List Merge Sort algorithm described by Knuth (1998, The Art of
    ! Computer Programming Vol. 3, Addison- Wesley, Massachusetts, 3rd
    ! edn.). Labels and variable names deliberately follow those of
    ! Knuth (apart from K() -> x())

    N = SIZE(x)

    ! Special casing if N is 0 or 1; Knuth assumes N >= 2

    if(N == 0) then
       return
    elseif(N == 1) then
       indices(1) = 1
       return
    end if

    ! L1 : Prepare two lists

    L(0) = 1
    L(1:N-2) = [(-(i+2), i=1,N-2)]
    L(N-1:N) = 0
    L(N+1) = 2

    ! L2 : Begin new pass

    L2_loop : do

       s = 0
       t = N + 1

       p = L(s)
       q = L(t)

       if(q == 0) exit L2_loop

       ! L3 : Compare K_p:K_q

       L3_loop : do

          if(x(p) > x(q)) then

             ! L6 : Advance q

             L(s) = SIGN(q, L(s))
             s = q
             q = L(q)

             if(q > 0) cycle L3_loop

             ! L7 : Complete the sublist

             L(s) = p
             s = t

             L7_loop : do

                t = p
                p = L(p)

                if(p <= 0) exit L7_loop

             end do L7_loop

          else

             ! L4 : Advance q

             L(s) = SIGN(p, L(s))
             s = p
             p = L(p)

             if(p > 0) cycle L3_loop

             ! L5 : Complete the sublist

             L(s) = q
             s = t

             L5_loop : do

                t = q
                q = L(q)

                if(q <= 0) exit L5_loop

             end do L5_loop

          end if

          ! L8 : End of pass?

          p = -p
          q = -q

          if(q == 0) then
             L(s) = SIGN(p, L(s))
             L(t) = 0
             exit L3_loop
          endif

       end do L3_loop

    end do L2_loop

    ! Use the link list to set up the indices array

    indices(1) = L(0)

    do i = 2,N
       indices(i) = L(indices(i-1))
    enddo

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(N:1:-1)
    endif

    ! Finish

    return

  end function sort_indices_r_dp_

  function sort_indices_a_ (x, descend) result (indices)

    character(*), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer                       :: indices(SIZE(x))

    integer :: N
    integer :: L(0:SIZE(x)+1)
    integer :: i
    integer :: p
    integer :: q
    integer :: s
    integer :: t

    ! Calculate the indices to sort x in increasing order using the
    ! List Merge Sort algorithm described by Knuth (1998, The Art of
    ! Computer Programming Vol. 3, Addison- Wesley, Massachusetts, 3rd
    ! edn.). Labels and variable names deliberately follow those of
    ! Knuth (apart from K() -> x())

    N = SIZE(x)

    ! Special casing if N is 0 or 1; Knuth assumes N >= 2

    if(N == 0) then
       return
    elseif(N == 1) then
       indices(1) = 1
       return
    end if

    ! L1 : Prepare two lists

    L(0) = 1
    L(1:N-2) = [(-(i+2), i=1,N-2)]
    L(N-1:N) = 0
    L(N+1) = 2

    ! L2 : Begin new pass

    L2_loop : do

       s = 0
       t = N + 1

       p = L(s)
       q = L(t)

       if(q == 0) exit L2_loop

       ! L3 : Compare K_p:K_q

       L3_loop : do

          if(x(p) > x(q)) then

             ! L6 : Advance q

             L(s) = SIGN(q, L(s))
             s = q
             q = L(q)

             if(q > 0) cycle L3_loop

             ! L7 : Complete the sublist

             L(s) = p
             s = t

             L7_loop : do

                t = p
                p = L(p)

                if(p <= 0) exit L7_loop

             end do L7_loop

          else

             ! L4 : Advance q

             L(s) = SIGN(p, L(s))
             s = p
             p = L(p)

             if(p > 0) cycle L3_loop

             ! L5 : Complete the sublist

             L(s) = q
             s = t

             L5_loop : do

                t = q
                q = L(q)

                if(q <= 0) exit L5_loop

             end do L5_loop

          end if

          ! L8 : End of pass?

          p = -p
          q = -q

          if(q == 0) then
             L(s) = SIGN(p, L(s))
             L(t) = 0
             exit L3_loop
          endif

       end do L3_loop

    end do L2_loop

    ! Use the link list to set up the indices array

    indices(1) = L(0)

    do i = 2,N
       indices(i) = L(indices(i-1))
    enddo

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(N:1:-1)
    endif

    ! Finish

    return

  end function sort_indices_a_

!****

  function unique_indices_i_i4_ (x, descend) result (indices)

    integer(I4), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer, allocatable          :: indices(:)

    integer :: indices_(SIZE(x))
    integer :: n
    integer :: i

    ! Calculate the indices to sort x in increasing order and then
    ! select unique values

    indices_ = sort_indices_i_i4_(x)

    n = 1

    do i = 2,SIZE(x)
       if(x(indices_(i)) /= x(indices_(n))) then
          n = n + 1
          indices_(n) = indices_(i)
       endif
    end do

    indices = indices_(:n)

    do i = 1,SIZE(indices)

    if(.NOT. COUNT(x(indices(i)) == x(indices)) == 1) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''COUNT(x(indices(i)) == x(indices)) == 1'' failed at line 274 <core_order:unique_i' &
 & // 'ndices_i_i4_>'
      stop
    endif

    end do

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(n:1:-1)
    endif

    ! Finish

    return

  end function unique_indices_i_i4_

  function unique_indices_i_i8_ (x, descend) result (indices)

    integer(I8), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer, allocatable          :: indices(:)

    integer :: indices_(SIZE(x))
    integer :: n
    integer :: i

    ! Calculate the indices to sort x in increasing order and then
    ! select unique values

    indices_ = sort_indices_i_i8_(x)

    n = 1

    do i = 2,SIZE(x)
       if(x(indices_(i)) /= x(indices_(n))) then
          n = n + 1
          indices_(n) = indices_(i)
       endif
    end do

    indices = indices_(:n)

    do i = 1,SIZE(indices)

    if(.NOT. COUNT(x(indices(i)) == x(indices)) == 1) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''COUNT(x(indices(i)) == x(indices)) == 1'' failed at line 275 <core_order:unique_i' &
 & // 'ndices_i_i8_>'
      stop
    endif

    end do

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(n:1:-1)
    endif

    ! Finish

    return

  end function unique_indices_i_i8_

  function unique_indices_r_sp_ (x, descend) result (indices)

    real(SP), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer, allocatable          :: indices(:)

    integer :: indices_(SIZE(x))
    integer :: n
    integer :: i

    ! Calculate the indices to sort x in increasing order and then
    ! select unique values

    indices_ = sort_indices_r_sp_(x)

    n = 1

    do i = 2,SIZE(x)
       if(x(indices_(i)) /= x(indices_(n))) then
          n = n + 1
          indices_(n) = indices_(i)
       endif
    end do

    indices = indices_(:n)

    do i = 1,SIZE(indices)

    if(.NOT. COUNT(x(indices(i)) == x(indices)) == 1) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''COUNT(x(indices(i)) == x(indices)) == 1'' failed at line 276 <core_order:unique_i' &
 & // 'ndices_r_sp_>'
      stop
    endif

    end do

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(n:1:-1)
    endif

    ! Finish

    return

  end function unique_indices_r_sp_

  function unique_indices_r_dp_ (x, descend) result (indices)

    real(DP), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer, allocatable          :: indices(:)

    integer :: indices_(SIZE(x))
    integer :: n
    integer :: i

    ! Calculate the indices to sort x in increasing order and then
    ! select unique values

    indices_ = sort_indices_r_dp_(x)

    n = 1

    do i = 2,SIZE(x)
       if(x(indices_(i)) /= x(indices_(n))) then
          n = n + 1
          indices_(n) = indices_(i)
       endif
    end do

    indices = indices_(:n)

    do i = 1,SIZE(indices)

    if(.NOT. COUNT(x(indices(i)) == x(indices)) == 1) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''COUNT(x(indices(i)) == x(indices)) == 1'' failed at line 277 <core_order:unique_i' &
 & // 'ndices_r_dp_>'
      stop
    endif

    end do

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(n:1:-1)
    endif

    ! Finish

    return

  end function unique_indices_r_dp_

  function unique_indices_a_ (x, descend) result (indices)

    character(*), intent(in)             :: x(:)
    logical, optional, intent(in) :: descend
    integer, allocatable          :: indices(:)

    integer :: indices_(SIZE(x))
    integer :: n
    integer :: i

    ! Calculate the indices to sort x in increasing order and then
    ! select unique values

    indices_ = sort_indices_a_(x)

    n = 1

    do i = 2,SIZE(x)
       if(x(indices_(i)) /= x(indices_(n))) then
          n = n + 1
          indices_(n) = indices_(i)
       endif
    end do

    indices = indices_(:n)

    do i = 1,SIZE(indices)

    if(.NOT. COUNT(x(indices(i)) == x(indices)) == 1) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''COUNT(x(indices(i)) == x(indices)) == 1'' failed at line 278 <core_order:unique_i' &
 & // 'ndices_a_>'
      stop
    endif

    end do

    ! If necessary, reverse the indices

    if(PRESENT(descend)) then
       if(descend) indices = indices(n:1:-1)
    endif

    ! Finish

    return

  end function unique_indices_a_

!****

  function index_1d_i_i4_ (i, s) result (i1)

    integer(I4), intent(in)   :: i(:)
    integer, intent(in) :: s(:)
    integer(I4)               :: i1

    integer :: r

  if(SIZE(s)/= SIZE(i)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(s) :', SIZE(s)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(i) :', SIZE(i)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(s)==SIZE(i) failed at line 315 <core_order:index_1d_i_i4_>'
    stop
  endif

    ! Calculate a 1d index from an nd index

    i1 = 0

    do r = 1,SIZE(i)
       i1 = i1 + (i(r)-1)*PRODUCT(s(:r-1))
    end do

    i1 = i1 + 1

    ! Finish

    return

  end function index_1d_i_i4_

  function index_1d_i_i8_ (i, s) result (i1)

    integer(I8), intent(in)   :: i(:)
    integer, intent(in) :: s(:)
    integer(I8)               :: i1

    integer :: r

  if(SIZE(s)/= SIZE(i)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(s) :', SIZE(s)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(i) :', SIZE(i)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(s)==SIZE(i) failed at line 316 <core_order:index_1d_i_i8_>'
    stop
  endif

    ! Calculate a 1d index from an nd index

    i1 = 0

    do r = 1,SIZE(i)
       i1 = i1 + (i(r)-1)*PRODUCT(s(:r-1))
    end do

    i1 = i1 + 1

    ! Finish

    return

  end function index_1d_i_i8_

!****

  function index_nd_i_i4_ (i1, s) result (i)

    integer(I4), intent(in)   :: i1
    integer, intent(in) :: s(:)
    integer(I4)               :: i(SIZE(s))

    integer :: r

  if(SIZE(s)/= SIZE(i)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(s) :', SIZE(s)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(i) :', SIZE(i)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(s)==SIZE(i) failed at line 354 <core_order:index_nd_i_i4_>'
    stop
  endif

    ! Calculate an nd index from a 1d index

    i(1) = i1 - 1

    do r = SIZE(s),2,-1
       i(r) = i(1)/PRODUCT(s(:r-1))
       i(1) = i(1) - i(r)*PRODUCT(s(:r-1))
    end do

    i = i + 1

    ! Finish

    return

  end function index_nd_i_i4_

  function index_nd_i_i8_ (i1, s) result (i)

    integer(I8), intent(in)   :: i1
    integer, intent(in) :: s(:)
    integer(I8)               :: i(SIZE(s))

    integer :: r

  if(SIZE(s)/= SIZE(i)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(s) :', SIZE(s)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(i) :', SIZE(i)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(s)==SIZE(i) failed at line 355 <core_order:index_nd_i_i8_>'
    stop
  endif

    ! Calculate an nd index from a 1d index

    i(1) = i1 - 1

    do r = SIZE(s),2,-1
       i(r) = i(1)/PRODUCT(s(:r-1))
       i(1) = i(1) - i(r)*PRODUCT(s(:r-1))
    end do

    i = i + 1

    ! Finish

    return

  end function index_nd_i_i8_

!****

  subroutine locate_i_i4_ (x, x_loc, i_loc)

    integer(I4), intent(in)    :: x(:)
    integer(I4), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    integer       :: n
    integer, save :: i_lo
    integer, save :: i_hi
    integer       :: di
    integer       :: i_mid

    !$OMP THREADPRIVATE (i_lo, i_hi)

    ! Use a binary search to find where x_loc falls in x (assumed to
    ! be in ascending order); x(i_loc) <= x_loc <= x(i_loc+1)

    n = SIZE(x)

    if(x_loc == x(n)) then

       i_loc = n - 1

    elseif(x_loc == x(1)) then

       i_loc = 1

    else

       if(i_lo < 1 .OR. i_lo >= n) then

          i_lo = 0
          i_hi = n+1

       else

          di = 1

          if(x_loc >= x(i_lo)) then

             search_up_loop : do

                i_hi = i_lo + di

                if(i_hi > n) then
                   i_hi = n + 1
                   exit search_up_loop
                endif

                if(x_loc < x(i_hi)) exit search_up_loop

                i_lo = i_hi
                di = 2*di

             end do search_up_loop

          else

             search_down_loop : do

                i_hi = i_lo
                i_lo = i_hi - di

                if(i_lo < 1) then
                   i_lo = 0
                   exit search_down_loop
                endif

                if(x_loc >= x(i_lo)) exit search_down_loop

             end do search_down_loop

          endif

       endif

       refine_loop : do

          if(i_hi-i_lo <= 1) exit refine_loop

          i_mid = (i_hi + i_lo)/2

          if(x_loc >= x(i_mid)) then
             i_lo = i_mid
          else
             i_hi = i_mid
          endif

       end do refine_loop

       i_loc = i_lo

    endif

    ! Finish

    return

  end subroutine locate_i_i4_

  subroutine locate_i_i8_ (x, x_loc, i_loc)

    integer(I8), intent(in)    :: x(:)
    integer(I8), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    integer       :: n
    integer, save :: i_lo
    integer, save :: i_hi
    integer       :: di
    integer       :: i_mid

    !$OMP THREADPRIVATE (i_lo, i_hi)

    ! Use a binary search to find where x_loc falls in x (assumed to
    ! be in ascending order); x(i_loc) <= x_loc <= x(i_loc+1)

    n = SIZE(x)

    if(x_loc == x(n)) then

       i_loc = n - 1

    elseif(x_loc == x(1)) then

       i_loc = 1

    else

       if(i_lo < 1 .OR. i_lo >= n) then

          i_lo = 0
          i_hi = n+1

       else

          di = 1

          if(x_loc >= x(i_lo)) then

             search_up_loop : do

                i_hi = i_lo + di

                if(i_hi > n) then
                   i_hi = n + 1
                   exit search_up_loop
                endif

                if(x_loc < x(i_hi)) exit search_up_loop

                i_lo = i_hi
                di = 2*di

             end do search_up_loop

          else

             search_down_loop : do

                i_hi = i_lo
                i_lo = i_hi - di

                if(i_lo < 1) then
                   i_lo = 0
                   exit search_down_loop
                endif

                if(x_loc >= x(i_lo)) exit search_down_loop

             end do search_down_loop

          endif

       endif

       refine_loop : do

          if(i_hi-i_lo <= 1) exit refine_loop

          i_mid = (i_hi + i_lo)/2

          if(x_loc >= x(i_mid)) then
             i_lo = i_mid
          else
             i_hi = i_mid
          endif

       end do refine_loop

       i_loc = i_lo

    endif

    ! Finish

    return

  end subroutine locate_i_i8_

  subroutine locate_r_sp_ (x, x_loc, i_loc)

    real(SP), intent(in)    :: x(:)
    real(SP), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    integer       :: n
    integer, save :: i_lo
    integer, save :: i_hi
    integer       :: di
    integer       :: i_mid

    !$OMP THREADPRIVATE (i_lo, i_hi)

    ! Use a binary search to find where x_loc falls in x (assumed to
    ! be in ascending order); x(i_loc) <= x_loc <= x(i_loc+1)

    n = SIZE(x)

    if(x_loc == x(n)) then

       i_loc = n - 1

    elseif(x_loc == x(1)) then

       i_loc = 1

    else

       if(i_lo < 1 .OR. i_lo >= n) then

          i_lo = 0
          i_hi = n+1

       else

          di = 1

          if(x_loc >= x(i_lo)) then

             search_up_loop : do

                i_hi = i_lo + di

                if(i_hi > n) then
                   i_hi = n + 1
                   exit search_up_loop
                endif

                if(x_loc < x(i_hi)) exit search_up_loop

                i_lo = i_hi
                di = 2*di

             end do search_up_loop

          else

             search_down_loop : do

                i_hi = i_lo
                i_lo = i_hi - di

                if(i_lo < 1) then
                   i_lo = 0
                   exit search_down_loop
                endif

                if(x_loc >= x(i_lo)) exit search_down_loop

             end do search_down_loop

          endif

       endif

       refine_loop : do

          if(i_hi-i_lo <= 1) exit refine_loop

          i_mid = (i_hi + i_lo)/2

          if(x_loc >= x(i_mid)) then
             i_lo = i_mid
          else
             i_hi = i_mid
          endif

       end do refine_loop

       i_loc = i_lo

    endif

    ! Finish

    return

  end subroutine locate_r_sp_

  subroutine locate_r_dp_ (x, x_loc, i_loc)

    real(DP), intent(in)    :: x(:)
    real(DP), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    integer       :: n
    integer, save :: i_lo
    integer, save :: i_hi
    integer       :: di
    integer       :: i_mid

    !$OMP THREADPRIVATE (i_lo, i_hi)

    ! Use a binary search to find where x_loc falls in x (assumed to
    ! be in ascending order); x(i_loc) <= x_loc <= x(i_loc+1)

    n = SIZE(x)

    if(x_loc == x(n)) then

       i_loc = n - 1

    elseif(x_loc == x(1)) then

       i_loc = 1

    else

       if(i_lo < 1 .OR. i_lo >= n) then

          i_lo = 0
          i_hi = n+1

       else

          di = 1

          if(x_loc >= x(i_lo)) then

             search_up_loop : do

                i_hi = i_lo + di

                if(i_hi > n) then
                   i_hi = n + 1
                   exit search_up_loop
                endif

                if(x_loc < x(i_hi)) exit search_up_loop

                i_lo = i_hi
                di = 2*di

             end do search_up_loop

          else

             search_down_loop : do

                i_hi = i_lo
                i_lo = i_hi - di

                if(i_lo < 1) then
                   i_lo = 0
                   exit search_down_loop
                endif

                if(x_loc >= x(i_lo)) exit search_down_loop

             end do search_down_loop

          endif

       endif

       refine_loop : do

          if(i_hi-i_lo <= 1) exit refine_loop

          i_mid = (i_hi + i_lo)/2

          if(x_loc >= x(i_mid)) then
             i_lo = i_mid
          else
             i_hi = i_mid
          endif

       end do refine_loop

       i_loc = i_lo

    endif

    ! Finish

    return

  end subroutine locate_r_dp_

  subroutine locate_a_ (x, x_loc, i_loc)

    character(*), intent(in)    :: x(:)
    character(*), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    integer       :: n
    integer, save :: i_lo
    integer, save :: i_hi
    integer       :: di
    integer       :: i_mid

    !$OMP THREADPRIVATE (i_lo, i_hi)

    ! Use a binary search to find where x_loc falls in x (assumed to
    ! be in ascending order); x(i_loc) <= x_loc <= x(i_loc+1)

    n = SIZE(x)

    if(x_loc == x(n)) then

       i_loc = n - 1

    elseif(x_loc == x(1)) then

       i_loc = 1

    else

       if(i_lo < 1 .OR. i_lo >= n) then

          i_lo = 0
          i_hi = n+1

       else

          di = 1

          if(x_loc >= x(i_lo)) then

             search_up_loop : do

                i_hi = i_lo + di

                if(i_hi > n) then
                   i_hi = n + 1
                   exit search_up_loop
                endif

                if(x_loc < x(i_hi)) exit search_up_loop

                i_lo = i_hi
                di = 2*di

             end do search_up_loop

          else

             search_down_loop : do

                i_hi = i_lo
                i_lo = i_hi - di

                if(i_lo < 1) then
                   i_lo = 0
                   exit search_down_loop
                endif

                if(x_loc >= x(i_lo)) exit search_down_loop

             end do search_down_loop

          endif

       endif

       refine_loop : do

          if(i_hi-i_lo <= 1) exit refine_loop

          i_mid = (i_hi + i_lo)/2

          if(x_loc >= x(i_mid)) then
             i_lo = i_mid
          else
             i_hi = i_mid
          endif

       end do refine_loop

       i_loc = i_lo

    endif

    ! Finish

    return

  end subroutine locate_a_

!****

  subroutine locate_uniform_r_sp_ (x_0, dx, x_loc, i_loc)

    real(SP), intent(in)    :: x_0
    real(SP), intent(in)    :: dx
    real(SP), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    ! Determine i_loc so that x_0 + (i_loc-1)*dx <= x_loc < x_0 + i_loc*dx

    i_loc = FLOOR((x_loc - x_0)/dx) + 1

    if(x_0 + (i_loc-1)*dx > x_loc) i_loc = i_loc - 1
    if(x_0 + i_loc*dx <= x_loc) i_loc = i_loc + 1

    ! Finish

    return

  end subroutine locate_uniform_r_sp_

  subroutine locate_uniform_r_dp_ (x_0, dx, x_loc, i_loc)

    real(DP), intent(in)    :: x_0
    real(DP), intent(in)    :: dx
    real(DP), intent(in)    :: x_loc
    integer, intent(out) :: i_loc

    ! Determine i_loc so that x_0 + (i_loc-1)*dx <= x_loc < x_0 + i_loc*dx

    i_loc = FLOOR((x_loc - x_0)/dx) + 1

    if(x_0 + (i_loc-1)*dx > x_loc) i_loc = i_loc - 1
    if(x_0 + i_loc*dx <= x_loc) i_loc = i_loc + 1

    ! Finish

    return

  end subroutine locate_uniform_r_dp_

end module core_order

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core_parallel.inc ../extern/core/core.inc
!   uses: ISO_FORTRAN_ENV core_parallel core_table gyre_cocache gyre_constants gyre_model core_spline core_kinds
!   provides: gyre_evol_model
!end dependencies
!
!end fpx3_header
! Module   : gyre_evol_model
! Purpose  : stellar evolutionary model
!
! Copyright 2013 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

! Incfile  : core_parallel
! Purpose  : parallel support fpx3 macros

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_evol_model

  ! Uses

  use core_kinds
  use core_parallel
  use core_spline
  use core_table

  use gyre_constants
  use gyre_model
  use gyre_cocache

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Parameters

  logical, parameter :: IMPLICIT_U = .FALSE.
  logical, parameter :: IMPLICIT_GAMMA_1 = .FALSE.

  integer, parameter :: J_M = 1
  integer, parameter :: J_P = 2
  integer, parameter :: J_RHO = 3
  integer, parameter :: J_T = 4
  integer, parameter :: J_V = 5
  integer, parameter :: J_AS = 6
  integer, parameter :: J_U = 7
  integer, parameter :: J_C_1 = 8
  integer, parameter :: J_GAMMA_1 = 9
  integer, parameter :: J_NABLA_AD = 10
  integer, parameter :: J_DELTA = 11
  integer, parameter :: J_OMEGA_ROT = 12
  integer, parameter :: J_NABLA = 13
  integer, parameter :: J_C_RAD = 14
  integer, parameter :: J_DC_RAD = 15
  integer, parameter :: J_C_THM = 16
  integer, parameter :: J_C_DIF = 17
  integer, parameter :: J_C_EPS_AD = 18
  integer, parameter :: J_C_EPS_S = 19
  integer, parameter :: J_KAPPA_AD = 20
  integer, parameter :: J_KAPPA_S = 21
  integer, parameter :: J_TAU_THM = 22

  integer, parameter :: N_J = 22

  ! Derived-type definitions

  type, extends (model_t) :: evol_model_t
     private
     type(spline_t), allocatable :: sp(:)
     logical, allocatable        :: sp_def(:)
     type(cocache_t), pointer    :: cc => null()
     real(WP), public            :: M_star
     real(WP), public            :: R_star
     real(WP), public            :: L_star
     real(WP)                    :: p_c
     real(WP)                    :: rho_c
   contains
     private
     procedure         :: set_sp_

    procedure       :: m_1_
    procedure       :: m_v_
    generic, public :: m => m_1_, m_v_

    procedure       :: p_1_
    procedure       :: p_v_
    generic, public :: p => p_1_, p_v_

    procedure       :: rho_1_
    procedure       :: rho_v_
    generic, public :: rho => rho_1_, rho_v_

    procedure       :: T_1_
    procedure       :: T_v_
    generic, public :: T => T_1_, T_v_

    procedure :: V_1_
    procedure :: V_v_

    procedure :: As_1_
    procedure :: As_v_

    procedure :: U_1_
    procedure :: U_v_

    procedure :: c_1_1_
    procedure :: c_1_v_

    procedure :: Gamma_1_1_
    procedure :: Gamma_1_v_

    procedure :: nabla_ad_1_
    procedure :: nabla_ad_v_

    procedure :: delta_1_
    procedure :: delta_v_

    procedure :: Omega_rot_1_
    procedure :: Omega_rot_v_

    procedure :: c_rad_1_
    procedure :: c_rad_v_

    procedure :: dc_rad_1_
    procedure :: dc_rad_v_

    procedure :: c_thm_1_
    procedure :: c_thm_v_

    procedure :: c_dif_1_
    procedure :: c_dif_v_

    procedure :: c_eps_ad_1_
    procedure :: c_eps_ad_v_

    procedure :: c_eps_S_1_
    procedure :: c_eps_S_v_

    procedure :: nabla_1_
    procedure :: nabla_v_

    procedure :: kappa_ad_1_
    procedure :: kappa_ad_v_

    procedure :: kappa_S_1_
    procedure :: kappa_S_v_

    procedure :: tau_thm_1_
    procedure :: tau_thm_v_

     procedure, public :: pi_c => pi_c_
     procedure, public :: is_zero => is_zero_
     procedure, public :: attach_cache => attach_cache_
     procedure, public :: detach_cache => detach_cache_
     procedure, public :: fill_cache => fill_cache_
!     procedure, public :: regularize => regularize_
  end type evol_model_t

  ! Interfaces

  interface evol_model_t
     module procedure evol_model_t_
     module procedure evol_model_t_mech_
     module procedure evol_model_t_mech_coeffs_
     module procedure evol_model_t_full_
  end interface evol_model_t

  ! Access specifiers

  private

  public :: evol_model_t

  ! Procedures

contains

  function evol_model_t_ () result (ml)

    type(evol_model_t) :: ml

    ! Construct the evol_model_t

    allocate(ml%sp(N_J))

    allocate(ml%sp_def(N_J))
    ml%sp_def = .FALSE.

    ml%cc => null()

    ! Finish

    return

  end function evol_model_t_

!****

  recursive function evol_model_t_mech_ (M_star, R_star, L_star, r, m, p, rho, T, N2, &
                                        Gamma_1, nabla_ad, delta, Omega_rot, &
                                        deriv_type, regularize, add_center) result (ml)

    real(WP), intent(in)          :: M_star
    real(WP), intent(in)          :: R_star
    real(WP), intent(in)          :: L_star
    real(WP), intent(in)          :: r(:)
    real(WP), intent(in)          :: m(:)
    real(WP), intent(in)          :: p(:)
    real(WP), intent(in)          :: rho(:)
    real(WP), intent(in)          :: T(:)
    real(WP), intent(in)          :: N2(:)
    real(WP), intent(in)          :: Gamma_1(:)
    real(WP), intent(in)          :: nabla_ad(:)
    real(WP), intent(in)          :: delta(:)
    real(WP), intent(in)          :: Omega_rot(:)
    character(LEN=*), intent(in)  :: deriv_type
    logical, optional, intent(in) :: regularize
    logical, optional, intent(in) :: add_center
    type(evol_model_t)            :: ml

    logical  :: regularize_
    logical  :: add_center_
    integer  :: n
    real(WP) :: m_reg(SIZE(r))
    real(WP) :: p_reg(SIZE(r))
    real(WP) :: N2_reg(SIZE(r))
    real(WP) :: V(SIZE(r))
    real(WP) :: As(SIZE(r))
    real(WP) :: U(SIZE(r))
    real(WP) :: c_1(SIZE(r))
    real(WP) :: Omega_rot_(SIZE(r))
    real(WP) :: x(SIZE(r))

  if(SIZE(m)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(m) :', SIZE(m)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(m)==SIZE(r) failed at line 212 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(p)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(p) :', SIZE(p)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(p)==SIZE(r) failed at line 213 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(rho)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(rho) :', SIZE(rho)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(rho)==SIZE(r) failed at line 214 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(T)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(T) :', SIZE(T)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(T)==SIZE(r) failed at line 215 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(N2)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(N2) :', SIZE(N2)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(N2)==SIZE(r) failed at line 216 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(Gamma_1)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Gamma_1) :', SIZE(Gamma_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Gamma_1)==SIZE(r) failed at line 217 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(nabla_ad)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(nabla_ad) :', SIZE(nabla_ad)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(nabla_ad)==SIZE(r) failed at line 218 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(delta)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(delta) :', SIZE(delta)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(delta)==SIZE(r) failed at line 219 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

  if(SIZE(Omega_rot)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Omega_rot) :', SIZE(Omega_rot)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Omega_rot)==SIZE(r) failed at line 220 <gyre_evol_model:evol_model_t_mech_>'
    stop
  endif

    if (PRESENT(regularize)) then
       regularize_ = regularize
    else
       regularize_ = .FALSE.
    endif

    if(PRESENT(add_center)) then
       add_center_ = add_center
    else
       add_center_ = .FALSE.
    endif

    ! Construct the evol_model_t using the mechanical structure data

    ! See if we need a central point

    if (add_center_) then

       ! Add a central point and initialize using recursion

       ml = evol_model_t(M_star, R_star, L_star, [0._WP,r], [0._WP,m], &
                         prep_center_(r, p), prep_center_(r, rho), prep_center_(r, T), &
                         [0._WP,N2], prep_center_(r, Gamma_1), prep_center_(r, nabla_ad), prep_center_(r, delta), &
                         prep_center_(r, Omega_rot), deriv_type, regularize, .FALSE.)

    elseif (regularize_) then

       ! Regularize and initialize using recursion

       n = SIZE(r)

       call regularize_data_(r, m, p, rho, Gamma_1, N2, deriv_type, m_reg, p_reg, N2_reg)

       ml = evol_model_t(m_reg(n), R_star, L_star, r, m_reg, &
                         p_reg, rho, T, &
                         N2_reg, Gamma_1, nabla_ad, delta, &
                         Omega_rot, deriv_type, .FALSE., .FALSE.)

    else

       ! Perform basic validations

       n = SIZE(r)

    if(.NOT. (r(1) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''r(1) == 0._WP'' failed at line 266 <gyre_evol_model:evol_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'First grid point not at center'
      stop
    endif

    if(.NOT. (m(1) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''m(1) == 0._WP'' failed at line 267 <gyre_evol_model:evol_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'First grid point not at center'
      stop
    endif

    if(.NOT. (ALL(r(2:) > r(:n-1)))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(r(2:) > r(:n-1))'' failed at line 269 <gyre_evol_model:evol_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-monotonic radius data'
      stop
    endif

    if(.NOT. (ALL(m(2:) >= m(:n-1)))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(m(2:) >= m(:n-1))'' failed at line 270 <gyre_evol_model:evol_model_t_mech_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-monotonic mass data'
      stop
    endif

       ! Calculate coefficients

       where(r /= 0._WP)
          V = G_GRAVITY*m*rho/(p*r)
          As = r**3*N2/(G_GRAVITY*m)
          U = 4._WP*PI*rho*r**3/m
          c_1 = (r/R_star)**3/(m/M_star)
       elsewhere
          V = 0._WP
          As = 0._WP
          U = 3._WP
          c_1 = 3._WP*(M_star/R_star**3)/(4._WP*PI*rho)
       end where

       Omega_rot_ = SQRT(R_star**3/(G_GRAVITY*M_star))*Omega_rot

       x = r/R_star

       ! Initialize the model

       ml = evol_model_t()

       !$OMP PARALLEL SECTIONS
       !$OMP SECTION
       call ml%set_sp_(x, m, deriv_type, J_M)
       !$OMP SECTION
       call ml%set_sp_(x, p, deriv_type, J_P)
       !$OMP SECTION
       call ml%set_sp_(x, rho, deriv_type, J_RHO)
       !$OMP SECTION
       call ml%set_sp_(x, T, deriv_type, J_T)
       !$OMP SECTION
       call ml%set_sp_(x, V, deriv_type, J_V)
       !$OMP SECTION
       call ml%set_sp_(x, As, deriv_type, J_AS)
       !$OMP SECTION
       call ml%set_sp_(x, U, deriv_type, J_U)
       !$OMP SECTION
       call ml%set_sp_(x, c_1, deriv_type, J_C_1)
       !$OMP SECTION
       call ml%set_sp_(x, Gamma_1, deriv_type, J_GAMMA_1)
       !$OMP SECTION
       call ml%set_sp_(x, nabla_ad, deriv_type, J_NABLA_AD)
       !$OMP SECTION
       call ml%set_sp_(x, delta, deriv_type, J_DELTA)
       !$OMP SECTION
       call ml%set_sp_(x, Omega_rot_, deriv_type, J_OMEGA_ROT)
       !$OMP END PARALLEL SECTIONS

       ml%M_star = M_star
       ml%R_star = R_star
       ml%L_star = L_star

       ml%p_c = p(1)
       ml%rho_c = rho(1)

    endif

    ! Finish

    return

  end function evol_model_t_mech_

!****

  recursive function evol_model_t_mech_coeffs_ (M_star, R_star, L_star, x, &
                                                V, As, U, c_1, Gamma_1, &
                                                deriv_type, add_center) result (ml)

    real(WP), intent(in)          :: M_star
    real(WP), intent(in)          :: R_star
    real(WP), intent(in)          :: L_star
    real(WP), intent(in)          :: x(:)
    real(WP), intent(in)          :: V(:)
    real(WP), intent(in)          :: As(:)
    real(WP), intent(in)          :: U(:)
    real(WP), intent(in)          :: c_1(:)
    real(WP), intent(in)          :: Gamma_1(:)
    character(LEN=*), intent(in)  :: deriv_type
    logical, optional, intent(in) :: add_center
    type(evol_model_t)            :: ml

    logical  :: add_center_

  if(SIZE(V)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(V) :', SIZE(V)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(V)==SIZE(x) failed at line 357 <gyre_evol_model:evol_model_t_mech_coeffs_>'
    stop
  endif

  if(SIZE(As)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(As) :', SIZE(As)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(As)==SIZE(x) failed at line 358 <gyre_evol_model:evol_model_t_mech_coeffs_>'
    stop
  endif

  if(SIZE(U)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(U) :', SIZE(U)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(U)==SIZE(x) failed at line 359 <gyre_evol_model:evol_model_t_mech_coeffs_>'
    stop
  endif

  if(SIZE(c_1)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(c_1) :', SIZE(c_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(c_1)==SIZE(x) failed at line 360 <gyre_evol_model:evol_model_t_mech_coeffs_>'
    stop
  endif

  if(SIZE(Gamma_1)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Gamma_1) :', SIZE(Gamma_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Gamma_1)==SIZE(x) failed at line 361 <gyre_evol_model:evol_model_t_mech_co' &
 & // 'effs_>'
    stop
  endif

    if(PRESENT(add_center)) then
       add_center_ = add_center
    else
       add_center_ = .FALSE.
    endif

    ! Construct the evol_model_t using the dimensionless coefficients

    ! See if we need a central point

    if(add_center_) then

       ! Add a central point and initialize using recursion

       ml = evol_model_t(M_star, R_star, L_star, &
                         [0._WP,x], [0._WP,V], [0._WP,As], [3._WP,U], &
                         prep_center_(x, c_1), prep_center_(x, Gamma_1), deriv_type, .FALSE.)

    else

       ! Initialize the model

       ml = evol_model_t()

       !$OMP PARALLEL SECTIONS
       !$OMP SECTION
       call ml%set_sp_(x, V, deriv_type, J_V)
       !$OMP SECTION
       call ml%set_sp_(x, As, deriv_type, J_AS)
       !$OMP SECTION
       call ml%set_sp_(x, U, deriv_type, J_U)
       !$OMP SECTION
       call ml%set_sp_(x, c_1, deriv_type, J_C_1)
       !$OMP SECTION
       call ml%set_sp_(x, Gamma_1, deriv_type, J_GAMMA_1)
       !$OMP SECTION
       call ml%set_sp_(x, SPREAD(0._WP, 1, SIZE(x)), deriv_type, J_OMEGA_ROT)
       !$OMP END PARALLEL SECTIONS

       ml%M_star = M_star
       ml%R_star = R_star
       ml%L_star = L_star

       ml%rho_c = 0._WP
       ml%p_c = 0._WP

    endif

    ! Finish

    return

  end function evol_model_t_mech_coeffs_

!****

  recursive function evol_model_t_full_ (M_star, R_star, L_star, r, m, p, rho, T, N2, &
                                         Gamma_1, nabla_ad, delta, Omega_rot, &
                                         nabla, kappa, kappa_rho, kappa_T, &
                                         epsilon, epsilon_rho, epsilon_T, &
                                         deriv_type, regularize, add_center) result (ml)

    real(WP), intent(in)          :: M_star
    real(WP), intent(in)          :: R_star
    real(WP), intent(in)          :: L_star
    real(WP), intent(in)          :: r(:)
    real(WP), intent(in)          :: m(:)
    real(WP), intent(in)          :: p(:)
    real(WP), intent(in)          :: rho(:)
    real(WP), intent(in)          :: T(:)
    real(WP), intent(in)          :: N2(:)
    real(WP), intent(in)          :: Gamma_1(:)
    real(WP), intent(in)          :: nabla_ad(:)
    real(WP), intent(in)          :: delta(:)
    real(WP), intent(in)          :: Omega_rot(:)
    real(WP), intent(in)          :: nabla(:)
    real(WP), intent(in)          :: kappa(:)
    real(WP), intent(in)          :: kappa_rho(:)
    real(WP), intent(in)          :: kappa_T(:)
    real(WP), intent(in)          :: epsilon(:)
    real(WP), intent(in)          :: epsilon_rho(:)
    real(WP), intent(in)          :: epsilon_T(:)
    character(LEN=*), intent(in)  :: deriv_type
    logical, optional, intent(in) :: regularize
    logical, optional, intent(in) :: add_center
    type(evol_model_t)            :: ml

    logical  :: regularize_
    logical  :: add_center_
    integer  :: n
    real(WP) :: m_reg(SIZE(r))
    real(WP) :: p_reg(SIZE(r))
    real(WP) :: N2_reg(SIZE(r))
    real(WP) :: x(SIZE(r))
    real(WP) :: V(SIZE(r))
    real(WP) :: V_x2(SIZE(r))
    real(WP) :: c_p(SIZE(r))
    real(WP) :: c_rad(SIZE(r))
    real(WP) :: c_thm(SIZE(r))
    real(WP) :: c_dif(SIZE(r))
    real(WP) :: kappa_ad(SIZE(r))
    real(WP) :: kappa_S(SIZE(r))
    real(WP) :: epsilon_ad(SIZE(r))
    real(WP) :: epsilon_S(SIZE(r))
    real(WP) :: c_eps_ad(SIZE(r))
    real(WP) :: c_eps_S(SIZE(r))
    real(WP) :: dtau_thm(SIZE(r))
    real(WP) :: tau_thm(SIZE(r))
    integer  :: i

  if(SIZE(m)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(m) :', SIZE(m)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(m)==SIZE(r) failed at line 473 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(p)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(p) :', SIZE(p)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(p)==SIZE(r) failed at line 474 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(rho)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(rho) :', SIZE(rho)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(rho)==SIZE(r) failed at line 475 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(T)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(T) :', SIZE(T)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(T)==SIZE(r) failed at line 476 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(N2)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(N2) :', SIZE(N2)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(N2)==SIZE(r) failed at line 477 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(Gamma_1)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Gamma_1) :', SIZE(Gamma_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Gamma_1)==SIZE(r) failed at line 478 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(nabla_ad)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(nabla_ad) :', SIZE(nabla_ad)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(nabla_ad)==SIZE(r) failed at line 479 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(delta)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(delta) :', SIZE(delta)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(delta)==SIZE(r) failed at line 480 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(nabla)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(nabla) :', SIZE(nabla)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(nabla)==SIZE(r) failed at line 481 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(kappa)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(kappa) :', SIZE(kappa)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(kappa)==SIZE(r) failed at line 482 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(kappa_T)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(kappa_T) :', SIZE(kappa_T)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(kappa_T)==SIZE(r) failed at line 483 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(kappa_rho)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(kappa_rho) :', SIZE(kappa_rho)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(kappa_rho)==SIZE(r) failed at line 484 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(epsilon)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(epsilon) :', SIZE(epsilon)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(epsilon)==SIZE(r) failed at line 485 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(epsilon_T)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(epsilon_T) :', SIZE(epsilon_T)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(epsilon_T)==SIZE(r) failed at line 486 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(epsilon_rho)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(epsilon_rho) :', SIZE(epsilon_rho)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(epsilon_rho)==SIZE(r) failed at line 487 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

  if(SIZE(Omega_rot)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Omega_rot) :', SIZE(Omega_rot)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Omega_rot)==SIZE(r) failed at line 488 <gyre_evol_model:evol_model_t_full_>'
    stop
  endif

    if (PRESENT(regularize)) then
       regularize_ = regularize
    else
       regularize_ = .FALSE.
    endif

    if (PRESENT(add_center)) then
       add_center_ = add_center
    else
       add_center_ = .FALSE.
    endif

    ! Construct the evol_model using the full structure data

    if (add_center_) then

       ! Add a central point and initialize using recursion

       ml = evol_model_t(M_star, R_star, L_star, [0._WP,r], [0._WP,m], &
                         prep_center_(r, p), prep_center_(r, rho), prep_center_(r, T), [0._WP,N2], &
                         prep_center_(r, Gamma_1), prep_center_(r, nabla_ad), prep_center_(r, delta), prep_center_(r, Omega_rot), &
                         prep_center_(r, nabla), prep_center_(r, kappa), prep_center_(r, kappa_rho), prep_center_(r, kappa_T), &
                         prep_center_(r, epsilon), prep_center_(r, epsilon_rho), prep_center_(r, epsilon_T), &
                         deriv_type, regularize, .FALSE.)

    elseif (regularize_) then

       ! Regularize and initialize using recursion

       n = SIZE(r)

       call regularize_data_(r, m, p, rho, Gamma_1, N2, deriv_type, m_reg, p_reg, N2_reg)

       ml = evol_model_t(m_reg(n), R_star, L_star, r, m_reg, &
                         p_reg, rho, T, N2_reg, &
                         Gamma_1, nabla_ad, delta, Omega_rot, &
                         nabla, kappa, kappa_rho, kappa_T, &
                         epsilon, epsilon_rho, epsilon_T, &
                         deriv_type, .FALSE., .FALSE.)

    else

       ! Perform basic validations

       n = SIZE(r)

    if(.NOT. (r(1) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''r(1) == 0._WP'' failed at line 536 <gyre_evol_model:evol_model_t_full_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'First grid point not at center'
      stop
    endif

    if(.NOT. (m(1) == 0._WP)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''m(1) == 0._WP'' failed at line 537 <gyre_evol_model:evol_model_t_full_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'First grid point not at center'
      stop
    endif

    if(.NOT. (ALL(r(2:) > r(:n-1)))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(r(2:) > r(:n-1))'' failed at line 539 <gyre_evol_model:evol_model_t_full_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-monotonic radius data'
      stop
    endif

    if(.NOT. (ALL(m(2:) >= m(:n-1)))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(m(2:) >= m(:n-1))'' failed at line 540 <gyre_evol_model:evol_model_t_full_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Non-monotonic mass data'
      stop
    endif

       ! Calculate coefficients

       x = r/R_star

       where(r /= 0._WP)
          V_x2 = G_GRAVITY*m*rho/(p*r*x**2)
       elsewhere
          V_x2 = 4._WP*PI*G_GRAVITY*rho**2*R_star**2/(3._WP*p)
       end where

       V = V_x2*x**2

       c_p = p*delta/(rho*T*nabla_ad)

       c_rad = 16._WP*PI*A_RADIATION*C_LIGHT*T**4*R_star*nabla*V_x2/(3._WP*kappa*rho*L_star)
       c_thm = 4._WP*PI*rho*T*c_p*SQRT(G_GRAVITY*M_star/R_star**3)*R_star**3/L_star

       kappa_ad = nabla_ad*kappa_T + kappa_rho/Gamma_1
       kappa_S = kappa_T - delta*kappa_rho

       c_dif = (kappa_ad-4._WP*nabla_ad)*V*nabla + nabla_ad*(dlny_dlnx_(x, nabla_ad)+V)

       epsilon_ad = nabla_ad*epsilon_T + epsilon_rho/Gamma_1
       epsilon_S = epsilon_T - delta*epsilon_rho

       c_eps_ad = 4._WP*PI*rho*epsilon_ad*R_star**3/L_star
       c_eps_S = 4._WP*PI*rho*epsilon_S*R_star**3/L_star

       dtau_thm = 4._WP*PI*rho*r**2*T*c_p*SQRT(G_GRAVITY*M_star/R_star**3)/L_star

       tau_thm(n) = 0._WP

       do i = n-1,1,-1
          tau_thm(i) = tau_thm(i+1) + &
               0.5_WP*(dtau_thm(i+1) + dtau_thm(i))*(r(i+1) - r(i))
       end do

       ! Initialize the model

       ml = evol_model_t(M_star, R_star, L_star, r, m, p, rho, T, N2, &
                         Gamma_1, nabla_ad, delta, Omega_rot, &
                         deriv_type, .FALSE.)

       !$OMP PARALLEL SECTIONS
       !$OMP SECTION
       call ml%set_sp_(x, c_rad, deriv_type, J_C_RAD)
       !$OMP SECTION
       call ml%set_sp_(x, c_thm, deriv_type, J_C_THM)
       !$OMP SECTION
       call ml%set_sp_(x, c_dif, deriv_type, J_C_DIF)
       !$OMP SECTION
       call ml%set_sp_(x, c_eps_ad, deriv_type, J_C_EPS_AD)
       !$OMP SECTION
       call ml%set_sp_(x, c_eps_S, deriv_type, J_C_EPS_S)
       !$OMP SECTION
       call ml%set_sp_(x, nabla, deriv_type, J_NABLA)
       !$OMP SECTION
       call ml%set_sp_(x, kappa_S, deriv_type, J_KAPPA_S)
       !$OMP SECTION
       call ml%set_sp_(x, kappa_ad, deriv_type, J_KAPPA_AD)
       !$OMP SECTION
       call ml%set_sp_(x, tau_thm, deriv_type, J_TAU_THM)
       !$OMP END PARALLEL SECTIONS

    endif

    ! Finish

    return

  contains

    function dlny_dlnx_ (x, y)

      real(WP), intent(in) :: x(:)
      real(WP), intent(in) :: y(:)
      real(WP)             :: dlny_dlnx_(SIZE(x))

      integer :: n
      integer :: i

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 623 <gyre_evol_model:evol_model_t_full_:dlny_dl' &
 & // 'nx_>'
    stop
  endif

      ! Calculate the logarithmic derivative of y wrt x

      n = SIZE(x)

      dlny_dlnx_(1) = 0._WP

      do i = 2,n-1
         dlny_dlnx_(i) = x(i)*0.5_WP*((y(i)-y(i-1))/(x(i)-x(i-1)) + (y(i+1)-y(i))/(x(i+1)-x(i)))/y(i)
      end do

      dlny_dlnx_(n) = x(n)*(y(n)-y(n-1))/(x(n)-x(n-1))/y(n)

      ! Finish

    end function dlny_dlnx_

  end function evol_model_t_full_

!****

  subroutine set_sp_ (this, x, y, deriv_type, i)

    class(evol_model_t), intent(inout) :: this
    real(WP), intent(in)               :: x(:)
    real(WP), intent(in)               :: y(:)
    character(LEN=*), intent(in)       :: deriv_type
    integer, intent(in)                :: i

  if(SIZE(y)/= SIZE(x)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(y)==SIZE(x) failed at line 653 <gyre_evol_model:set_sp_>'
    stop
  endif

    ! Set up the i'th spline with the provided data

    this%sp(i) = spline_t(x, y, deriv_type, dy_dx_a=0._WP)

    this%sp_def(i) = .TRUE.

    ! Finish

    return

  end subroutine set_sp_

!****

  function prep_center_ (x, y) result (y_prep)

    real(WP), intent(in) :: x(:)
    real(WP), intent(in) :: y(:)
    real(WP)             :: y_prep(SIZE(y)+1)

    real(WP) :: y_0

  if(SIZE(x)/= SIZE(y)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(x) :', SIZE(x)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(y) :', SIZE(y)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(x)==SIZE(y) failed at line 677 <gyre_evol_model:prep_center_>'
    stop
  endif

    if(.NOT. (SIZE(y) >= 2)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SIZE(y) >= 2'' failed at line 679 <gyre_evol_model:prep_center_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Insufficient grid points'
      stop
    endif

    ! Use parabola fitting to interpolate y at the center

    y_0 = (x(2)**2*y(1) - x(1)**2*y(2))/(x(2)**2 - x(1)**2)

    ! Preprend this to the array

    y_prep = [y_0,y]

    ! Finish

    return

  end function prep_center_

!****

  subroutine regularize_data_ (r, m, p, rho, Gamma_1, N2, deriv_type, m_reg, p_reg, N2_reg)

    real(WP), intent(in)     :: r(:)
    real(WP), intent(in)     :: m(:)
    real(WP), intent(in)     :: p(:)
    real(WP), intent(in)     :: rho(:)
    real(WP), intent(in)     :: Gamma_1(:)
    real(WP), intent(in)     :: N2(:)
    character(*), intent(in) :: deriv_type
    real(WP), intent(out)    :: m_reg(:)
    real(WP), intent(out)    :: p_reg(:)
    real(WP), intent(out)    :: N2_reg(:)

    type(spline_t) :: sp_rho
    type(spline_t) :: sp_dm
    type(spline_t) :: sp_N2
    integer        :: n
    logical        :: N2_mask(SIZE(r))
    real(WP)       :: dlnrho_dlnr(SIZE(r))
    real(WP)       :: g_r(SIZE(r))

  if(SIZE(m)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(m) :', SIZE(m)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(m)==SIZE(r) failed at line 718 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(p)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(p) :', SIZE(p)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(p)==SIZE(r) failed at line 719 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(rho)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(rho) :', SIZE(rho)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(rho)==SIZE(r) failed at line 720 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(Gamma_1)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(Gamma_1) :', SIZE(Gamma_1)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(Gamma_1)==SIZE(r) failed at line 721 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(N2)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(N2) :', SIZE(N2)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(N2)==SIZE(r) failed at line 722 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(m_reg)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(m_reg) :', SIZE(m_reg)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(m_reg)==SIZE(r) failed at line 723 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(p_reg)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(p_reg) :', SIZE(p_reg)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(p_reg)==SIZE(r) failed at line 724 <gyre_evol_model:regularize_data_>'
    stop
  endif

  if(SIZE(N2_reg)/= SIZE(r)) then
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(N2_reg) :', SIZE(N2_reg)
    write(UNIT=ERROR_UNIT, FMT=*) 'SIZE(r) :', SIZE(r)
    write(UNIT=ERROR_UNIT, FMT=*) 'CHECK_BOUNDS SIZE(N2_reg)==SIZE(r) failed at line 725 <gyre_evol_model:regularize_data_>'
    stop
  endif

    ! Regularize the model

    ! Set up interpolating splines

    sp_rho = spline_t(r, rho, deriv_type, dy_dx_a=0._WP)
    sp_dm = spline_t(r, 4._WP*PI*r**2*rho, deriv_type, dy_dx_a=0._WP)

    n = SIZE(N2)

    N2_mask = [.TRUE.,N2(1:n-2) > 0._WP .AND. N2(2:n-1) < 0._WP .AND. N2(3:n) > 0._WP,.TRUE.]

    sp_N2 = spline_t(PACK(r, N2_mask), PACK(N2, N2_mask), deriv_type, dy_dx_a=0._WP)

    ! Recalculate m

    m_reg = sp_dm%integ()

    ! Calculate dlnrho/dlnr

    dlnrho_dlnr = r*sp_rho%deriv()/rho

    ! Calculate g/r

    where (r /= 0._WP)
       g_r = G_GRAVITY*m_reg/r**3
    elsewhere
       g_r = 4._WP*PI*G_GRAVITY*rho
    endwhere

    ! Recalculate N2

    N2_reg = sp_N2%interp(r)

    ! Recalculate p

    where (r /= 0._WP)
       p_reg = -rho*g_r*r**2/(Gamma_1*(N2_reg/g_r + dlnrho_dlnr))
    endwhere

    where (r == 0._WP)
       p_reg = MAXVAL(p_reg, MASK=r /= 0._WP)
    endwhere

    if(.NOT. (ALL(p_reg > 0._WP))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ALL(p_reg > 0._WP)'' failed at line 770 <gyre_evol_model:regularize_data_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Negative regularized pressure'
      stop
    endif

    ! Finish

    return

  end subroutine regularize_data_

!****

  function m_1_ (this, x) result (m)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: m

    integer :: j

    ! Interpolate $NAME

    j = J_M

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          m = this%cc%lookup(j, x)
       else
          m = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 846 <gyre_evol_model:m_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'm is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function m_1_

  function m_v_ (this, x) result (m)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: m(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_M

    if(this%sp_def(j)) then

       m = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 846 <gyre_evol_model:m_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'm is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function m_v_

  function p_1_ (this, x) result (p)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: p

    integer :: j

    ! Interpolate $NAME

    j = J_P

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          p = this%cc%lookup(j, x)
       else
          p = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 847 <gyre_evol_model:p_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'p is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function p_1_

  function p_v_ (this, x) result (p)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: p(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_P

    if(this%sp_def(j)) then

       p = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 847 <gyre_evol_model:p_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'p is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function p_v_

  function rho_1_ (this, x) result (rho)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: rho

    integer :: j

    ! Interpolate $NAME

    j = J_RHO

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          rho = this%cc%lookup(j, x)
       else
          rho = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 848 <gyre_evol_model:rho_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'rho is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function rho_1_

  function rho_v_ (this, x) result (rho)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: rho(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_RHO

    if(this%sp_def(j)) then

       rho = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 848 <gyre_evol_model:rho_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'rho is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function rho_v_

  function T_1_ (this, x) result (T)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: T

    integer :: j

    ! Interpolate $NAME

    j = J_T

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          T = this%cc%lookup(j, x)
       else
          T = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 849 <gyre_evol_model:T_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'T is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function T_1_

  function T_v_ (this, x) result (T)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: T(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_T

    if(this%sp_def(j)) then

       T = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 849 <gyre_evol_model:T_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'T is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function T_v_

  function V_1_ (this, x) result (V)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: V

    integer :: j

    ! Interpolate $NAME

    j = J_V

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          V = this%cc%lookup(j, x)
       else
          V = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 850 <gyre_evol_model:V_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'V is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function V_1_

  function V_v_ (this, x) result (V)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: V(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_V

    if(this%sp_def(j)) then

       V = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 850 <gyre_evol_model:V_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'V is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function V_v_

  function As_1_ (this, x) result (As)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: As

    integer :: j

    ! Interpolate $NAME

    j = J_AS

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          As = this%cc%lookup(j, x)
       else
          As = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 851 <gyre_evol_model:As_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'As is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function As_1_

  function As_v_ (this, x) result (As)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: As(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_AS

    if(this%sp_def(j)) then

       As = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 851 <gyre_evol_model:As_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'As is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function As_v_

  function c_1_1_ (this, x) result (c_1)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_1

    integer :: j

    ! Interpolate $NAME

    j = J_C_1

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          c_1 = this%cc%lookup(j, x)
       else
          c_1 = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 852 <gyre_evol_model:c_1_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_1 is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_1_1_

  function c_1_v_ (this, x) result (c_1)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_1(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_C_1

    if(this%sp_def(j)) then

       c_1 = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 852 <gyre_evol_model:c_1_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_1 is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_1_v_

  function nabla_ad_1_ (this, x) result (nabla_ad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: nabla_ad

    integer :: j

    ! Interpolate $NAME

    j = J_NABLA_AD

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          nabla_ad = this%cc%lookup(j, x)
       else
          nabla_ad = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 853 <gyre_evol_model:nabla_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla_ad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function nabla_ad_1_

  function nabla_ad_v_ (this, x) result (nabla_ad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: nabla_ad(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_NABLA_AD

    if(this%sp_def(j)) then

       nabla_ad = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 853 <gyre_evol_model:nabla_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla_ad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function nabla_ad_v_

  function delta_1_ (this, x) result (delta)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: delta

    integer :: j

    ! Interpolate $NAME

    j = J_DELTA

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          delta = this%cc%lookup(j, x)
       else
          delta = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 854 <gyre_evol_model:delta_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'delta is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function delta_1_

  function delta_v_ (this, x) result (delta)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: delta(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_DELTA

    if(this%sp_def(j)) then

       delta = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 854 <gyre_evol_model:delta_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'delta is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function delta_v_

  function Omega_rot_1_ (this, x) result (Omega_rot)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: Omega_rot

    integer :: j

    ! Interpolate $NAME

    j = J_OMEGA_ROT

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          Omega_rot = this%cc%lookup(j, x)
       else
          Omega_rot = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 855 <gyre_evol_model:Omega_rot_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Omega_rot is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function Omega_rot_1_

  function Omega_rot_v_ (this, x) result (Omega_rot)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: Omega_rot(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_OMEGA_ROT

    if(this%sp_def(j)) then

       Omega_rot = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 855 <gyre_evol_model:Omega_rot_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Omega_rot is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function Omega_rot_v_

  function nabla_1_ (this, x) result (nabla)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: nabla

    integer :: j

    ! Interpolate $NAME

    j = J_NABLA

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          nabla = this%cc%lookup(j, x)
       else
          nabla = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 856 <gyre_evol_model:nabla_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function nabla_1_

  function nabla_v_ (this, x) result (nabla)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: nabla(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_NABLA

    if(this%sp_def(j)) then

       nabla = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 856 <gyre_evol_model:nabla_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'nabla is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function nabla_v_

  function c_rad_1_ (this, x) result (c_rad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_rad

    integer :: j

    ! Interpolate $NAME

    j = J_C_RAD

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          c_rad = this%cc%lookup(j, x)
       else
          c_rad = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 857 <gyre_evol_model:c_rad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_rad_1_

  function c_rad_v_ (this, x) result (c_rad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_rad(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_C_RAD

    if(this%sp_def(j)) then

       c_rad = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 857 <gyre_evol_model:c_rad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_rad_v_

  function c_thm_1_ (this, x) result (c_thm)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_thm

    integer :: j

    ! Interpolate $NAME

    j = J_C_THM

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          c_thm = this%cc%lookup(j, x)
       else
          c_thm = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 858 <gyre_evol_model:c_thm_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_thm is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_thm_1_

  function c_thm_v_ (this, x) result (c_thm)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_thm(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_C_THM

    if(this%sp_def(j)) then

       c_thm = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 858 <gyre_evol_model:c_thm_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_thm is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_thm_v_

  function c_dif_1_ (this, x) result (c_dif)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_dif

    integer :: j

    ! Interpolate $NAME

    j = J_C_DIF

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          c_dif = this%cc%lookup(j, x)
       else
          c_dif = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 859 <gyre_evol_model:c_dif_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_dif is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_dif_1_

  function c_dif_v_ (this, x) result (c_dif)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_dif(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_C_DIF

    if(this%sp_def(j)) then

       c_dif = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 859 <gyre_evol_model:c_dif_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_dif is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_dif_v_

  function c_eps_ad_1_ (this, x) result (c_eps_ad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_eps_ad

    integer :: j

    ! Interpolate $NAME

    j = J_C_EPS_AD

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          c_eps_ad = this%cc%lookup(j, x)
       else
          c_eps_ad = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 860 <gyre_evol_model:c_eps_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_ad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_eps_ad_1_

  function c_eps_ad_v_ (this, x) result (c_eps_ad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_eps_ad(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_C_EPS_AD

    if(this%sp_def(j)) then

       c_eps_ad = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 860 <gyre_evol_model:c_eps_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_ad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_eps_ad_v_

  function c_eps_S_1_ (this, x) result (c_eps_S)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: c_eps_S

    integer :: j

    ! Interpolate $NAME

    j = J_C_EPS_S

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          c_eps_S = this%cc%lookup(j, x)
       else
          c_eps_S = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 861 <gyre_evol_model:c_eps_S_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_S is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_eps_S_1_

  function c_eps_S_v_ (this, x) result (c_eps_S)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: c_eps_S(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_C_EPS_S

    if(this%sp_def(j)) then

       c_eps_S = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 861 <gyre_evol_model:c_eps_S_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_eps_S is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function c_eps_S_v_

  function kappa_S_1_ (this, x) result (kappa_S)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: kappa_S

    integer :: j

    ! Interpolate $NAME

    j = J_KAPPA_S

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          kappa_S = this%cc%lookup(j, x)
       else
          kappa_S = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 862 <gyre_evol_model:kappa_S_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_S is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function kappa_S_1_

  function kappa_S_v_ (this, x) result (kappa_S)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: kappa_S(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_KAPPA_S

    if(this%sp_def(j)) then

       kappa_S = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 862 <gyre_evol_model:kappa_S_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_S is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function kappa_S_v_

  function kappa_ad_1_ (this, x) result (kappa_ad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: kappa_ad

    integer :: j

    ! Interpolate $NAME

    j = J_KAPPA_AD

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          kappa_ad = this%cc%lookup(j, x)
       else
          kappa_ad = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 863 <gyre_evol_model:kappa_ad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_ad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function kappa_ad_1_

  function kappa_ad_v_ (this, x) result (kappa_ad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: kappa_ad(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_KAPPA_AD

    if(this%sp_def(j)) then

       kappa_ad = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 863 <gyre_evol_model:kappa_ad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'kappa_ad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function kappa_ad_v_

  function tau_thm_1_ (this, x) result (tau_thm)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: tau_thm

    integer :: j

    ! Interpolate $NAME

    j = J_TAU_THM

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          tau_thm = this%cc%lookup(j, x)
       else
          tau_thm = this%sp(j)%interp(x)
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 864 <gyre_evol_model:tau_thm_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'tau_thm is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function tau_thm_1_

  function tau_thm_v_ (this, x) result (tau_thm)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: tau_thm(SIZE(x))

    integer :: j

    ! Interpolate $NAME

    j = J_TAU_THM

    if(this%sp_def(j)) then

       tau_thm = this%sp(j)%interp(x)

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 864 <gyre_evol_model:tau_thm_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'tau_thm is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function tau_thm_v_

!****

  function dc_rad_1_ (this, x) result (dc_rad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: dc_rad

    integer :: j
    integer :: j_d

    ! Interpolate dln$NAME/dlnx

    j = J_C_RAD
    j_d = J_DC_RAD

    if(this%sp_def(j)) then

       if(ASSOCIATED(this%cc)) then
          dc_rad = this%cc%lookup(j_d, x)
       else
          if(x > 0._WP) then
             dc_rad = x*this%sp(j)%deriv(x)/this%sp(j)%interp(x)
          else
             dc_rad = 0._WP
          endif
       endif

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 944 <gyre_evol_model:dc_rad_1_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function dc_rad_1_

  function dc_rad_v_ (this, x) result (dc_rad)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: dc_rad(SIZE(x))

    integer :: j

    ! Interpolate dln$NAME/dlnx

    j = J_C_RAD

    if(this%sp_def(j)) then

       where(x > 0._WP)
          dc_rad = x*this%sp(j)%deriv(x)/this%sp(j)%interp(x)
       elsewhere
          dc_rad = 0._WP
       endwhere

    else

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 944 <gyre_evol_model:dc_rad_v_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'c_rad is undefined'

  stop 'Program aborted'

    endif

    ! Finish

    return

  end function dc_rad_v_

!****

  function U_1_ (this, x) result (U)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: U

    ! Calculate U. If implicit_U is .TRUE., use the c_1 based
    ! expression; this ensures that the correct relation between U and
    ! c_1 is preserved (see, e.g., eqn. 18 of Takata 2006, Proc. SOHO
    ! 18/GONG 2006/HELAS I, p. 26)

    if(ASSOCIATED(this%cc)) then

       U = this%cc%lookup(J_U, x)

    else

       if(implicit_U) then
          U = 3._WP - x*this%sp(J_C_1)%deriv(x)/this%sp(J_C_1)%interp(x)
       else
          U =  this%sp(J_U)%interp(x)
       endif

    endif

    ! Finish

    return

  end function U_1_

!****

  function U_v_ (this, x) result (U)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: U(SIZE(x))

    ! Calculate U. If implicit_U is .TRUE., use the c_1 based
    ! expression; this ensures that the correct relation between U and
    ! c_1 is preserved (see, e.g., eqn. 18 of Takata 2006, Proc. SOHO
    ! 18/GONG 2006/HELAS I, p. 26)

    if(implicit_U) then
       U = 3._WP - x*this%sp(J_C_1)%deriv(x)/this%sp(J_C_1)%interp(x)
    else
       U =  this%sp(J_U)%interp(x)
    endif

    ! Finish

    return

  end function U_v_

!****

  function Gamma_1_1_ (this, x) result (Gamma_1)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    real(WP)                        :: Gamma_1

    ! Calculate Gamma_1. If implicit_Gamma_1 is .TRUE., derive from
    ! other structure coefficients

    if(ASSOCIATED(this%cc)) then

       Gamma_1 = this%cc%lookup(J_GAMMA_1, x)

    else

       if(implicit_Gamma_1 .AND. x /= 0._WP) then

          Gamma_1 = this%V(x)/(-this%As(x) + this%U(x) + this%V(x) - 1._WP - &
                               x*this%sp(J_V)%deriv(x)/this%V(x))

       else

          Gamma_1 = this%sp(J_GAMMA_1)%interp(x)

       endif

    endif

    ! Finish

    return

  end function Gamma_1_1_

!****

  function Gamma_1_v_ (this, x) result (Gamma_1)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x(:)
    real(WP)                        :: Gamma_1(SIZE(x))

    ! Calculate Gamma_1. If implicit_Gamma_1 is .TRUE., derive from
    ! other structure coefficients

    where(implicit_Gamma_1 .AND. x /= 0._WP)

       Gamma_1 = this%V(x)/(-this%As(x) + this%U(x) + this%V(x) - 1._WP - &
                            x*this%sp(J_V)%deriv(x)/this%V(x))

    elsewhere

       Gamma_1 = this%sp(J_GAMMA_1)%interp(x)

    end where

    ! Finish

    return

  end function Gamma_1_v_

!****

  function pi_c_ (this) result (pi_c)

    class(evol_model_t), intent(in) :: this
    real(WP)                         :: pi_c

    ! Calculate pi_c = V/x^2 as x -> 0

    pi_c = 4._WP*PI*G_GRAVITY*this%rho(0._WP)**2*this%R_star**2/(3._WP*this%p(0._WP))

    ! Finish

    return

  end function pi_c_

!****

  function is_zero_ (this, x) result (is_zero)

    class(evol_model_t), intent(in) :: this
    real(WP), intent(in)            :: x
    logical                         :: is_zero

    logical :: p_zero
    logical :: rho_zero

    ! Determine whether the point at x has a vanishing pressure and/or
    ! density

    if(this%sp_def(J_P)) then
       p_zero = this%p(x) == 0._WP
    else
       p_zero = .FALSE.
    endif

    if(this%sp_def(J_RHO)) then
       rho_zero = this%rho(x) == 0._WP
    else
       rho_zero = .FALSE.
    endif

    is_zero = P_ZERO .OR. RHO_ZERO

    ! Finish

    return

  end function is_zero_

!****

  subroutine attach_cache_ (this, cc)

    class(evol_model_t), intent(inout)    :: this
    class(cocache_t), pointer, intent(in) :: cc

    ! Attach a coefficient cache

    this%cc => cc

    ! Finish

    return

  end subroutine attach_cache_

!****

  subroutine detach_cache_ (this)

    class(evol_model_t), intent(inout) :: this

    ! Detach the coefficient cache

    this%cc => null()

    ! Finish

    return

  end subroutine detach_cache_

!****

  subroutine fill_cache_ (this, x)

    class(evol_model_t), intent(inout) :: this
    real(WP), intent(in)               :: x(:)

    real(WP) :: c(N_J,SIZE(x))

    if(.NOT. (ASSOCIATED(this%cc))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''ASSOCIATED(this%cc)'' failed at line 1161 <gyre_evol_model:fill_cache_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'No cache attached'
      stop
    endif

    ! Fill the coefficient cache

    !$OMP PARALLEL SECTIONS
    !$OMP SECTION
    if (this%sp_def(J_M)) c(J_M,:) = this%m(x)
    !$OMP SECTION
    if (this%sp_def(J_P)) c(J_P,:) = this%p(x)
    !$OMP SECTION
    if (this%sp_def(J_RHO)) c(J_RHO,:) = this%rho(x)
    !$OMP SECTION
    if (this%sp_def(J_T)) c(J_T,:) = this%T(x)
    !$OMP SECTION
    if (this%sp_def(J_V)) c(J_V,:) = this%V(x)
    !$OMP SECTION
    if (this%sp_def(J_AS)) c(J_AS,:) = this%As(x)
    !$OMP SECTION
    if (this%sp_def(J_U)) c(J_U,:) = this%U(x)
    !$OMP SECTION
    if (this%sp_def(J_C_1)) c(J_C_1,:) = this%c_1(x)
    !$OMP SECTION
    if (this%sp_def(J_GAMMA_1)) c(J_GAMMA_1,:) = this%Gamma_1(x)
    !$OMP SECTION
    if (this%sp_def(J_NABLA_AD)) c(J_NABLA_AD,:) = this%nabla_ad(x)
    !$OMP SECTION
    if (this%sp_def(J_DELTA)) c(J_DELTA,:) = this%delta(x)
    !$OMP SECTION
    if (this%sp_def(J_OMEGA_ROT)) c(J_OMEGA_ROT,:) = this%Omega_rot(x)
    !$OMP SECTION
    if (this%sp_def(J_NABLA)) c(J_NABLA,:) = this%nabla(x)
    !$OMP SECTION
    if (this%sp_def(J_C_RAD)) c(J_C_RAD,:) = this%c_rad(x)
    !$OMP SECTION
    if (this%sp_def(J_C_RAD)) c(J_DC_RAD,:) = this%dc_rad(x)
    !$OMP SECTION
    if (this%sp_def(J_C_THM)) c(J_C_THM,:) = this%c_thm(x)
    !$OMP SECTION
    if (this%sp_def(J_C_DIF)) c(J_C_DIF,:) = this%c_dif (x)
    !$OMP SECTION
    if (this%sp_def(J_C_EPS_AD)) c(J_C_EPS_AD,:) = this%c_eps_ad(x)
    !$OMP SECTION
    if (this%sp_def(J_C_EPS_S)) c(J_C_EPS_S,:) = this%c_eps_S(x)
    !$OMP SECTION
    if (this%sp_def(J_KAPPA_S)) c(J_KAPPA_S,:) = this%kappa_S(x)
    !$OMP SECTION
    if (this%sp_def(J_KAPPA_AD)) c(J_KAPPA_AD,:) = this%kappa_ad(x)
    !$OMP SECTION
    if (this%sp_def(J_TAU_THM)) c(J_TAU_THM,:) = this%tau_thm(x)
    !$OMP END PARALLEL SECTIONS

    this%cc = cocache_t(x, c)

    ! Finish

    return

  end subroutine fill_cache_

!****

end module gyre_evol_model

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: ISO_FORTRAN_ENV omp_lib core_order core_kinds
!   provides: core_parallel
!end dependencies
!
!end fpx3_header
! Module   : core_parallel
! Purpose  : parallel support

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_parallel

  ! Uses

  use core_kinds
  use core_order

  use ISO_FORTRAN_ENV

  use omp_lib

  ! No implicit typing

  implicit none

  ! Module variables

  integer, save, protected :: MPI_SIZE
  integer, save, protected :: MPI_RANK
  integer, save, protected :: OMP_SIZE_MAX

  ! Interfaces

  ! Access specifiers

  private

  public :: MPI_SIZE
  public :: MPI_RANK
  public :: OMP_SIZE_MAX
  public :: init_parallel
  public :: final_parallel
  public :: omp_size
  public :: omp_rank

  public :: omp_get_thread_num

  public :: partition_tasks

contains

  subroutine init_parallel ()

    ! Initialize MPI

    MPI_SIZE = 1
    MPI_RANK = 0

    ! Initialize OpenMP

    OMP_SIZE_MAX = omp_get_max_threads()

    ! Finish

    return

  end subroutine init_parallel

!****

  subroutine final_parallel ()

    ! Finalize MPI

    MPI_SIZE = 0
    MPI_RANK = 0

    ! Finish

    return

  end subroutine final_parallel

!****

  function omp_size ()

    integer :: omp_size

    ! Get the OpenMP thread size

    omp_size = omp_get_num_threads()

    ! Finish

    return

  end function omp_size

!****

  function omp_rank ()

    integer :: omp_rank

    ! Get the OpenMP thread rank

    omp_rank = omp_get_thread_num()

    ! finish

    return

  end function omp_rank

!****

!****

  subroutine partition_tasks (n, m, k_part)

    integer, intent(in)  :: n
    integer, intent(in)  :: m
    integer, intent(out) :: k_part(:)

    integer :: n_work
    integer :: n_part(SIZE(k_part)-1)
    integer :: i

    n_work = SIZE(k_part) - 1

    ! Partition n tasks among n_work workers --- where possible, at
    ! least m tasks per worker. The resulting partitioning indices are
    ! returned in the array k_part

    n_part = m*(n/(m*n_work))

    size_loop : do i = 1, n_work
       if(SUM(n_part) >= n-m+1) then
          n_part(i) = n_part(i) + n - SUM(n_part)
          exit size_loop
       else
          n_part(i) = n_part(i) + m
       endif
    end do size_loop

    if(.NOT. (SUM(n_part) == n)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''SUM(n_part) == n'' failed at line 1324 <core_parallel:partition_tasks>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Partitioning failed'
      stop
    endif

    k_part(1) = 1

    index_loop : do i = 1, n_work
       k_part(i+1) = k_part(i) + n_part(i)
    end do index_loop

    ! Finish

    return

  end subroutine partition_tasks

end module core_parallel

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: core_kinds ISO_FORTRAN_ENV
!   provides: core_func
!end dependencies
!
!end fpx3_header
! Module   : core_func
! Purpose  : monovariate functions

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_func

  ! Uses

  use core_kinds

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type, abstract :: func_t
   contains
     private
     procedure                    :: eval_r_
     procedure(eval_c_), deferred :: eval_c_
     generic, public              :: eval => eval_r_, eval_c_
     procedure, public            :: expand_bracket => expand_bracket_
     procedure, public            :: narrow_bracket => narrow_bracket_
     procedure                    :: root_r_
     procedure                    :: root_c_
     generic, public              :: root => root_r_, root_c_
     procedure, public            :: minimum => minimum_r_
     procedure, public            :: maximum => maximum_r_
  end type func_t

  ! Interfaces

  abstract interface
    function eval_c_ (this, z) result (f_z)
      use core_kinds
      import func_t
      class(func_t), intent(inout) :: this
      complex(WP), intent(in)      :: z
      complex(WP)                  :: f_z
    end function eval_c_
  end interface

  ! Access specifiers

  private

  public :: func_t

  ! Procedures

contains

    function eval_r_ (this, x) result (f_x)

    class(func_t), intent(inout) :: this
    real(WP), intent(in)         :: x
    real(WP)                     :: f_x

    ! Evaluate the real function based on the complex function
    ! this%eval(z)

    f_x = REAL(this%eval(CMPLX(x, KIND=WP)), WP)

    ! Finish

    return

  end function eval_r_

!****

  subroutine expand_bracket_ (this, x_a, x_b, f_x_a, f_x_b, clamp_a, clamp_b)

    class(func_t), intent(inout)    :: this
    real(WP), intent(inout)         :: x_a
    real(WP), intent(inout)         :: x_b
    real(WP), intent(out), optional :: f_x_a
    real(WP), intent(out), optional :: f_x_b
    logical, intent(in), optional   :: clamp_a
    logical, intent(in), optional   :: clamp_b

    real(WP), parameter :: EXPAND_FACTOR = 1.6_WP

    logical  :: clamp_a_
    logical  :: clamp_b_
    real(WP) :: f_a
    real(WP) :: f_b
    logical  :: move_a

    if(PRESENT(clamp_a)) then
       clamp_a_ = clamp_a
    else
       clamp_a_ = .FALSE.
    endif

    if(PRESENT(clamp_b)) then
       clamp_b_ = clamp_b
    else
       clamp_b_ = .FALSE.
    endif

    if(.NOT. (.NOT. (clamp_a_ .AND. clamp_b_))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''.NOT. (clamp_a_ .AND. clamp_b_)'' failed at line 106 <core_func:expand_bracket_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Cannot clamp both points'
      stop
    endif

    if(.NOT. (x_a /= x_b)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''x_a /= x_b'' failed at line 108 <core_func:expand_bracket_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid initial bracket'
      stop
    endif

    ! Expand the bracket [x_a,x_b] until it contains a root of the real function this%eval(x)

    f_a = this%eval(x_a)
    f_b = this%eval(x_b)

    expand_loop : do

       if((f_a > 0._WP .AND. f_b < 0._WP) .OR. &
          (f_a < 0._WP .AND. f_b > 0._WP)) exit expand_loop

       if(clamp_a_) then
          move_a = .FALSE.
       elseif(clamp_b_) then
          move_a = .TRUE.
       else
          move_a = ABS(f_b) > ABS(f_a)
       endif

       if(move_a) then
          x_a = x_a + EXPAND_FACTOR*(x_a - x_b)
          f_a = this%eval(x_a)
       else
          x_b = x_b + EXPAND_FACTOR*(x_b - x_a)
          f_b = this%eval(x_b)
       endif

    end do expand_loop

    ! Store f_a and f_b

    if(PRESENT(f_x_a)) f_x_a = f_a
    if(PRESENT(f_x_b)) f_x_b = f_b

    ! Finish

    return

  end subroutine expand_bracket_

!****

  subroutine narrow_bracket_ (this, x_a, x_b, x_tol, f_x_a, f_x_b, n_iter, relative_tol)

    class(func_t), intent(inout)      :: this
    real(WP), intent(inout)           :: x_a
    real(WP), intent(inout)           :: x_b
    real(WP), intent(in)              :: x_tol
    real(WP), optional, intent(inout) :: f_x_a
    real(WP), optional, intent(inout) :: f_x_b
    integer, optional, intent(inout)  :: n_iter
    logical, optional, intent(in)     :: relative_tol

    real(WP), parameter :: EPS = EPSILON(0._WP)

    integer  :: n_iter_
    logical  :: relative_tol_
    real(WP) :: a
    real(WP) :: b
    real(WP) :: c
    real(WP) :: d
    real(WP) :: e
    real(WP) :: f_a
    real(WP) :: f_b
    real(WP) :: f_c
    real(WP) :: tol
    real(WP) :: m
    real(WP) :: p
    real(WP) :: q
    real(WP) :: r
    real(WP) :: s
    integer  :: i

    if(PRESENT(n_iter)) then
       n_iter_ = n_iter
    else
       n_iter_ = 50
    end if

    if(PRESENT(relative_tol)) then
       relative_tol_ = relative_tol
    else
       relative_tol_ = .FALSE.
    endif

    ! Use Brent's method [based on the ALGOL 60 routine 'zero'
    ! published in Brent (1973, "Algorithms for Minimization without
    ! Derivatives", Prentice Hall, Englewood Cliffs] to narrow the
    ! bracket [x_a,x_b] bracket on the real function this%eval(x)

    ! Set up the initial state

    a = x_a
    b = x_b

    if(PRESENT(f_x_a)) then
       f_a = f_x_a
    else
       f_a = this%eval(a)
    endif

    if(PRESENT(f_x_b)) then
       f_b = f_x_b
    else
       f_b = this%eval(b)
    endif

    c = b
    f_c = f_b

    ! Check that a root does indeed lie within the bracket

    if(.NOT. ((f_a >= 0._WP .AND. f_b <= 0._WP) .OR. (f_a <= 0._WP .AND. f_b >= 0._WP))) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''(f_a >= 0._WP .AND. f_b <= 0._WP) .OR. (f_a <= 0._WP .AND. f_b >= 0._WP)'' failed' &
 & // ' at line 221 <core_func:narrow_bracket_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Root is not bracketed'
      stop
    endif

    ! Iterate until the correction drops below the threshold, or the
    ! maximum number of iterations is exceeded

    iterate_loop : do i = 1,n_iter_

       ! Reorder c so that it has the opposite sign to b

       if(f_b > 0. .EQV. f_c > 0.) then
          c = a
          f_c = f_a
          d = b - a
          e = d
       endif

       ! Make sure that the function is smallest in magnitude
       ! at b

       if(ABS(f_c) < ABS(f_b)) then
          a = b
          b = c
          c = a
          f_a = f_b
          f_b = f_c
          f_c = f_a
       endif

       if(relative_tol_) then
          tol = (2.*EPS + x_tol)*ABS(b)
       else
          tol = 2.*EPS*ABS(b) + x_tol
       endif

       m = 0.5*(c - b)

       ! Check for convergence

       if(ABS(m) <= tol .OR. f_b == 0.) exit iterate_loop

       ! See if bisection is forced

       if(ABS(e) <  tol .OR. ABS(f_a) < ABS(f_b)) then

          d = m
          e = d

       else

          s = f_b/f_a

          if(a == c) then

             ! Linear interpolation

             p = 2.*m*s
             q = 1. - s

          else

             ! Inverse quadratic interpolation

             q = f_a/f_c
             r = f_b/f_c

             p = s*(2.*m*q*(q - r) - (b - a)*(r - 1.))
             q = (q - 1.)*(r - 1.)*(s - 1.)

          endif

          if(p > 0.) then
             q = -q
          else
             p = -p
          endif

          s = e
          e = d

          if(2.*p < 3.*m*q - ABS(tol*q) .AND. p < ABS(0.5*s*q)) then
             d = p/q
          else
             d = m
             e = d
          endif

       endif

       ! Store the old value of b in a

       a = b
       f_a = f_b

       ! Update b

       b = b + MERGE(d, MERGE(tol, -tol, m > 0), ABS(d) > tol)

       f_b = this%eval(b)

    end do iterate_loop

    if(PRESENT(n_iter)) then
       n_iter = i
    else

    if(.NOT. (i <= n_iter_)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i <= n_iter_'' failed at line 325 <core_func:narrow_bracket_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Too many iterations'
      stop
    endif

    endif

    ! Store the results

    x_a = a
    x_b = b

    if(PRESENT(f_x_a)) f_x_a = f_a
    if(PRESENT(f_x_b)) f_x_b = f_b

    ! Finish

    return

  end subroutine narrow_bracket_

!****

  function root_r_ (this, x_a, x_b, x_tol, f_x_a, f_x_b, n_iter, relative_tol) result (x)

    class(func_t), intent(inout)     :: this
    real(WP), intent(in)             :: x_a
    real(WP), intent(in)             :: x_b
    real(WP), intent(in)             :: x_tol
    real(WP), optional, intent(in)   :: f_x_a
    real(WP), optional, intent(in)   :: f_x_b
    integer, optional, intent(inout) :: n_iter
    logical, optional, intent(in)    :: relative_tol
    real(WP)                         :: x

    real(WP) :: a
    real(WP) :: b
    real(WP) :: f_a
    real(WP) :: f_b

    ! Find a root of the real function this%eval(x)

    a = x_a
    b = x_b

    if(PRESENT(f_x_a)) then
       f_a = f_x_a
    else
       f_a = this%eval(a)
    endif

    if(PRESENT(f_x_b)) then
       f_b = f_x_b
    else
       f_b = this%eval(b)
    endif

    call this%narrow_bracket(a, b, x_tol, f_a, f_b, n_iter, relative_tol)

    x = b

    ! Finish

    return

  end function root_r_

!****

  function root_c_ (this, z_a, z_b, z_tol, f_z_a, f_z_b, n_iter, relative_tol) result (z)

    class(func_t), intent(inout)      :: this
    complex(WP), intent(in)           :: z_a
    complex(WP), intent(in)           :: z_b
    real(WP), intent(in)              :: z_tol
    complex(WP), optional, intent(in) :: f_z_a
    complex(WP), optional, intent(in) :: f_z_b
    integer, optional, intent(inout)  :: n_iter
    logical, optional, intent(in)     :: relative_tol
    complex(WP)                       :: z

    real(WP), parameter :: EPS = EPSILON(0._WP)

    integer     :: n_iter_
    logical     :: relative_tol_
    complex(WP) :: a
    complex(WP) :: b
    complex(WP) :: c
    complex(WP) :: f_a
    complex(WP) :: f_b
    complex(WP) :: f_c
    integer     :: i
    complex(WP) :: f_dz
    complex(WP) :: rho
    real(WP)    :: tol

    if(PRESENT(n_iter)) then
       n_iter_ = n_iter
    else
       n_iter_ = 50
    end if

    if(PRESENT(relative_tol)) then
       relative_tol_ = relative_tol
    else
       relative_tol_ = .FALSE.
    endif

    ! Use the secant method to find a complex root of the function
    ! this%eval(z)

    ! Set up the initial state

    a = z_a
    b = z_b

    if(PRESENT(f_z_a)) then
       f_a = f_z_a
    else
       f_a = this%eval(a)
    endif

    if(PRESENT(f_z_b)) then
       f_b = f_z_b
    else
       f_b = this%eval(b)
    endif

    if(ABS(f_a) < ABS(f_b)) then

       c = a
       a = b
       b = c

       f_c = f_a
       f_a = f_b
       f_b = f_c

    endif

    ! Iterate until the correction drops below the threshold, or the
    ! maximum number of iterations is exceeded

    iterate_loop : do i = 1,n_iter_

       ! Calculate the correction

       f_dz = f_b*(b - a)

       rho = f_b - f_a

       ! Check for a singular correction

       if(ABS(b*rho) < 8._WP*EPS*ABS(f_dz)) then

    write(UNIT=ERROR_UNIT, FMT=*) 'ABORT at line 475 <core_func:root_c_>:'
    write(UNIT=ERROR_UNIT, FMT=*) 'Singular correction in secant'

  stop 'Program aborted'

       endif

       ! Update the root

       a = b
       f_a = f_b

       b = b - f_dz/rho
       f_b = this%eval(b)

       ! Check for convergence

       if(relative_tol_) then
          tol = (4._WP*EPS + z_tol)*ABS(b)
       else
          tol = 4._WP*EPS*ABS(b) + z_tol
       endif

       if((ABS(b - a) <= tol .OR. f_b == 0._WP)) exit iterate_loop

    end do iterate_loop

    if(PRESENT(n_iter)) then
       n_iter = i
    else

    if(.NOT. (i <= n_iter_)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''i <= n_iter_'' failed at line 501 <core_func:root_c_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Too many iterations'
      stop
    endif

    endif

    ! Store the result

    z = b

    ! Finish

  end function root_c_

!****

  function minimum_r_ (this, x_a, x_b, x_c, x_tol, relative_tol) result (x)

    class(func_t), intent(inout)  :: this
    real(WP), intent(in)          :: x_a
    real(WP), intent(in)          :: x_b
    real(WP), intent(in)          :: x_c
    real(WP), intent(in)          :: x_tol
    logical, intent(in), optional :: relative_tol
    real(WP)                      :: x

    ! Find a local minimum of the real function this%eval(x)

    x = extremum_(this, x_a, x_b, x_c, x_tol, .TRUE., relative_tol)

    ! Finish

    return

  end function minimum_r_

!****

  function maximum_r_ (this, x_a, x_b, x_c, x_tol, relative_tol) result (x)

    class(func_t), intent(inout)  :: this
    real(WP), intent(in)          :: x_a
    real(WP), intent(in)          :: x_b
    real(WP), intent(in)          :: x_c
    real(WP), intent(in)          :: x_tol
    logical, intent(in), optional :: relative_tol
    real(WP)                      :: x

    ! Find a local maximum of the real function this%eval(x)

    x = extremum_(this, x_a, x_b, x_c, x_tol, .FALSE., relative_tol)

    ! Finish

    return

  end function maximum_r_

!****

  function extremum_ (rf, x_a, x_b, x_c, x_tol, minimum, relative_tol) result (x)

    class(func_t), intent(inout)  :: rf
    real(WP), intent(in)          :: x_a
    real(WP), intent(in)          :: x_b
    real(WP), intent(in)          :: x_c
    real(WP), intent(in)          :: x_tol
    logical, intent(in)           :: minimum
    logical, intent(in), optional :: relative_tol
    real(WP)                      :: x

    real(WP), parameter :: EPS = EPSILON(0._WP)
    real(WP), parameter :: R = 0.61803399_WP
    real(WP), parameter :: C = 1._WP - R

    logical  :: relative_tol_
    real(WP) :: x_0
    real(WP) :: x_1
    real(WP) :: x_2
    real(WP) :: x_3
    real(WP) :: f_1
    real(WP) :: f_2
    real(WP) :: tol

    if(PRESENT(relative_tol)) then
       relative_tol_ = relative_tol
    else
       relative_tol_ = .FALSE.
    endif

    ! Use a golden section search to find a local extremum of the real
    ! function this%eval(x)

    ! Set up the starting locations

    x_0 = x_a
    x_3 = x_c

    if(ABS(x_c-x_b) > ABS(x_b-x_a)) then
       x_1 = x_b
       x_2 = x_b + C*(x_c-x_b)
    else
       x_2 = x_b
       x_1 = x_b - C*(x_b-x_a)
    end if

    ! Iterate until convergence

    f_1 = rf%eval(x_1)*MERGE(1._WP, -1._WP, minimum)
    f_2 = rf%eval(x_2)*MERGE(1._WP, -1._WP, minimum)

    iterate_loop : do

       ! Check for a converged bracket

       if(relative_tol_) then
          tol = (SQRT(EPS) + 0.5_WP*x_tol)*(ABS(x_1) + ABS(x_2))
       else
          tol = SQRT(EPS)*(ABS(x_1) + ABS(x_2)) + x_tol
       endif

       if (ABS(x_3-x_0) <= tol) exit iterate_loop

       ! Update the bracket

       if (f_2 < f_1) then
          call shft3_(x_0, x_1, x_2, R*x_2+C*x_3)
          call shft2_(f_1, f_2, rf%eval(x_2)*MERGE(1._WP, -1._WP, minimum))
       else
          call shft3_(x_3, x_2, x_1, R*x_1+C*x_0)
          call shft2_(f_2, f_1, rf%eval(x_1)*MERGE(1._WP, -1._WP, minimum))
       end if

    end do iterate_loop

    ! Select the lower point

    if (f_1 < f_2) then
       x = x_1
    else
       x = x_2
    endif

    ! Finish

    return

  contains

    subroutine shft2_ (a, b, c)

      real(WP), intent(out)   :: a
      real(WP), intent(inout) :: b
      real(WP), intent(in)    :: c

      ! Shift b to a and c to b

      a=b
      b=c

      ! Finish

      return

    end subroutine shft2_

    subroutine shft3_ (a, b, c, d)

      real(WP), intent(out)   :: a 
      real(WP), intent(inout) :: b 
      real(WP), intent(inout) :: c
      real(WP), intent(in)    :: d

      ! Shift b to a, c to b and d to c

      a=b
      b=c
      c=d

    end subroutine shft3_

  end function extremum_

end module core_func

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: ISO_FORTRAN_ENV core_kinds
!   provides: core_system
!end dependencies
!
!end fpx3_header
! Module   : core_system
! Purpose  : operating system support

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module core_system

  ! Uses

  use core_kinds

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Interfaces

  interface get_arg
     module procedure get_arg_i_i4_
     module procedure get_arg_i_i8_
     module procedure get_arg_r_sp_
     module procedure get_arg_r_dp_
     module procedure get_arg_c_sp_
     module procedure get_arg_c_dp_
     module procedure get_arg_a_
     module procedure get_arg_l_
  end interface get_arg

  interface get_env
     module procedure get_env_i_i4_
     module procedure get_env_i_i8_
     module procedure get_env_r_sp_
     module procedure get_env_r_dp_
     module procedure get_env_c_sp_
     module procedure get_env_c_dp_
     module procedure get_env_a_
     module procedure get_env_l_
  end interface get_env

  ! Access specifiers

  private

  public :: n_arg
  public :: get_arg
  public :: get_env

contains

  function n_arg ()

    integer :: n_arg

    ! Get the number of arguments

    n_arg = COMMAND_ARGUMENT_COUNT()

    ! Finish

    return

  end function n_arg

!****

  subroutine get_arg_i_i4_ (number, value)

    integer, intent(in)      :: number
    integer(I4), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_i_i4_

  subroutine get_arg_i_i8_ (number, value)

    integer, intent(in)      :: number
    integer(I8), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_i_i8_

  subroutine get_arg_r_sp_ (number, value)

    integer, intent(in)      :: number
    real(SP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_r_sp_

  subroutine get_arg_r_dp_ (number, value)

    integer, intent(in)      :: number
    real(DP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_r_dp_

  subroutine get_arg_c_sp_ (number, value)

    integer, intent(in)      :: number
    complex(SP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_c_sp_

  subroutine get_arg_c_dp_ (number, value)

    integer, intent(in)      :: number
    complex(DP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_c_dp_

  subroutine get_arg_a_ (number, value)

    integer, intent(in)      :: number
    character(*), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_a_

  subroutine get_arg_l_ (number, value)

    integer, intent(in)      :: number
    logical, intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the argument into a character buffer

    call GET_COMMAND_ARGUMENT(number, LENGTH=buffer_len)

    allocate(character(buffer_len)::buffer)

    call GET_COMMAND_ARGUMENT(number, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_arg_l_

!****

  subroutine get_env_i_i4_ (name, value)

    character(*), intent(in) :: name
    integer(I4), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 147 <core_system:get_env_i_i4_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_i_i4_

  subroutine get_env_i_i8_ (name, value)

    character(*), intent(in) :: name
    integer(I8), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 148 <core_system:get_env_i_i8_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_i_i8_

  subroutine get_env_r_sp_ (name, value)

    character(*), intent(in) :: name
    real(SP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 149 <core_system:get_env_r_sp_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_r_sp_

  subroutine get_env_r_dp_ (name, value)

    character(*), intent(in) :: name
    real(DP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 150 <core_system:get_env_r_dp_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_r_dp_

  subroutine get_env_c_sp_ (name, value)

    character(*), intent(in) :: name
    complex(SP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 151 <core_system:get_env_c_sp_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_c_sp_

  subroutine get_env_c_dp_ (name, value)

    character(*), intent(in) :: name
    complex(DP), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 152 <core_system:get_env_c_dp_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_c_dp_

  subroutine get_env_a_ (name, value)

    character(*), intent(in) :: name
    character(*), intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 153 <core_system:get_env_a_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_a_

  subroutine get_env_l_ (name, value)

    character(*), intent(in) :: name
    logical, intent(out) :: value

    integer                   :: buffer_len
    character(:), allocatable :: buffer

    ! Read the environment variable into a character buffer

    call GET_ENVIRONMENT_VARIABLE(name, LENGTH=buffer_len)

    if(.NOT. (buffer_len > 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''buffer_len > 0'' failed at line 154 <core_system:get_env_l_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid environment variable'
      stop
    endif

    allocate(character(buffer_len)::buffer)

    call GET_ENVIRONMENT_VARIABLE(name, buffer)

    ! Extract the value from the buffer

    read(buffer, *) value

    ! Finish

    return

  end subroutine get_env_l_

end module core_system

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: 
!   uses: gyre_c_rot gyre_r_rot
!   provides: gyre_rot
!end dependencies
!
!end fpx3_header
! Module   : gyre_rot
! Purpose  : rotational effects
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module gyre_rot

  ! Uses

  use gyre_r_rot
  use gyre_c_rot

end module gyre_rot

!fpx3_header(0.13_3a)
!
!dependencies
!   dir: ~/devel/gyre-4/src/utils 
!   sources: -
!   includes: ../extern/core/core.inc
!   uses: ISO_FORTRAN_ENV core_hgroup gyre_cheby core_kinds astro_hough
!   provides: gyre_trad_func
!end dependencies
!
!end fpx3_header
! Program  : gyre_trad_func
! Purpose  : traditional approximation functions
!
! Copyright 2013-2014 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

! Incfile  : core
! Purpose  : fpx3 macros

!****

!****

!****

!****

!****

!****

!****

!****

!****

module gyre_trad_func

  ! Uses

  use core_kinds

  use core_hgroup

  use astro_hough

  use gyre_cheby

  use ISO_FORTRAN_ENV

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: trad_func_t
     private
     type(cheby_t)   :: cb_neg
     type(cheby_t)   :: cb_pos
     type(cheby_t)   :: cb_ctr
     integer, public :: m
     integer, public :: k
   contains
     private
     procedure       :: lambda_r_
     procedure       :: lambda_c_
     generic, public :: lambda => lambda_r_, lambda_c_
  end type trad_func_t

  ! Interfaces

  interface trad_func_t
     module procedure trad_func_t_tol_
  end interface trad_func_t

  interface read
     module procedure read_
  end interface read
  interface write
     module procedure write_
  end interface write

  ! Access specifiers

  private

  public :: trad_func_t

  public :: read
  public :: write

  ! Procedures

contains

  function trad_func_t_tol_ (m, k, lambda_tol, cheby_tol, cheby_n) result (tf)

    integer, intent(in)  :: m
    integer, intent(in)  :: k
    real(WP), intent(in) :: lambda_tol
    real(WP), intent(in) :: cheby_tol
    integer, intent(in)  :: cheby_n
    type(trad_func_t)    :: tf

    if(.NOT. (k >= 0)) then
      write(UNIT=ERROR_UNIT, FMT=*) 'ASSERT ''k >= 0'' failed at line 102 <gyre_trad_func:trad_func_t_tol_>:'
      write(UNIT=ERROR_UNIT, FMT=*) 'Invalid k'
      stop
    endif

    ! Construct the trad_func_t with the specified tolerances and
    ! Chebyshev fit order

    tf%m = m
    tf%k = k

    tf%cb_neg = cheby_t(-1._WP, 0._WP, cheby_n, f_outer)
    tf%cb_pos = cheby_t(0._WP , 1._WP, cheby_n, f_outer)
    tf%cb_ctr = cheby_t(-1._WP, 1._WP, cheby_n, f_inner)

    call tf%cb_neg%truncate(cheby_tol)
    call tf%cb_pos%truncate(cheby_tol)
    call tf%cb_ctr%truncate(cheby_tol)

    ! Finish

    return

  contains

    function f_inner (x) 

      real(WP), intent(in) :: x
      real(WP)             :: f_inner

      ! Calculate the eigenvalue function in the inner region

      if (m == 0._WP .AND. k == 0._WP) then

         f_inner = 1._WP

      else

         associate (nu => x)
           f_inner = lambda(nu, m, k, lambda_tol)/lambda_norm_(nu, m, k)
         end associate

      endif

      ! Finish

      return

    end function f_inner

    function f_outer (x)

      real(WP), intent(in) :: x
      real(WP)             :: f_outer

      ! Calculate the eigenvalue function in the outer region

      if (m == 0._WP .AND. k == 0._WP) then

         f_outer = 1._WP

      else

         if (x == 0._WP) then

            f_outer = 1._WP

         else

            associate (nu => 1._WP/x)
              f_outer = lambda(nu, m, k, lambda_tol)/lambda_norm_(nu, m, k)
            end associate

         endif

      endif

      ! Finish

      return

    end function f_outer

  end function trad_func_t_tol_

!****

  subroutine read_ (hg, tf)

    type(hgroup_t), intent(inout)  :: hg
    type(trad_func_t), intent(out) :: tf

    type(hgroup_t) :: hg_comp

    ! Read the trad_func_t

    call read_attr(hg, 'm', tf%m)
    call read_attr(hg, 'k', tf%k)

    hg_comp = hgroup_t(hg, 'cb_neg')
    call read(hg_comp, tf%cb_neg)
    call hg_comp%final()

    hg_comp = hgroup_t(hg, 'cb_pos')
    call read(hg_comp, tf%cb_pos)
    call hg_comp%final()

    hg_comp = hgroup_t(hg, 'cb_ctr')
    call read(hg_comp, tf%cb_ctr)
    call hg_comp%final()

    ! Finish

    return

  end subroutine read_

!****

  subroutine write_ (hg, tf)

    type(hgroup_t), intent(inout) :: hg
    type(trad_func_t), intent(in) :: tf

    type(hgroup_t) :: hg_comp

    ! Write the trad_func_t

    call write_attr(hg, 'm', tf%m)
    call write_attr(hg, 'k', tf%k)

    hg_comp = hgroup_t(hg, 'cb_neg')
    call write(hg_comp, tf%cb_neg)
    call hg_comp%final()

    hg_comp = hgroup_t(hg, 'cb_pos')
    call write(hg_comp, tf%cb_pos)
    call hg_comp%final()

    hg_comp = hgroup_t(hg, 'cb_ctr')
    call write(hg_comp, tf%cb_ctr)
    call hg_comp%final()

    ! Finish

    return

  end subroutine write_

!****

!****

  function lambda_r_ (this, nu) result (lambda)

    class(trad_func_t), intent(in) :: this
    real(WP), intent(in)           :: nu
    real(WP)                       :: lambda

    ! Evaluate the eigenvalue of Laplace's tidal equation (real)

    if (nu < -1._WP) then
       lambda = this%cb_neg%eval(1._WP/nu)*lambda_norm_(nu, this%m, this%k)
    elseif (nu > 1._WP) then
       lambda = this%cb_pos%eval(1._WP/nu)*lambda_norm_(nu, this%m, this%k)
    else
       lambda = this%cb_ctr%eval(nu)*lambda_norm_(nu, this%m, this%k)
    endif

    ! Finish

    return

  end function lambda_r_

!****

  function lambda_c_ (this, nu) result (lambda)

    class(trad_func_t), intent(in) :: this
    complex(WP), intent(in)        :: nu
    complex(WP)                    :: lambda

    ! Evaluate the eigenvalue of Laplace's tidal equation (complex)

    if (REAL(nu) < -1._WP) then
       lambda = this%cb_neg%eval(1._WP/nu)*lambda_norm_(REAL(nu), this%m, this%k)
    elseif (REAL(nu) > 1._WP) then
       lambda = this%cb_pos%eval(1._WP/nu)*lambda_norm_(REAL(nu), this%m, this%k)
    else
       lambda = this%cb_ctr%eval(nu)*lambda_norm_(REAL(nu), this%m, this%k)
    endif

    ! Finish

    return

  end function lambda_c_

!****

  function lambda_norm_ (nu, m, k) result (lambda_norm)

    real(WP), intent(in) :: nu
    integer, intent(in)  :: m
    integer, intent(in)  :: k
    real(WP)             :: lambda_norm

    ! Evaluate the eigenvalue normalization function (used to scale
    ! the Chebychev fits to lambda)

    if (nu < -1._WP) then
       lambda_norm = lambda_asymp(nu, m, k)
    elseif (nu > 1._WP) then
       lambda_norm = lambda_asymp(nu, m, k)
    else
       associate (l => ABS(m) + k)
         lambda_norm = l*(l+1)
       end associate
    end if

    ! Finish

    return

  end function lambda_norm_

end module gyre_trad_func

#!/bin/bash
#
# File     : gyre.sh
# Purpose  : GYRE testing script

. test_support

# Settings

EXEC=./gyre_nad

IN_FILE=gyre_nad.in
OUT_FILE=gyre_nad.txt

LABEL="MESA model for RGB star"

RELERR=4E-12
FIELDS=1-5

# Do the tests

run_gyre $EXEC $IN_FILE "$LABEL"
if [ $? -ne 0 ]; then
    exit 1;
fi

check_output $RELERR $FIELDS $OUT_FILE
if [ $? -ne 0 ]; then
    exit 1;
fi

# Clean up output files

rm -f $OUT_FILE

# Finish

echo " ...succeeded"

#!/bin/bash
#
# File     : gyre.sh
# Purpose  : GYRE testing script

. test_support

# Settings

EXEC=./gyre_ad

IN_FILE_N=gyre_ad.n.in
IN_FILE_1=gyre_ad.1.in

OUT_FILE_N=gyre_ad.n.txt
OUT_FILE_1=gyre_ad.1.txt

FIELDS=1-5

# Do the tests

run_gyre $EXEC $IN_FILE_N "homogeneous compressible model (OpenMP)"
if [ $? -ne 0 ]; then
    exit 1;
fi

export OMP_NUM_THREADS=1

run_gyre $EXEC $IN_FILE_1 ""
if [ $? -ne 0 ]; then
    exit 1;
fi

check_output "" $FIELDS $OUT_FILE_N $OUT_FILE_1
if [ $? -ne 0 ]; then
    exit 1;
fi

# Clean up output files

rm -f $OUT_FILE_N $OUT_FILE_1

# Finish

echo " ...succeeded"
